# -*- coding: utf-8 -*-
# This file is auto-generated, don't edit it. Thanks.
from typing import Dict
from Tea.core import TeaCore

from alibabacloud_tea_openapi.client import Client as OpenApiClient
from alibabacloud_tea_openapi import models as open_api_models
from alibabacloud_tea_util.client import Client as UtilClient
from alibabacloud_endpoint_util.client import Client as EndpointUtilClient
from alibabacloud_adb20211201 import models as adb_20211201_models
from alibabacloud_tea_util import models as util_models
from alibabacloud_openapi_util.client import Client as OpenApiUtilClient


class Client(OpenApiClient):
    """
    *\
    """
    def __init__(
        self, 
        config: open_api_models.Config,
    ):
        super().__init__(config)
        self._endpoint_rule = 'regional'
        self._endpoint_map = {
            'cn-qingdao': 'adb.aliyuncs.com',
            'cn-beijing': 'adb.aliyuncs.com',
            'cn-hangzhou': 'adb.aliyuncs.com',
            'cn-shanghai': 'adb.aliyuncs.com',
            'cn-shenzhen': 'adb.aliyuncs.com',
            'cn-hongkong': 'adb.aliyuncs.com',
            'ap-southeast-1': 'adb.aliyuncs.com',
            'us-west-1': 'adb.aliyuncs.com',
            'us-east-1': 'adb.aliyuncs.com',
            'cn-hangzhou-finance': 'adb.aliyuncs.com',
            'cn-north-2-gov-1': 'adb.aliyuncs.com',
            'ap-northeast-2-pop': 'adb.ap-northeast-1.aliyuncs.com',
            'cn-beijing-finance-1': 'adb.aliyuncs.com',
            'cn-beijing-finance-pop': 'adb.aliyuncs.com',
            'cn-beijing-gov-1': 'adb.aliyuncs.com',
            'cn-beijing-nu16-b01': 'adb.aliyuncs.com',
            'cn-edge-1': 'adb.aliyuncs.com',
            'cn-fujian': 'adb.aliyuncs.com',
            'cn-haidian-cm12-c01': 'adb.aliyuncs.com',
            'cn-hangzhou-bj-b01': 'adb.aliyuncs.com',
            'cn-hangzhou-internal-prod-1': 'adb.aliyuncs.com',
            'cn-hangzhou-internal-test-1': 'adb.aliyuncs.com',
            'cn-hangzhou-internal-test-2': 'adb.aliyuncs.com',
            'cn-hangzhou-internal-test-3': 'adb.aliyuncs.com',
            'cn-hangzhou-test-306': 'adb.aliyuncs.com',
            'cn-hongkong-finance-pop': 'adb.aliyuncs.com',
            'cn-qingdao-nebula': 'adb.aliyuncs.com',
            'cn-shanghai-et15-b01': 'adb.aliyuncs.com',
            'cn-shanghai-et2-b01': 'adb.aliyuncs.com',
            'cn-shanghai-finance-1': 'adb.aliyuncs.com',
            'cn-shanghai-inner': 'adb.aliyuncs.com',
            'cn-shanghai-internal-test-1': 'adb.aliyuncs.com',
            'cn-shenzhen-finance-1': 'adb.aliyuncs.com',
            'cn-shenzhen-inner': 'adb.aliyuncs.com',
            'cn-shenzhen-st4-d01': 'adb.aliyuncs.com',
            'cn-shenzhen-su18-b01': 'adb.aliyuncs.com',
            'cn-wuhan': 'adb.aliyuncs.com',
            'cn-yushanfang': 'adb.aliyuncs.com',
            'cn-zhangbei-na61-b01': 'adb.aliyuncs.com',
            'cn-zhangjiakou-na62-a01': 'adb.aliyuncs.com',
            'cn-zhengzhou-nebula-1': 'adb.aliyuncs.com',
            'eu-west-1-oxs': 'adb.ap-northeast-1.aliyuncs.com',
            'me-east-1': 'adb.ap-northeast-1.aliyuncs.com',
            'rus-west-1-pop': 'adb.ap-northeast-1.aliyuncs.com'
        }
        self.check_config(config)
        self._endpoint = self.get_endpoint('adb', self._region_id, self._endpoint_rule, self._network, self._suffix, self._endpoint_map, self._endpoint)

    def get_endpoint(
        self,
        product_id: str,
        region_id: str,
        endpoint_rule: str,
        network: str,
        suffix: str,
        endpoint_map: Dict[str, str],
        endpoint: str,
    ) -> str:
        if not UtilClient.empty(endpoint):
            return endpoint
        if not UtilClient.is_unset(endpoint_map) and not UtilClient.empty(endpoint_map.get(region_id)):
            return endpoint_map.get(region_id)
        return EndpointUtilClient.get_endpoint_rules(product_id, region_id, endpoint_rule, network, suffix)

    def allocate_cluster_public_connection_with_options(
        self,
        request: adb_20211201_models.AllocateClusterPublicConnectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.AllocateClusterPublicConnectionResponse:
        """
        @summary Applies for a public endpoint for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: AllocateClusterPublicConnectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: AllocateClusterPublicConnectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.connection_string_prefix):
            query['ConnectionStringPrefix'] = request.connection_string_prefix
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='AllocateClusterPublicConnection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.AllocateClusterPublicConnectionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.AllocateClusterPublicConnectionResponse(),
                self.execute(params, req, runtime)
            )

    async def allocate_cluster_public_connection_with_options_async(
        self,
        request: adb_20211201_models.AllocateClusterPublicConnectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.AllocateClusterPublicConnectionResponse:
        """
        @summary Applies for a public endpoint for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: AllocateClusterPublicConnectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: AllocateClusterPublicConnectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.connection_string_prefix):
            query['ConnectionStringPrefix'] = request.connection_string_prefix
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='AllocateClusterPublicConnection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.AllocateClusterPublicConnectionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.AllocateClusterPublicConnectionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def allocate_cluster_public_connection(
        self,
        request: adb_20211201_models.AllocateClusterPublicConnectionRequest,
    ) -> adb_20211201_models.AllocateClusterPublicConnectionResponse:
        """
        @summary Applies for a public endpoint for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: AllocateClusterPublicConnectionRequest
        @return: AllocateClusterPublicConnectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.allocate_cluster_public_connection_with_options(request, runtime)

    async def allocate_cluster_public_connection_async(
        self,
        request: adb_20211201_models.AllocateClusterPublicConnectionRequest,
    ) -> adb_20211201_models.AllocateClusterPublicConnectionResponse:
        """
        @summary Applies for a public endpoint for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: AllocateClusterPublicConnectionRequest
        @return: AllocateClusterPublicConnectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.allocate_cluster_public_connection_with_options_async(request, runtime)

    def apply_advice_by_id_with_options(
        self,
        request: adb_20211201_models.ApplyAdviceByIdRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ApplyAdviceByIdResponse:
        """
        @summary Applies an optimization suggestion.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ApplyAdviceByIdRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ApplyAdviceByIdResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.advice_date):
            query['AdviceDate'] = request.advice_date
        if not UtilClient.is_unset(request.advice_id):
            query['AdviceId'] = request.advice_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ApplyAdviceById',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ApplyAdviceByIdResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ApplyAdviceByIdResponse(),
                self.execute(params, req, runtime)
            )

    async def apply_advice_by_id_with_options_async(
        self,
        request: adb_20211201_models.ApplyAdviceByIdRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ApplyAdviceByIdResponse:
        """
        @summary Applies an optimization suggestion.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ApplyAdviceByIdRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ApplyAdviceByIdResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.advice_date):
            query['AdviceDate'] = request.advice_date
        if not UtilClient.is_unset(request.advice_id):
            query['AdviceId'] = request.advice_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ApplyAdviceById',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ApplyAdviceByIdResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ApplyAdviceByIdResponse(),
                await self.execute_async(params, req, runtime)
            )

    def apply_advice_by_id(
        self,
        request: adb_20211201_models.ApplyAdviceByIdRequest,
    ) -> adb_20211201_models.ApplyAdviceByIdResponse:
        """
        @summary Applies an optimization suggestion.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ApplyAdviceByIdRequest
        @return: ApplyAdviceByIdResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.apply_advice_by_id_with_options(request, runtime)

    async def apply_advice_by_id_async(
        self,
        request: adb_20211201_models.ApplyAdviceByIdRequest,
    ) -> adb_20211201_models.ApplyAdviceByIdResponse:
        """
        @summary Applies an optimization suggestion.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ApplyAdviceByIdRequest
        @return: ApplyAdviceByIdResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.apply_advice_by_id_with_options_async(request, runtime)

    def attach_user_eniwith_options(
        self,
        request: adb_20211201_models.AttachUserENIRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.AttachUserENIResponse:
        """
        @summary Attaches an elastic network interface (ENI) to an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: AttachUserENIRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: AttachUserENIResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='AttachUserENI',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.AttachUserENIResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.AttachUserENIResponse(),
                self.execute(params, req, runtime)
            )

    async def attach_user_eniwith_options_async(
        self,
        request: adb_20211201_models.AttachUserENIRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.AttachUserENIResponse:
        """
        @summary Attaches an elastic network interface (ENI) to an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: AttachUserENIRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: AttachUserENIResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='AttachUserENI',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.AttachUserENIResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.AttachUserENIResponse(),
                await self.execute_async(params, req, runtime)
            )

    def attach_user_eni(
        self,
        request: adb_20211201_models.AttachUserENIRequest,
    ) -> adb_20211201_models.AttachUserENIResponse:
        """
        @summary Attaches an elastic network interface (ENI) to an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: AttachUserENIRequest
        @return: AttachUserENIResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.attach_user_eniwith_options(request, runtime)

    async def attach_user_eni_async(
        self,
        request: adb_20211201_models.AttachUserENIRequest,
    ) -> adb_20211201_models.AttachUserENIResponse:
        """
        @summary Attaches an elastic network interface (ENI) to an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: AttachUserENIRequest
        @return: AttachUserENIResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.attach_user_eniwith_options_async(request, runtime)

    def batch_apply_advice_by_id_list_with_options(
        self,
        request: adb_20211201_models.BatchApplyAdviceByIdListRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.BatchApplyAdviceByIdListResponse:
        """
        @summary The request ID.
        
        @param request: BatchApplyAdviceByIdListRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: BatchApplyAdviceByIdListResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.advice_date):
            query['AdviceDate'] = request.advice_date
        if not UtilClient.is_unset(request.advice_id_list):
            query['AdviceIdList'] = request.advice_id_list
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='BatchApplyAdviceByIdList',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.BatchApplyAdviceByIdListResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.BatchApplyAdviceByIdListResponse(),
                self.execute(params, req, runtime)
            )

    async def batch_apply_advice_by_id_list_with_options_async(
        self,
        request: adb_20211201_models.BatchApplyAdviceByIdListRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.BatchApplyAdviceByIdListResponse:
        """
        @summary The request ID.
        
        @param request: BatchApplyAdviceByIdListRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: BatchApplyAdviceByIdListResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.advice_date):
            query['AdviceDate'] = request.advice_date
        if not UtilClient.is_unset(request.advice_id_list):
            query['AdviceIdList'] = request.advice_id_list
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='BatchApplyAdviceByIdList',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.BatchApplyAdviceByIdListResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.BatchApplyAdviceByIdListResponse(),
                await self.execute_async(params, req, runtime)
            )

    def batch_apply_advice_by_id_list(
        self,
        request: adb_20211201_models.BatchApplyAdviceByIdListRequest,
    ) -> adb_20211201_models.BatchApplyAdviceByIdListResponse:
        """
        @summary The request ID.
        
        @param request: BatchApplyAdviceByIdListRequest
        @return: BatchApplyAdviceByIdListResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.batch_apply_advice_by_id_list_with_options(request, runtime)

    async def batch_apply_advice_by_id_list_async(
        self,
        request: adb_20211201_models.BatchApplyAdviceByIdListRequest,
    ) -> adb_20211201_models.BatchApplyAdviceByIdListResponse:
        """
        @summary The request ID.
        
        @param request: BatchApplyAdviceByIdListRequest
        @return: BatchApplyAdviceByIdListResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.batch_apply_advice_by_id_list_with_options_async(request, runtime)

    def bind_account_with_options(
        self,
        request: adb_20211201_models.BindAccountRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.BindAccountResponse:
        """
        @summary Associates a standard account of an AnalyticDB for MySQL cluster with a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: BindAccountRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: BindAccountResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.ram_user):
            query['RamUser'] = request.ram_user
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='BindAccount',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.BindAccountResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.BindAccountResponse(),
                self.execute(params, req, runtime)
            )

    async def bind_account_with_options_async(
        self,
        request: adb_20211201_models.BindAccountRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.BindAccountResponse:
        """
        @summary Associates a standard account of an AnalyticDB for MySQL cluster with a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: BindAccountRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: BindAccountResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.ram_user):
            query['RamUser'] = request.ram_user
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='BindAccount',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.BindAccountResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.BindAccountResponse(),
                await self.execute_async(params, req, runtime)
            )

    def bind_account(
        self,
        request: adb_20211201_models.BindAccountRequest,
    ) -> adb_20211201_models.BindAccountResponse:
        """
        @summary Associates a standard account of an AnalyticDB for MySQL cluster with a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: BindAccountRequest
        @return: BindAccountResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.bind_account_with_options(request, runtime)

    async def bind_account_async(
        self,
        request: adb_20211201_models.BindAccountRequest,
    ) -> adb_20211201_models.BindAccountResponse:
        """
        @summary Associates a standard account of an AnalyticDB for MySQL cluster with a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: BindAccountRequest
        @return: BindAccountResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.bind_account_with_options_async(request, runtime)

    def bind_dbresource_group_with_user_with_options(
        self,
        request: adb_20211201_models.BindDBResourceGroupWithUserRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.BindDBResourceGroupWithUserResponse:
        """
        @summary Associates a resource group with a database account.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: BindDBResourceGroupWithUserRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: BindDBResourceGroupWithUserResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        if not UtilClient.is_unset(request.group_user):
            query['GroupUser'] = request.group_user
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='BindDBResourceGroupWithUser',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.BindDBResourceGroupWithUserResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.BindDBResourceGroupWithUserResponse(),
                self.execute(params, req, runtime)
            )

    async def bind_dbresource_group_with_user_with_options_async(
        self,
        request: adb_20211201_models.BindDBResourceGroupWithUserRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.BindDBResourceGroupWithUserResponse:
        """
        @summary Associates a resource group with a database account.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: BindDBResourceGroupWithUserRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: BindDBResourceGroupWithUserResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        if not UtilClient.is_unset(request.group_user):
            query['GroupUser'] = request.group_user
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='BindDBResourceGroupWithUser',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.BindDBResourceGroupWithUserResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.BindDBResourceGroupWithUserResponse(),
                await self.execute_async(params, req, runtime)
            )

    def bind_dbresource_group_with_user(
        self,
        request: adb_20211201_models.BindDBResourceGroupWithUserRequest,
    ) -> adb_20211201_models.BindDBResourceGroupWithUserResponse:
        """
        @summary Associates a resource group with a database account.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: BindDBResourceGroupWithUserRequest
        @return: BindDBResourceGroupWithUserResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.bind_dbresource_group_with_user_with_options(request, runtime)

    async def bind_dbresource_group_with_user_async(
        self,
        request: adb_20211201_models.BindDBResourceGroupWithUserRequest,
    ) -> adb_20211201_models.BindDBResourceGroupWithUserResponse:
        """
        @summary Associates a resource group with a database account.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: BindDBResourceGroupWithUserRequest
        @return: BindDBResourceGroupWithUserResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.bind_dbresource_group_with_user_with_options_async(request, runtime)

    def cancel_spark_repl_statement_with_options(
        self,
        request: adb_20211201_models.CancelSparkReplStatementRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CancelSparkReplStatementResponse:
        """
        @summary Terminates part of the code in a Spark job.
        
        @param request: CancelSparkReplStatementRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CancelSparkReplStatementResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        if not UtilClient.is_unset(request.session_id):
            body['SessionId'] = request.session_id
        if not UtilClient.is_unset(request.statement_id):
            body['StatementId'] = request.statement_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CancelSparkReplStatement',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CancelSparkReplStatementResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CancelSparkReplStatementResponse(),
                self.execute(params, req, runtime)
            )

    async def cancel_spark_repl_statement_with_options_async(
        self,
        request: adb_20211201_models.CancelSparkReplStatementRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CancelSparkReplStatementResponse:
        """
        @summary Terminates part of the code in a Spark job.
        
        @param request: CancelSparkReplStatementRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CancelSparkReplStatementResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        if not UtilClient.is_unset(request.session_id):
            body['SessionId'] = request.session_id
        if not UtilClient.is_unset(request.statement_id):
            body['StatementId'] = request.statement_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CancelSparkReplStatement',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CancelSparkReplStatementResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CancelSparkReplStatementResponse(),
                await self.execute_async(params, req, runtime)
            )

    def cancel_spark_repl_statement(
        self,
        request: adb_20211201_models.CancelSparkReplStatementRequest,
    ) -> adb_20211201_models.CancelSparkReplStatementResponse:
        """
        @summary Terminates part of the code in a Spark job.
        
        @param request: CancelSparkReplStatementRequest
        @return: CancelSparkReplStatementResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.cancel_spark_repl_statement_with_options(request, runtime)

    async def cancel_spark_repl_statement_async(
        self,
        request: adb_20211201_models.CancelSparkReplStatementRequest,
    ) -> adb_20211201_models.CancelSparkReplStatementResponse:
        """
        @summary Terminates part of the code in a Spark job.
        
        @param request: CancelSparkReplStatementRequest
        @return: CancelSparkReplStatementResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.cancel_spark_repl_statement_with_options_async(request, runtime)

    def cancel_spark_warehouse_batch_sqlwith_options(
        self,
        request: adb_20211201_models.CancelSparkWarehouseBatchSQLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CancelSparkWarehouseBatchSQLResponse:
        """
        @summary 取消一段Spark Batch SQL的状态
        
        @param request: CancelSparkWarehouseBatchSQLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CancelSparkWarehouseBatchSQLResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.agency):
            body['Agency'] = request.agency
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.query_id):
            body['QueryId'] = request.query_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CancelSparkWarehouseBatchSQL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CancelSparkWarehouseBatchSQLResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CancelSparkWarehouseBatchSQLResponse(),
                self.execute(params, req, runtime)
            )

    async def cancel_spark_warehouse_batch_sqlwith_options_async(
        self,
        request: adb_20211201_models.CancelSparkWarehouseBatchSQLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CancelSparkWarehouseBatchSQLResponse:
        """
        @summary 取消一段Spark Batch SQL的状态
        
        @param request: CancelSparkWarehouseBatchSQLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CancelSparkWarehouseBatchSQLResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.agency):
            body['Agency'] = request.agency
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.query_id):
            body['QueryId'] = request.query_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CancelSparkWarehouseBatchSQL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CancelSparkWarehouseBatchSQLResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CancelSparkWarehouseBatchSQLResponse(),
                await self.execute_async(params, req, runtime)
            )

    def cancel_spark_warehouse_batch_sql(
        self,
        request: adb_20211201_models.CancelSparkWarehouseBatchSQLRequest,
    ) -> adb_20211201_models.CancelSparkWarehouseBatchSQLResponse:
        """
        @summary 取消一段Spark Batch SQL的状态
        
        @param request: CancelSparkWarehouseBatchSQLRequest
        @return: CancelSparkWarehouseBatchSQLResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.cancel_spark_warehouse_batch_sqlwith_options(request, runtime)

    async def cancel_spark_warehouse_batch_sql_async(
        self,
        request: adb_20211201_models.CancelSparkWarehouseBatchSQLRequest,
    ) -> adb_20211201_models.CancelSparkWarehouseBatchSQLResponse:
        """
        @summary 取消一段Spark Batch SQL的状态
        
        @param request: CancelSparkWarehouseBatchSQLRequest
        @return: CancelSparkWarehouseBatchSQLResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.cancel_spark_warehouse_batch_sqlwith_options_async(request, runtime)

    def check_bind_ram_user_with_options(
        self,
        request: adb_20211201_models.CheckBindRamUserRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CheckBindRamUserResponse:
        """
        @summary Queries whether a database account of an AnalyticDB for MySQL cluster is associated with a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CheckBindRamUserRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CheckBindRamUserResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CheckBindRamUser',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CheckBindRamUserResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CheckBindRamUserResponse(),
                self.execute(params, req, runtime)
            )

    async def check_bind_ram_user_with_options_async(
        self,
        request: adb_20211201_models.CheckBindRamUserRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CheckBindRamUserResponse:
        """
        @summary Queries whether a database account of an AnalyticDB for MySQL cluster is associated with a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CheckBindRamUserRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CheckBindRamUserResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CheckBindRamUser',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CheckBindRamUserResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CheckBindRamUserResponse(),
                await self.execute_async(params, req, runtime)
            )

    def check_bind_ram_user(
        self,
        request: adb_20211201_models.CheckBindRamUserRequest,
    ) -> adb_20211201_models.CheckBindRamUserResponse:
        """
        @summary Queries whether a database account of an AnalyticDB for MySQL cluster is associated with a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CheckBindRamUserRequest
        @return: CheckBindRamUserResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.check_bind_ram_user_with_options(request, runtime)

    async def check_bind_ram_user_async(
        self,
        request: adb_20211201_models.CheckBindRamUserRequest,
    ) -> adb_20211201_models.CheckBindRamUserResponse:
        """
        @summary Queries whether a database account of an AnalyticDB for MySQL cluster is associated with a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CheckBindRamUserRequest
        @return: CheckBindRamUserResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.check_bind_ram_user_with_options_async(request, runtime)

    def check_sample_data_set_with_options(
        self,
        request: adb_20211201_models.CheckSampleDataSetRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CheckSampleDataSetResponse:
        """
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CheckSampleDataSetRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CheckSampleDataSetResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CheckSampleDataSet',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CheckSampleDataSetResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CheckSampleDataSetResponse(),
                self.execute(params, req, runtime)
            )

    async def check_sample_data_set_with_options_async(
        self,
        request: adb_20211201_models.CheckSampleDataSetRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CheckSampleDataSetResponse:
        """
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CheckSampleDataSetRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CheckSampleDataSetResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CheckSampleDataSet',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CheckSampleDataSetResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CheckSampleDataSetResponse(),
                await self.execute_async(params, req, runtime)
            )

    def check_sample_data_set(
        self,
        request: adb_20211201_models.CheckSampleDataSetRequest,
    ) -> adb_20211201_models.CheckSampleDataSetResponse:
        """
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CheckSampleDataSetRequest
        @return: CheckSampleDataSetResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.check_sample_data_set_with_options(request, runtime)

    async def check_sample_data_set_async(
        self,
        request: adb_20211201_models.CheckSampleDataSetRequest,
    ) -> adb_20211201_models.CheckSampleDataSetResponse:
        """
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CheckSampleDataSetRequest
        @return: CheckSampleDataSetResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.check_sample_data_set_with_options_async(request, runtime)

    def create_apsjob_with_options(
        self,
        request: adb_20211201_models.CreateAPSJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateAPSJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateAPSJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateAPSJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_name):
            body['ApsJobName'] = request.aps_job_name
        if not UtilClient.is_unset(request.db_list):
            body['DbList'] = request.db_list
        if not UtilClient.is_unset(request.destination_endpoint_instance_id):
            body['DestinationEndpointInstanceID'] = request.destination_endpoint_instance_id
        if not UtilClient.is_unset(request.destination_endpoint_password):
            body['DestinationEndpointPassword'] = request.destination_endpoint_password
        if not UtilClient.is_unset(request.destination_endpoint_user_name):
            body['DestinationEndpointUserName'] = request.destination_endpoint_user_name
        if not UtilClient.is_unset(request.partition_list):
            body['PartitionList'] = request.partition_list
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.source_endpoint_instance_id):
            body['SourceEndpointInstanceID'] = request.source_endpoint_instance_id
        if not UtilClient.is_unset(request.source_endpoint_password):
            body['SourceEndpointPassword'] = request.source_endpoint_password
        if not UtilClient.is_unset(request.source_endpoint_region):
            body['SourceEndpointRegion'] = request.source_endpoint_region
        if not UtilClient.is_unset(request.source_endpoint_user_name):
            body['SourceEndpointUserName'] = request.source_endpoint_user_name
        if not UtilClient.is_unset(request.target_table_mode):
            body['TargetTableMode'] = request.target_table_mode
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateAPSJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateAPSJobResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateAPSJobResponse(),
                self.execute(params, req, runtime)
            )

    async def create_apsjob_with_options_async(
        self,
        request: adb_20211201_models.CreateAPSJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateAPSJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateAPSJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateAPSJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_name):
            body['ApsJobName'] = request.aps_job_name
        if not UtilClient.is_unset(request.db_list):
            body['DbList'] = request.db_list
        if not UtilClient.is_unset(request.destination_endpoint_instance_id):
            body['DestinationEndpointInstanceID'] = request.destination_endpoint_instance_id
        if not UtilClient.is_unset(request.destination_endpoint_password):
            body['DestinationEndpointPassword'] = request.destination_endpoint_password
        if not UtilClient.is_unset(request.destination_endpoint_user_name):
            body['DestinationEndpointUserName'] = request.destination_endpoint_user_name
        if not UtilClient.is_unset(request.partition_list):
            body['PartitionList'] = request.partition_list
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.source_endpoint_instance_id):
            body['SourceEndpointInstanceID'] = request.source_endpoint_instance_id
        if not UtilClient.is_unset(request.source_endpoint_password):
            body['SourceEndpointPassword'] = request.source_endpoint_password
        if not UtilClient.is_unset(request.source_endpoint_region):
            body['SourceEndpointRegion'] = request.source_endpoint_region
        if not UtilClient.is_unset(request.source_endpoint_user_name):
            body['SourceEndpointUserName'] = request.source_endpoint_user_name
        if not UtilClient.is_unset(request.target_table_mode):
            body['TargetTableMode'] = request.target_table_mode
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateAPSJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateAPSJobResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateAPSJobResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_apsjob(
        self,
        request: adb_20211201_models.CreateAPSJobRequest,
    ) -> adb_20211201_models.CreateAPSJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateAPSJobRequest
        @return: CreateAPSJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_apsjob_with_options(request, runtime)

    async def create_apsjob_async(
        self,
        request: adb_20211201_models.CreateAPSJobRequest,
    ) -> adb_20211201_models.CreateAPSJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateAPSJobRequest
        @return: CreateAPSJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_apsjob_with_options_async(request, runtime)

    def create_account_with_options(
        self,
        request: adb_20211201_models.CreateAccountRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateAccountResponse:
        """
        @summary Creates a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateAccountRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateAccountResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_description):
            query['AccountDescription'] = request.account_description
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.account_password):
            query['AccountPassword'] = request.account_password
        if not UtilClient.is_unset(request.account_type):
            query['AccountType'] = request.account_type
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CreateAccount',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateAccountResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateAccountResponse(),
                self.execute(params, req, runtime)
            )

    async def create_account_with_options_async(
        self,
        request: adb_20211201_models.CreateAccountRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateAccountResponse:
        """
        @summary Creates a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateAccountRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateAccountResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_description):
            query['AccountDescription'] = request.account_description
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.account_password):
            query['AccountPassword'] = request.account_password
        if not UtilClient.is_unset(request.account_type):
            query['AccountType'] = request.account_type
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CreateAccount',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateAccountResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateAccountResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_account(
        self,
        request: adb_20211201_models.CreateAccountRequest,
    ) -> adb_20211201_models.CreateAccountResponse:
        """
        @summary Creates a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateAccountRequest
        @return: CreateAccountResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_account_with_options(request, runtime)

    async def create_account_async(
        self,
        request: adb_20211201_models.CreateAccountRequest,
    ) -> adb_20211201_models.CreateAccountResponse:
        """
        @summary Creates a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateAccountRequest
        @return: CreateAccountResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_account_with_options_async(request, runtime)

    def create_aps_copy_workload_with_options(
        self,
        request: adb_20211201_models.CreateApsCopyWorkloadRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateApsCopyWorkloadResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) replication job.
        
        @param request: CreateApsCopyWorkloadRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateApsCopyWorkloadResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.db_name):
            body['DbName'] = request.db_name
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.table_name):
            body['TableName'] = request.table_name
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        if not UtilClient.is_unset(request.workload_type):
            body['WorkloadType'] = request.workload_type
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateApsCopyWorkload',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateApsCopyWorkloadResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateApsCopyWorkloadResponse(),
                self.execute(params, req, runtime)
            )

    async def create_aps_copy_workload_with_options_async(
        self,
        request: adb_20211201_models.CreateApsCopyWorkloadRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateApsCopyWorkloadResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) replication job.
        
        @param request: CreateApsCopyWorkloadRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateApsCopyWorkloadResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.db_name):
            body['DbName'] = request.db_name
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.table_name):
            body['TableName'] = request.table_name
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        if not UtilClient.is_unset(request.workload_type):
            body['WorkloadType'] = request.workload_type
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateApsCopyWorkload',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateApsCopyWorkloadResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateApsCopyWorkloadResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_aps_copy_workload(
        self,
        request: adb_20211201_models.CreateApsCopyWorkloadRequest,
    ) -> adb_20211201_models.CreateApsCopyWorkloadResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) replication job.
        
        @param request: CreateApsCopyWorkloadRequest
        @return: CreateApsCopyWorkloadResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_aps_copy_workload_with_options(request, runtime)

    async def create_aps_copy_workload_async(
        self,
        request: adb_20211201_models.CreateApsCopyWorkloadRequest,
    ) -> adb_20211201_models.CreateApsCopyWorkloadResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) replication job.
        
        @param request: CreateApsCopyWorkloadRequest
        @return: CreateApsCopyWorkloadResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_aps_copy_workload_with_options_async(request, runtime)

    def create_aps_datasoure_with_options(
        self,
        tmp_req: adb_20211201_models.CreateApsDatasoureRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateApsDatasoureResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param tmp_req: CreateApsDatasoureRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateApsDatasoureResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.CreateApsDatasoureShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.databricks_info):
            request.databricks_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.databricks_info, 'DatabricksInfo', 'json')
        if not UtilClient.is_unset(tmp_req.hive_info):
            request.hive_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.hive_info, 'HiveInfo', 'json')
        if not UtilClient.is_unset(tmp_req.kafka_info):
            request.kafka_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.kafka_info, 'KafkaInfo', 'json')
        if not UtilClient.is_unset(tmp_req.polar_dbmysql_info):
            request.polar_dbmysql_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.polar_dbmysql_info, 'PolarDBMysqlInfo', 'json')
        if not UtilClient.is_unset(tmp_req.polar_dbxinfo):
            request.polar_dbxinfo_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.polar_dbxinfo, 'PolarDBXInfo', 'json')
        if not UtilClient.is_unset(tmp_req.rds_mysql_info):
            request.rds_mysql_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.rds_mysql_info, 'RdsMysqlInfo', 'json')
        if not UtilClient.is_unset(tmp_req.sls_info):
            request.sls_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.sls_info, 'SlsInfo', 'json')
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.databricks_info_shrink):
            body['DatabricksInfo'] = request.databricks_info_shrink
        if not UtilClient.is_unset(request.datasource_description):
            body['DatasourceDescription'] = request.datasource_description
        if not UtilClient.is_unset(request.datasource_name):
            body['DatasourceName'] = request.datasource_name
        if not UtilClient.is_unset(request.datasource_type):
            body['DatasourceType'] = request.datasource_type
        if not UtilClient.is_unset(request.hive_info_shrink):
            body['HiveInfo'] = request.hive_info_shrink
        if not UtilClient.is_unset(request.kafka_info_shrink):
            body['KafkaInfo'] = request.kafka_info_shrink
        if not UtilClient.is_unset(request.mode):
            body['Mode'] = request.mode
        if not UtilClient.is_unset(request.polar_dbmysql_info_shrink):
            body['PolarDBMysqlInfo'] = request.polar_dbmysql_info_shrink
        if not UtilClient.is_unset(request.polar_dbxinfo_shrink):
            body['PolarDBXInfo'] = request.polar_dbxinfo_shrink
        if not UtilClient.is_unset(request.rds_mysql_info_shrink):
            body['RdsMysqlInfo'] = request.rds_mysql_info_shrink
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.sls_info_shrink):
            body['SlsInfo'] = request.sls_info_shrink
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateApsDatasoure',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateApsDatasoureResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateApsDatasoureResponse(),
                self.execute(params, req, runtime)
            )

    async def create_aps_datasoure_with_options_async(
        self,
        tmp_req: adb_20211201_models.CreateApsDatasoureRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateApsDatasoureResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param tmp_req: CreateApsDatasoureRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateApsDatasoureResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.CreateApsDatasoureShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.databricks_info):
            request.databricks_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.databricks_info, 'DatabricksInfo', 'json')
        if not UtilClient.is_unset(tmp_req.hive_info):
            request.hive_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.hive_info, 'HiveInfo', 'json')
        if not UtilClient.is_unset(tmp_req.kafka_info):
            request.kafka_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.kafka_info, 'KafkaInfo', 'json')
        if not UtilClient.is_unset(tmp_req.polar_dbmysql_info):
            request.polar_dbmysql_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.polar_dbmysql_info, 'PolarDBMysqlInfo', 'json')
        if not UtilClient.is_unset(tmp_req.polar_dbxinfo):
            request.polar_dbxinfo_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.polar_dbxinfo, 'PolarDBXInfo', 'json')
        if not UtilClient.is_unset(tmp_req.rds_mysql_info):
            request.rds_mysql_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.rds_mysql_info, 'RdsMysqlInfo', 'json')
        if not UtilClient.is_unset(tmp_req.sls_info):
            request.sls_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.sls_info, 'SlsInfo', 'json')
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.databricks_info_shrink):
            body['DatabricksInfo'] = request.databricks_info_shrink
        if not UtilClient.is_unset(request.datasource_description):
            body['DatasourceDescription'] = request.datasource_description
        if not UtilClient.is_unset(request.datasource_name):
            body['DatasourceName'] = request.datasource_name
        if not UtilClient.is_unset(request.datasource_type):
            body['DatasourceType'] = request.datasource_type
        if not UtilClient.is_unset(request.hive_info_shrink):
            body['HiveInfo'] = request.hive_info_shrink
        if not UtilClient.is_unset(request.kafka_info_shrink):
            body['KafkaInfo'] = request.kafka_info_shrink
        if not UtilClient.is_unset(request.mode):
            body['Mode'] = request.mode
        if not UtilClient.is_unset(request.polar_dbmysql_info_shrink):
            body['PolarDBMysqlInfo'] = request.polar_dbmysql_info_shrink
        if not UtilClient.is_unset(request.polar_dbxinfo_shrink):
            body['PolarDBXInfo'] = request.polar_dbxinfo_shrink
        if not UtilClient.is_unset(request.rds_mysql_info_shrink):
            body['RdsMysqlInfo'] = request.rds_mysql_info_shrink
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.sls_info_shrink):
            body['SlsInfo'] = request.sls_info_shrink
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateApsDatasoure',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateApsDatasoureResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateApsDatasoureResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_aps_datasoure(
        self,
        request: adb_20211201_models.CreateApsDatasoureRequest,
    ) -> adb_20211201_models.CreateApsDatasoureResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateApsDatasoureRequest
        @return: CreateApsDatasoureResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_aps_datasoure_with_options(request, runtime)

    async def create_aps_datasoure_async(
        self,
        request: adb_20211201_models.CreateApsDatasoureRequest,
    ) -> adb_20211201_models.CreateApsDatasoureResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateApsDatasoureRequest
        @return: CreateApsDatasoureResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_aps_datasoure_with_options_async(request, runtime)

    def create_aps_hive_job_with_options(
        self,
        request: adb_20211201_models.CreateApsHiveJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateApsHiveJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job from a Hive data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateApsHiveJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateApsHiveJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.advanced_config):
            body['AdvancedConfig'] = request.advanced_config
        if not UtilClient.is_unset(request.conflict_strategy):
            body['ConflictStrategy'] = request.conflict_strategy
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.full_compute_unit):
            body['FullComputeUnit'] = request.full_compute_unit
        if not UtilClient.is_unset(request.oss_location):
            body['OssLocation'] = request.oss_location
        if not UtilClient.is_unset(request.parallelism):
            body['Parallelism'] = request.parallelism
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            body['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.sync_allow_expression):
            body['SyncAllowExpression'] = request.sync_allow_expression
        if not UtilClient.is_unset(request.sync_deny_expression):
            body['SyncDenyExpression'] = request.sync_deny_expression
        if not UtilClient.is_unset(request.target_type):
            body['TargetType'] = request.target_type
        if not UtilClient.is_unset(request.workload_name):
            body['WorkloadName'] = request.workload_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateApsHiveJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateApsHiveJobResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateApsHiveJobResponse(),
                self.execute(params, req, runtime)
            )

    async def create_aps_hive_job_with_options_async(
        self,
        request: adb_20211201_models.CreateApsHiveJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateApsHiveJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job from a Hive data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateApsHiveJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateApsHiveJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.advanced_config):
            body['AdvancedConfig'] = request.advanced_config
        if not UtilClient.is_unset(request.conflict_strategy):
            body['ConflictStrategy'] = request.conflict_strategy
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.full_compute_unit):
            body['FullComputeUnit'] = request.full_compute_unit
        if not UtilClient.is_unset(request.oss_location):
            body['OssLocation'] = request.oss_location
        if not UtilClient.is_unset(request.parallelism):
            body['Parallelism'] = request.parallelism
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            body['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.sync_allow_expression):
            body['SyncAllowExpression'] = request.sync_allow_expression
        if not UtilClient.is_unset(request.sync_deny_expression):
            body['SyncDenyExpression'] = request.sync_deny_expression
        if not UtilClient.is_unset(request.target_type):
            body['TargetType'] = request.target_type
        if not UtilClient.is_unset(request.workload_name):
            body['WorkloadName'] = request.workload_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateApsHiveJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateApsHiveJobResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateApsHiveJobResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_aps_hive_job(
        self,
        request: adb_20211201_models.CreateApsHiveJobRequest,
    ) -> adb_20211201_models.CreateApsHiveJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job from a Hive data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateApsHiveJobRequest
        @return: CreateApsHiveJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_aps_hive_job_with_options(request, runtime)

    async def create_aps_hive_job_async(
        self,
        request: adb_20211201_models.CreateApsHiveJobRequest,
    ) -> adb_20211201_models.CreateApsHiveJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job from a Hive data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateApsHiveJobRequest
        @return: CreateApsHiveJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_aps_hive_job_with_options_async(request, runtime)

    def create_aps_sls_adbjob_with_options(
        self,
        tmp_req: adb_20211201_models.CreateApsSlsADBJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateApsSlsADBJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job from Simple Log Service (SLS) to an AnalyticDB for MySQL Data Warehouse Edition cluster.
        
        @param tmp_req: CreateApsSlsADBJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateApsSlsADBJobResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.CreateApsSlsADBJobShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.columns):
            request.columns_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.columns, 'Columns', 'json')
        if not UtilClient.is_unset(tmp_req.partition_specs):
            request.partition_specs_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.partition_specs, 'PartitionSpecs', 'json')
        if not UtilClient.is_unset(tmp_req.unix_timestamp_convert):
            request.unix_timestamp_convert_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.unix_timestamp_convert, 'UnixTimestampConvert', 'json')
        body = {}
        if not UtilClient.is_unset(request.across_role):
            body['AcrossRole'] = request.across_role
        if not UtilClient.is_unset(request.across_uid):
            body['AcrossUid'] = request.across_uid
        if not UtilClient.is_unset(request.advanced_config):
            body['AdvancedConfig'] = request.advanced_config
        if not UtilClient.is_unset(request.columns_shrink):
            body['Columns'] = request.columns_shrink
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.db_name):
            body['DbName'] = request.db_name
        if not UtilClient.is_unset(request.dirty_data_handle_mode):
            body['DirtyDataHandleMode'] = request.dirty_data_handle_mode
        if not UtilClient.is_unset(request.dirty_data_process_pattern):
            body['DirtyDataProcessPattern'] = request.dirty_data_process_pattern
        if not UtilClient.is_unset(request.exactly_once):
            body['ExactlyOnce'] = request.exactly_once
        if not UtilClient.is_unset(request.full_compute_unit):
            body['FullComputeUnit'] = request.full_compute_unit
        if not UtilClient.is_unset(request.hudi_advanced_config):
            body['HudiAdvancedConfig'] = request.hudi_advanced_config
        if not UtilClient.is_unset(request.incremental_compute_unit):
            body['IncrementalComputeUnit'] = request.incremental_compute_unit
        if not UtilClient.is_unset(request.lakehouse_id):
            body['LakehouseId'] = request.lakehouse_id
        if not UtilClient.is_unset(request.max_offsets_per_trigger):
            body['MaxOffsetsPerTrigger'] = request.max_offsets_per_trigger
        if not UtilClient.is_unset(request.oss_location):
            body['OssLocation'] = request.oss_location
        if not UtilClient.is_unset(request.output_format):
            body['OutputFormat'] = request.output_format
        if not UtilClient.is_unset(request.partition_specs_shrink):
            body['PartitionSpecs'] = request.partition_specs_shrink
        if not UtilClient.is_unset(request.password):
            body['Password'] = request.password
        if not UtilClient.is_unset(request.primary_key_definition):
            body['PrimaryKeyDefinition'] = request.primary_key_definition
        if not UtilClient.is_unset(request.project):
            body['Project'] = request.project
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            body['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.source_region_id):
            body['SourceRegionId'] = request.source_region_id
        if not UtilClient.is_unset(request.starting_offsets):
            body['StartingOffsets'] = request.starting_offsets
        if not UtilClient.is_unset(request.store):
            body['Store'] = request.store
        if not UtilClient.is_unset(request.table_name):
            body['TableName'] = request.table_name
        if not UtilClient.is_unset(request.target_generate_rule):
            body['TargetGenerateRule'] = request.target_generate_rule
        if not UtilClient.is_unset(request.target_type):
            body['TargetType'] = request.target_type
        if not UtilClient.is_unset(request.unix_timestamp_convert_shrink):
            body['UnixTimestampConvert'] = request.unix_timestamp_convert_shrink
        if not UtilClient.is_unset(request.user_name):
            body['UserName'] = request.user_name
        if not UtilClient.is_unset(request.workload_name):
            body['WorkloadName'] = request.workload_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateApsSlsADBJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateApsSlsADBJobResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateApsSlsADBJobResponse(),
                self.execute(params, req, runtime)
            )

    async def create_aps_sls_adbjob_with_options_async(
        self,
        tmp_req: adb_20211201_models.CreateApsSlsADBJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateApsSlsADBJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job from Simple Log Service (SLS) to an AnalyticDB for MySQL Data Warehouse Edition cluster.
        
        @param tmp_req: CreateApsSlsADBJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateApsSlsADBJobResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.CreateApsSlsADBJobShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.columns):
            request.columns_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.columns, 'Columns', 'json')
        if not UtilClient.is_unset(tmp_req.partition_specs):
            request.partition_specs_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.partition_specs, 'PartitionSpecs', 'json')
        if not UtilClient.is_unset(tmp_req.unix_timestamp_convert):
            request.unix_timestamp_convert_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.unix_timestamp_convert, 'UnixTimestampConvert', 'json')
        body = {}
        if not UtilClient.is_unset(request.across_role):
            body['AcrossRole'] = request.across_role
        if not UtilClient.is_unset(request.across_uid):
            body['AcrossUid'] = request.across_uid
        if not UtilClient.is_unset(request.advanced_config):
            body['AdvancedConfig'] = request.advanced_config
        if not UtilClient.is_unset(request.columns_shrink):
            body['Columns'] = request.columns_shrink
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.db_name):
            body['DbName'] = request.db_name
        if not UtilClient.is_unset(request.dirty_data_handle_mode):
            body['DirtyDataHandleMode'] = request.dirty_data_handle_mode
        if not UtilClient.is_unset(request.dirty_data_process_pattern):
            body['DirtyDataProcessPattern'] = request.dirty_data_process_pattern
        if not UtilClient.is_unset(request.exactly_once):
            body['ExactlyOnce'] = request.exactly_once
        if not UtilClient.is_unset(request.full_compute_unit):
            body['FullComputeUnit'] = request.full_compute_unit
        if not UtilClient.is_unset(request.hudi_advanced_config):
            body['HudiAdvancedConfig'] = request.hudi_advanced_config
        if not UtilClient.is_unset(request.incremental_compute_unit):
            body['IncrementalComputeUnit'] = request.incremental_compute_unit
        if not UtilClient.is_unset(request.lakehouse_id):
            body['LakehouseId'] = request.lakehouse_id
        if not UtilClient.is_unset(request.max_offsets_per_trigger):
            body['MaxOffsetsPerTrigger'] = request.max_offsets_per_trigger
        if not UtilClient.is_unset(request.oss_location):
            body['OssLocation'] = request.oss_location
        if not UtilClient.is_unset(request.output_format):
            body['OutputFormat'] = request.output_format
        if not UtilClient.is_unset(request.partition_specs_shrink):
            body['PartitionSpecs'] = request.partition_specs_shrink
        if not UtilClient.is_unset(request.password):
            body['Password'] = request.password
        if not UtilClient.is_unset(request.primary_key_definition):
            body['PrimaryKeyDefinition'] = request.primary_key_definition
        if not UtilClient.is_unset(request.project):
            body['Project'] = request.project
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            body['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.source_region_id):
            body['SourceRegionId'] = request.source_region_id
        if not UtilClient.is_unset(request.starting_offsets):
            body['StartingOffsets'] = request.starting_offsets
        if not UtilClient.is_unset(request.store):
            body['Store'] = request.store
        if not UtilClient.is_unset(request.table_name):
            body['TableName'] = request.table_name
        if not UtilClient.is_unset(request.target_generate_rule):
            body['TargetGenerateRule'] = request.target_generate_rule
        if not UtilClient.is_unset(request.target_type):
            body['TargetType'] = request.target_type
        if not UtilClient.is_unset(request.unix_timestamp_convert_shrink):
            body['UnixTimestampConvert'] = request.unix_timestamp_convert_shrink
        if not UtilClient.is_unset(request.user_name):
            body['UserName'] = request.user_name
        if not UtilClient.is_unset(request.workload_name):
            body['WorkloadName'] = request.workload_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateApsSlsADBJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateApsSlsADBJobResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateApsSlsADBJobResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_aps_sls_adbjob(
        self,
        request: adb_20211201_models.CreateApsSlsADBJobRequest,
    ) -> adb_20211201_models.CreateApsSlsADBJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job from Simple Log Service (SLS) to an AnalyticDB for MySQL Data Warehouse Edition cluster.
        
        @param request: CreateApsSlsADBJobRequest
        @return: CreateApsSlsADBJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_aps_sls_adbjob_with_options(request, runtime)

    async def create_aps_sls_adbjob_async(
        self,
        request: adb_20211201_models.CreateApsSlsADBJobRequest,
    ) -> adb_20211201_models.CreateApsSlsADBJobResponse:
        """
        @summary Creates an AnalyticDB Pipeline Service (APS) job from Simple Log Service (SLS) to an AnalyticDB for MySQL Data Warehouse Edition cluster.
        
        @param request: CreateApsSlsADBJobRequest
        @return: CreateApsSlsADBJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_aps_sls_adbjob_with_options_async(request, runtime)

    def create_dbcluster_with_options(
        self,
        request: adb_20211201_models.CreateDBClusterRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateDBClusterResponse:
        """
        @summary Creates an AnalyticDB for MySQL Data Lakehouse Edition cluster.
        
        @description CreateDBCluster
        
        @param request: CreateDBClusterRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateDBClusterResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.backup_set_id):
            query['BackupSetId'] = request.backup_set_id
        if not UtilClient.is_unset(request.clone_source_region_id):
            query['CloneSourceRegionId'] = request.clone_source_region_id
        if not UtilClient.is_unset(request.compute_resource):
            query['ComputeResource'] = request.compute_resource
        if not UtilClient.is_unset(request.dbcluster_description):
            query['DBClusterDescription'] = request.dbcluster_description
        if not UtilClient.is_unset(request.dbcluster_network_type):
            query['DBClusterNetworkType'] = request.dbcluster_network_type
        if not UtilClient.is_unset(request.dbcluster_version):
            query['DBClusterVersion'] = request.dbcluster_version
        if not UtilClient.is_unset(request.disk_encryption):
            query['DiskEncryption'] = request.disk_encryption
        if not UtilClient.is_unset(request.enable_default_resource_pool):
            query['EnableDefaultResourcePool'] = request.enable_default_resource_pool
        if not UtilClient.is_unset(request.kms_id):
            query['KmsId'] = request.kms_id
        if not UtilClient.is_unset(request.pay_type):
            query['PayType'] = request.pay_type
        if not UtilClient.is_unset(request.period):
            query['Period'] = request.period
        if not UtilClient.is_unset(request.product_form):
            query['ProductForm'] = request.product_form
        if not UtilClient.is_unset(request.product_version):
            query['ProductVersion'] = request.product_version
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.reserved_node_count):
            query['ReservedNodeCount'] = request.reserved_node_count
        if not UtilClient.is_unset(request.reserved_node_size):
            query['ReservedNodeSize'] = request.reserved_node_size
        if not UtilClient.is_unset(request.resource_group_id):
            query['ResourceGroupId'] = request.resource_group_id
        if not UtilClient.is_unset(request.restore_to_time):
            query['RestoreToTime'] = request.restore_to_time
        if not UtilClient.is_unset(request.restore_type):
            query['RestoreType'] = request.restore_type
        if not UtilClient.is_unset(request.secondary_vswitch_id):
            query['SecondaryVSwitchId'] = request.secondary_vswitch_id
        if not UtilClient.is_unset(request.secondary_zone_id):
            query['SecondaryZoneId'] = request.secondary_zone_id
        if not UtilClient.is_unset(request.source_db_cluster_id):
            query['SourceDbClusterId'] = request.source_db_cluster_id
        if not UtilClient.is_unset(request.storage_resource):
            query['StorageResource'] = request.storage_resource
        if not UtilClient.is_unset(request.tag):
            query['Tag'] = request.tag
        if not UtilClient.is_unset(request.used_time):
            query['UsedTime'] = request.used_time
        if not UtilClient.is_unset(request.vpcid):
            query['VPCId'] = request.vpcid
        if not UtilClient.is_unset(request.v_switch_id):
            query['VSwitchId'] = request.v_switch_id
        if not UtilClient.is_unset(request.zone_id):
            query['ZoneId'] = request.zone_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CreateDBCluster',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateDBClusterResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateDBClusterResponse(),
                self.execute(params, req, runtime)
            )

    async def create_dbcluster_with_options_async(
        self,
        request: adb_20211201_models.CreateDBClusterRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateDBClusterResponse:
        """
        @summary Creates an AnalyticDB for MySQL Data Lakehouse Edition cluster.
        
        @description CreateDBCluster
        
        @param request: CreateDBClusterRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateDBClusterResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.backup_set_id):
            query['BackupSetId'] = request.backup_set_id
        if not UtilClient.is_unset(request.clone_source_region_id):
            query['CloneSourceRegionId'] = request.clone_source_region_id
        if not UtilClient.is_unset(request.compute_resource):
            query['ComputeResource'] = request.compute_resource
        if not UtilClient.is_unset(request.dbcluster_description):
            query['DBClusterDescription'] = request.dbcluster_description
        if not UtilClient.is_unset(request.dbcluster_network_type):
            query['DBClusterNetworkType'] = request.dbcluster_network_type
        if not UtilClient.is_unset(request.dbcluster_version):
            query['DBClusterVersion'] = request.dbcluster_version
        if not UtilClient.is_unset(request.disk_encryption):
            query['DiskEncryption'] = request.disk_encryption
        if not UtilClient.is_unset(request.enable_default_resource_pool):
            query['EnableDefaultResourcePool'] = request.enable_default_resource_pool
        if not UtilClient.is_unset(request.kms_id):
            query['KmsId'] = request.kms_id
        if not UtilClient.is_unset(request.pay_type):
            query['PayType'] = request.pay_type
        if not UtilClient.is_unset(request.period):
            query['Period'] = request.period
        if not UtilClient.is_unset(request.product_form):
            query['ProductForm'] = request.product_form
        if not UtilClient.is_unset(request.product_version):
            query['ProductVersion'] = request.product_version
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.reserved_node_count):
            query['ReservedNodeCount'] = request.reserved_node_count
        if not UtilClient.is_unset(request.reserved_node_size):
            query['ReservedNodeSize'] = request.reserved_node_size
        if not UtilClient.is_unset(request.resource_group_id):
            query['ResourceGroupId'] = request.resource_group_id
        if not UtilClient.is_unset(request.restore_to_time):
            query['RestoreToTime'] = request.restore_to_time
        if not UtilClient.is_unset(request.restore_type):
            query['RestoreType'] = request.restore_type
        if not UtilClient.is_unset(request.secondary_vswitch_id):
            query['SecondaryVSwitchId'] = request.secondary_vswitch_id
        if not UtilClient.is_unset(request.secondary_zone_id):
            query['SecondaryZoneId'] = request.secondary_zone_id
        if not UtilClient.is_unset(request.source_db_cluster_id):
            query['SourceDbClusterId'] = request.source_db_cluster_id
        if not UtilClient.is_unset(request.storage_resource):
            query['StorageResource'] = request.storage_resource
        if not UtilClient.is_unset(request.tag):
            query['Tag'] = request.tag
        if not UtilClient.is_unset(request.used_time):
            query['UsedTime'] = request.used_time
        if not UtilClient.is_unset(request.vpcid):
            query['VPCId'] = request.vpcid
        if not UtilClient.is_unset(request.v_switch_id):
            query['VSwitchId'] = request.v_switch_id
        if not UtilClient.is_unset(request.zone_id):
            query['ZoneId'] = request.zone_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CreateDBCluster',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateDBClusterResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateDBClusterResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_dbcluster(
        self,
        request: adb_20211201_models.CreateDBClusterRequest,
    ) -> adb_20211201_models.CreateDBClusterResponse:
        """
        @summary Creates an AnalyticDB for MySQL Data Lakehouse Edition cluster.
        
        @description CreateDBCluster
        
        @param request: CreateDBClusterRequest
        @return: CreateDBClusterResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_dbcluster_with_options(request, runtime)

    async def create_dbcluster_async(
        self,
        request: adb_20211201_models.CreateDBClusterRequest,
    ) -> adb_20211201_models.CreateDBClusterResponse:
        """
        @summary Creates an AnalyticDB for MySQL Data Lakehouse Edition cluster.
        
        @description CreateDBCluster
        
        @param request: CreateDBClusterRequest
        @return: CreateDBClusterResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_dbcluster_with_options_async(request, runtime)

    def create_dbresource_group_with_options(
        self,
        tmp_req: adb_20211201_models.CreateDBResourceGroupRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateDBResourceGroupResponse:
        """
        @summary Creates a resource group for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param tmp_req: CreateDBResourceGroupRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateDBResourceGroupResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.CreateDBResourceGroupShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.engine_params):
            request.engine_params_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.engine_params, 'EngineParams', 'json')
        if not UtilClient.is_unset(tmp_req.ray_config):
            request.ray_config_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.ray_config, 'RayConfig', 'json')
        if not UtilClient.is_unset(tmp_req.rules):
            request.rules_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.rules, 'Rules', 'json')
        query = {}
        if not UtilClient.is_unset(request.auto_stop_interval):
            query['AutoStopInterval'] = request.auto_stop_interval
        if not UtilClient.is_unset(request.cluster_mode):
            query['ClusterMode'] = request.cluster_mode
        if not UtilClient.is_unset(request.cluster_size_resource):
            query['ClusterSizeResource'] = request.cluster_size_resource
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_spot):
            query['EnableSpot'] = request.enable_spot
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        if not UtilClient.is_unset(request.engine_params_shrink):
            query['EngineParams'] = request.engine_params_shrink
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        if not UtilClient.is_unset(request.group_type):
            query['GroupType'] = request.group_type
        if not UtilClient.is_unset(request.max_cluster_count):
            query['MaxClusterCount'] = request.max_cluster_count
        if not UtilClient.is_unset(request.max_compute_resource):
            query['MaxComputeResource'] = request.max_compute_resource
        if not UtilClient.is_unset(request.max_gpu_quantity):
            query['MaxGpuQuantity'] = request.max_gpu_quantity
        if not UtilClient.is_unset(request.min_cluster_count):
            query['MinClusterCount'] = request.min_cluster_count
        if not UtilClient.is_unset(request.min_compute_resource):
            query['MinComputeResource'] = request.min_compute_resource
        if not UtilClient.is_unset(request.min_gpu_quantity):
            query['MinGpuQuantity'] = request.min_gpu_quantity
        if not UtilClient.is_unset(request.ray_config_shrink):
            query['RayConfig'] = request.ray_config_shrink
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.rules_shrink):
            query['Rules'] = request.rules_shrink
        if not UtilClient.is_unset(request.spec_name):
            query['SpecName'] = request.spec_name
        if not UtilClient.is_unset(request.target_resource_group_name):
            query['TargetResourceGroupName'] = request.target_resource_group_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CreateDBResourceGroup',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateDBResourceGroupResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateDBResourceGroupResponse(),
                self.execute(params, req, runtime)
            )

    async def create_dbresource_group_with_options_async(
        self,
        tmp_req: adb_20211201_models.CreateDBResourceGroupRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateDBResourceGroupResponse:
        """
        @summary Creates a resource group for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param tmp_req: CreateDBResourceGroupRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateDBResourceGroupResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.CreateDBResourceGroupShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.engine_params):
            request.engine_params_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.engine_params, 'EngineParams', 'json')
        if not UtilClient.is_unset(tmp_req.ray_config):
            request.ray_config_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.ray_config, 'RayConfig', 'json')
        if not UtilClient.is_unset(tmp_req.rules):
            request.rules_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.rules, 'Rules', 'json')
        query = {}
        if not UtilClient.is_unset(request.auto_stop_interval):
            query['AutoStopInterval'] = request.auto_stop_interval
        if not UtilClient.is_unset(request.cluster_mode):
            query['ClusterMode'] = request.cluster_mode
        if not UtilClient.is_unset(request.cluster_size_resource):
            query['ClusterSizeResource'] = request.cluster_size_resource
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_spot):
            query['EnableSpot'] = request.enable_spot
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        if not UtilClient.is_unset(request.engine_params_shrink):
            query['EngineParams'] = request.engine_params_shrink
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        if not UtilClient.is_unset(request.group_type):
            query['GroupType'] = request.group_type
        if not UtilClient.is_unset(request.max_cluster_count):
            query['MaxClusterCount'] = request.max_cluster_count
        if not UtilClient.is_unset(request.max_compute_resource):
            query['MaxComputeResource'] = request.max_compute_resource
        if not UtilClient.is_unset(request.max_gpu_quantity):
            query['MaxGpuQuantity'] = request.max_gpu_quantity
        if not UtilClient.is_unset(request.min_cluster_count):
            query['MinClusterCount'] = request.min_cluster_count
        if not UtilClient.is_unset(request.min_compute_resource):
            query['MinComputeResource'] = request.min_compute_resource
        if not UtilClient.is_unset(request.min_gpu_quantity):
            query['MinGpuQuantity'] = request.min_gpu_quantity
        if not UtilClient.is_unset(request.ray_config_shrink):
            query['RayConfig'] = request.ray_config_shrink
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.rules_shrink):
            query['Rules'] = request.rules_shrink
        if not UtilClient.is_unset(request.spec_name):
            query['SpecName'] = request.spec_name
        if not UtilClient.is_unset(request.target_resource_group_name):
            query['TargetResourceGroupName'] = request.target_resource_group_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CreateDBResourceGroup',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateDBResourceGroupResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateDBResourceGroupResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_dbresource_group(
        self,
        request: adb_20211201_models.CreateDBResourceGroupRequest,
    ) -> adb_20211201_models.CreateDBResourceGroupResponse:
        """
        @summary Creates a resource group for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: CreateDBResourceGroupRequest
        @return: CreateDBResourceGroupResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_dbresource_group_with_options(request, runtime)

    async def create_dbresource_group_async(
        self,
        request: adb_20211201_models.CreateDBResourceGroupRequest,
    ) -> adb_20211201_models.CreateDBResourceGroupResponse:
        """
        @summary Creates a resource group for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: CreateDBResourceGroupRequest
        @return: CreateDBResourceGroupResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_dbresource_group_with_options_async(request, runtime)

    def create_elastic_plan_with_options(
        self,
        request: adb_20211201_models.CreateElasticPlanRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateElasticPlanResponse:
        """
        @summary Creates a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateElasticPlanRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateElasticPlanResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.auto_scale):
            query['AutoScale'] = request.auto_scale
        if not UtilClient.is_unset(request.cron_expression):
            query['CronExpression'] = request.cron_expression
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        if not UtilClient.is_unset(request.enabled):
            query['Enabled'] = request.enabled
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.target_size):
            query['TargetSize'] = request.target_size
        if not UtilClient.is_unset(request.type):
            query['Type'] = request.type
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CreateElasticPlan',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateElasticPlanResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateElasticPlanResponse(),
                self.execute(params, req, runtime)
            )

    async def create_elastic_plan_with_options_async(
        self,
        request: adb_20211201_models.CreateElasticPlanRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateElasticPlanResponse:
        """
        @summary Creates a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateElasticPlanRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateElasticPlanResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.auto_scale):
            query['AutoScale'] = request.auto_scale
        if not UtilClient.is_unset(request.cron_expression):
            query['CronExpression'] = request.cron_expression
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        if not UtilClient.is_unset(request.enabled):
            query['Enabled'] = request.enabled
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.target_size):
            query['TargetSize'] = request.target_size
        if not UtilClient.is_unset(request.type):
            query['Type'] = request.type
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CreateElasticPlan',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateElasticPlanResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateElasticPlanResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_elastic_plan(
        self,
        request: adb_20211201_models.CreateElasticPlanRequest,
    ) -> adb_20211201_models.CreateElasticPlanResponse:
        """
        @summary Creates a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateElasticPlanRequest
        @return: CreateElasticPlanResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_elastic_plan_with_options(request, runtime)

    async def create_elastic_plan_async(
        self,
        request: adb_20211201_models.CreateElasticPlanRequest,
    ) -> adb_20211201_models.CreateElasticPlanResponse:
        """
        @summary Creates a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: CreateElasticPlanRequest
        @return: CreateElasticPlanResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_elastic_plan_with_options_async(request, runtime)

    def create_lake_storage_with_options(
        self,
        tmp_req: adb_20211201_models.CreateLakeStorageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateLakeStorageResponse:
        """
        @summary Creates a lake storage.
        
        @param tmp_req: CreateLakeStorageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateLakeStorageResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.CreateLakeStorageShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.permissions):
            request.permissions_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.permissions, 'Permissions', 'json')
        query = {}
        if not UtilClient.is_unset(request.client_token):
            query['ClientToken'] = request.client_token
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.description):
            body['Description'] = request.description
        if not UtilClient.is_unset(request.permissions_shrink):
            body['Permissions'] = request.permissions_shrink
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateLakeStorage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateLakeStorageResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateLakeStorageResponse(),
                self.execute(params, req, runtime)
            )

    async def create_lake_storage_with_options_async(
        self,
        tmp_req: adb_20211201_models.CreateLakeStorageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateLakeStorageResponse:
        """
        @summary Creates a lake storage.
        
        @param tmp_req: CreateLakeStorageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateLakeStorageResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.CreateLakeStorageShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.permissions):
            request.permissions_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.permissions, 'Permissions', 'json')
        query = {}
        if not UtilClient.is_unset(request.client_token):
            query['ClientToken'] = request.client_token
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.description):
            body['Description'] = request.description
        if not UtilClient.is_unset(request.permissions_shrink):
            body['Permissions'] = request.permissions_shrink
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateLakeStorage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateLakeStorageResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateLakeStorageResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_lake_storage(
        self,
        request: adb_20211201_models.CreateLakeStorageRequest,
    ) -> adb_20211201_models.CreateLakeStorageResponse:
        """
        @summary Creates a lake storage.
        
        @param request: CreateLakeStorageRequest
        @return: CreateLakeStorageResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_lake_storage_with_options(request, runtime)

    async def create_lake_storage_async(
        self,
        request: adb_20211201_models.CreateLakeStorageRequest,
    ) -> adb_20211201_models.CreateLakeStorageResponse:
        """
        @summary Creates a lake storage.
        
        @param request: CreateLakeStorageRequest
        @return: CreateLakeStorageResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_lake_storage_with_options_async(request, runtime)

    def create_oss_sub_directory_with_options(
        self,
        request: adb_20211201_models.CreateOssSubDirectoryRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateOssSubDirectoryResponse:
        """
        @summary Creates an Object Storage Service (OSS) subdirectory.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: CreateOssSubDirectoryRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateOssSubDirectoryResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.path):
            body['Path'] = request.path
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateOssSubDirectory',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateOssSubDirectoryResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateOssSubDirectoryResponse(),
                self.execute(params, req, runtime)
            )

    async def create_oss_sub_directory_with_options_async(
        self,
        request: adb_20211201_models.CreateOssSubDirectoryRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateOssSubDirectoryResponse:
        """
        @summary Creates an Object Storage Service (OSS) subdirectory.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: CreateOssSubDirectoryRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateOssSubDirectoryResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.path):
            body['Path'] = request.path
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateOssSubDirectory',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateOssSubDirectoryResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateOssSubDirectoryResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_oss_sub_directory(
        self,
        request: adb_20211201_models.CreateOssSubDirectoryRequest,
    ) -> adb_20211201_models.CreateOssSubDirectoryResponse:
        """
        @summary Creates an Object Storage Service (OSS) subdirectory.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: CreateOssSubDirectoryRequest
        @return: CreateOssSubDirectoryResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_oss_sub_directory_with_options(request, runtime)

    async def create_oss_sub_directory_async(
        self,
        request: adb_20211201_models.CreateOssSubDirectoryRequest,
    ) -> adb_20211201_models.CreateOssSubDirectoryResponse:
        """
        @summary Creates an Object Storage Service (OSS) subdirectory.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: CreateOssSubDirectoryRequest
        @return: CreateOssSubDirectoryResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_oss_sub_directory_with_options_async(request, runtime)

    def create_performance_view_with_options(
        self,
        tmp_req: adb_20211201_models.CreatePerformanceViewRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreatePerformanceViewResponse:
        """
        @summary Creates a custom monitoring view.
        
        @param tmp_req: CreatePerformanceViewRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreatePerformanceViewResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.CreatePerformanceViewShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.view_detail):
            request.view_detail_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.view_detail, 'ViewDetail', 'json')
        query = {}
        if not UtilClient.is_unset(request.create_from_view_type):
            query['CreateFromViewType'] = request.create_from_view_type
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.fill_origin_view_keys):
            query['FillOriginViewKeys'] = request.fill_origin_view_keys
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.view_detail_shrink):
            query['ViewDetail'] = request.view_detail_shrink
        if not UtilClient.is_unset(request.view_name):
            query['ViewName'] = request.view_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CreatePerformanceView',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreatePerformanceViewResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreatePerformanceViewResponse(),
                self.execute(params, req, runtime)
            )

    async def create_performance_view_with_options_async(
        self,
        tmp_req: adb_20211201_models.CreatePerformanceViewRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreatePerformanceViewResponse:
        """
        @summary Creates a custom monitoring view.
        
        @param tmp_req: CreatePerformanceViewRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreatePerformanceViewResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.CreatePerformanceViewShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.view_detail):
            request.view_detail_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.view_detail, 'ViewDetail', 'json')
        query = {}
        if not UtilClient.is_unset(request.create_from_view_type):
            query['CreateFromViewType'] = request.create_from_view_type
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.fill_origin_view_keys):
            query['FillOriginViewKeys'] = request.fill_origin_view_keys
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.view_detail_shrink):
            query['ViewDetail'] = request.view_detail_shrink
        if not UtilClient.is_unset(request.view_name):
            query['ViewName'] = request.view_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='CreatePerformanceView',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreatePerformanceViewResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreatePerformanceViewResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_performance_view(
        self,
        request: adb_20211201_models.CreatePerformanceViewRequest,
    ) -> adb_20211201_models.CreatePerformanceViewResponse:
        """
        @summary Creates a custom monitoring view.
        
        @param request: CreatePerformanceViewRequest
        @return: CreatePerformanceViewResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_performance_view_with_options(request, runtime)

    async def create_performance_view_async(
        self,
        request: adb_20211201_models.CreatePerformanceViewRequest,
    ) -> adb_20211201_models.CreatePerformanceViewResponse:
        """
        @summary Creates a custom monitoring view.
        
        @param request: CreatePerformanceViewRequest
        @return: CreatePerformanceViewResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_performance_view_with_options_async(request, runtime)

    def create_spark_template_with_options(
        self,
        request: adb_20211201_models.CreateSparkTemplateRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateSparkTemplateResponse:
        """
        @summary Creates a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: CreateSparkTemplateRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateSparkTemplateResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_type):
            body['AppType'] = request.app_type
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.name):
            body['Name'] = request.name
        if not UtilClient.is_unset(request.parent_id):
            body['ParentId'] = request.parent_id
        if not UtilClient.is_unset(request.type):
            body['Type'] = request.type
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateSparkTemplate',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateSparkTemplateResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateSparkTemplateResponse(),
                self.execute(params, req, runtime)
            )

    async def create_spark_template_with_options_async(
        self,
        request: adb_20211201_models.CreateSparkTemplateRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.CreateSparkTemplateResponse:
        """
        @summary Creates a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: CreateSparkTemplateRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: CreateSparkTemplateResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_type):
            body['AppType'] = request.app_type
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.name):
            body['Name'] = request.name
        if not UtilClient.is_unset(request.parent_id):
            body['ParentId'] = request.parent_id
        if not UtilClient.is_unset(request.type):
            body['Type'] = request.type
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='CreateSparkTemplate',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.CreateSparkTemplateResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.CreateSparkTemplateResponse(),
                await self.execute_async(params, req, runtime)
            )

    def create_spark_template(
        self,
        request: adb_20211201_models.CreateSparkTemplateRequest,
    ) -> adb_20211201_models.CreateSparkTemplateResponse:
        """
        @summary Creates a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: CreateSparkTemplateRequest
        @return: CreateSparkTemplateResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.create_spark_template_with_options(request, runtime)

    async def create_spark_template_async(
        self,
        request: adb_20211201_models.CreateSparkTemplateRequest,
    ) -> adb_20211201_models.CreateSparkTemplateResponse:
        """
        @summary Creates a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: CreateSparkTemplateRequest
        @return: CreateSparkTemplateResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.create_spark_template_with_options_async(request, runtime)

    def delete_account_with_options(
        self,
        request: adb_20211201_models.DeleteAccountRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteAccountResponse:
        """
        @summary Deletes a database account from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteAccountRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteAccountResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteAccount',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteAccountResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteAccountResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_account_with_options_async(
        self,
        request: adb_20211201_models.DeleteAccountRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteAccountResponse:
        """
        @summary Deletes a database account from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteAccountRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteAccountResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteAccount',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteAccountResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteAccountResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_account(
        self,
        request: adb_20211201_models.DeleteAccountRequest,
    ) -> adb_20211201_models.DeleteAccountResponse:
        """
        @summary Deletes a database account from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteAccountRequest
        @return: DeleteAccountResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_account_with_options(request, runtime)

    async def delete_account_async(
        self,
        request: adb_20211201_models.DeleteAccountRequest,
    ) -> adb_20211201_models.DeleteAccountResponse:
        """
        @summary Deletes a database account from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteAccountRequest
        @return: DeleteAccountResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_account_with_options_async(request, runtime)

    def delete_aps_datasoure_with_options(
        self,
        request: adb_20211201_models.DeleteApsDatasoureRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteApsDatasoureResponse:
        """
        @summary Deletes an AnalyticDB Pipeline Service (APS) data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteApsDatasoureRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteApsDatasoureResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DeleteApsDatasoure',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteApsDatasoureResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteApsDatasoureResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_aps_datasoure_with_options_async(
        self,
        request: adb_20211201_models.DeleteApsDatasoureRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteApsDatasoureResponse:
        """
        @summary Deletes an AnalyticDB Pipeline Service (APS) data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteApsDatasoureRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteApsDatasoureResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DeleteApsDatasoure',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteApsDatasoureResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteApsDatasoureResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_aps_datasoure(
        self,
        request: adb_20211201_models.DeleteApsDatasoureRequest,
    ) -> adb_20211201_models.DeleteApsDatasoureResponse:
        """
        @summary Deletes an AnalyticDB Pipeline Service (APS) data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteApsDatasoureRequest
        @return: DeleteApsDatasoureResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_aps_datasoure_with_options(request, runtime)

    async def delete_aps_datasoure_async(
        self,
        request: adb_20211201_models.DeleteApsDatasoureRequest,
    ) -> adb_20211201_models.DeleteApsDatasoureResponse:
        """
        @summary Deletes an AnalyticDB Pipeline Service (APS) data source.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteApsDatasoureRequest
        @return: DeleteApsDatasoureResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_aps_datasoure_with_options_async(request, runtime)

    def delete_aps_job_with_options(
        self,
        request: adb_20211201_models.DeleteApsJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteApsJobResponse:
        """
        @summary Deletes an AnalyticDB Pipeline Service (APS) job.
        
        @description    Deleting backup sets is an asynchronous operation and may require 10 to 20 minutes to complete.
        You can delete up to 100 backup sets at a time. If you want to delete more than 100 backup sets, call this operation twice.
        To ensure data security, the system forcibly retains one valid backup set. If you want to delete the last backup set, the system prohibits your operation.
        
        @param request: DeleteApsJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteApsJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_id):
            body['ApsJobId'] = request.aps_job_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DeleteApsJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteApsJobResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteApsJobResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_aps_job_with_options_async(
        self,
        request: adb_20211201_models.DeleteApsJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteApsJobResponse:
        """
        @summary Deletes an AnalyticDB Pipeline Service (APS) job.
        
        @description    Deleting backup sets is an asynchronous operation and may require 10 to 20 minutes to complete.
        You can delete up to 100 backup sets at a time. If you want to delete more than 100 backup sets, call this operation twice.
        To ensure data security, the system forcibly retains one valid backup set. If you want to delete the last backup set, the system prohibits your operation.
        
        @param request: DeleteApsJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteApsJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_id):
            body['ApsJobId'] = request.aps_job_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DeleteApsJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteApsJobResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteApsJobResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_aps_job(
        self,
        request: adb_20211201_models.DeleteApsJobRequest,
    ) -> adb_20211201_models.DeleteApsJobResponse:
        """
        @summary Deletes an AnalyticDB Pipeline Service (APS) job.
        
        @description    Deleting backup sets is an asynchronous operation and may require 10 to 20 minutes to complete.
        You can delete up to 100 backup sets at a time. If you want to delete more than 100 backup sets, call this operation twice.
        To ensure data security, the system forcibly retains one valid backup set. If you want to delete the last backup set, the system prohibits your operation.
        
        @param request: DeleteApsJobRequest
        @return: DeleteApsJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_aps_job_with_options(request, runtime)

    async def delete_aps_job_async(
        self,
        request: adb_20211201_models.DeleteApsJobRequest,
    ) -> adb_20211201_models.DeleteApsJobResponse:
        """
        @summary Deletes an AnalyticDB Pipeline Service (APS) job.
        
        @description    Deleting backup sets is an asynchronous operation and may require 10 to 20 minutes to complete.
        You can delete up to 100 backup sets at a time. If you want to delete more than 100 backup sets, call this operation twice.
        To ensure data security, the system forcibly retains one valid backup set. If you want to delete the last backup set, the system prohibits your operation.
        
        @param request: DeleteApsJobRequest
        @return: DeleteApsJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_aps_job_with_options_async(request, runtime)

    def delete_backups_with_options(
        self,
        request: adb_20211201_models.DeleteBackupsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteBackupsResponse:
        """
        @summary Manually deletes backup sets.
        
        @description    You can delete up to 100 backup sets at a time. If you want to delete more than 100 backup sets, call this operation twice.
        To ensure data security, the system forcibly retains one valid backup set. If you want to delete the last backup set, the system prohibits your operation.
        
        @param request: DeleteBackupsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteBackupsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.backup_ids):
            query['BackupIds'] = request.backup_ids
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteBackups',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteBackupsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteBackupsResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_backups_with_options_async(
        self,
        request: adb_20211201_models.DeleteBackupsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteBackupsResponse:
        """
        @summary Manually deletes backup sets.
        
        @description    You can delete up to 100 backup sets at a time. If you want to delete more than 100 backup sets, call this operation twice.
        To ensure data security, the system forcibly retains one valid backup set. If you want to delete the last backup set, the system prohibits your operation.
        
        @param request: DeleteBackupsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteBackupsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.backup_ids):
            query['BackupIds'] = request.backup_ids
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteBackups',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteBackupsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteBackupsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_backups(
        self,
        request: adb_20211201_models.DeleteBackupsRequest,
    ) -> adb_20211201_models.DeleteBackupsResponse:
        """
        @summary Manually deletes backup sets.
        
        @description    You can delete up to 100 backup sets at a time. If you want to delete more than 100 backup sets, call this operation twice.
        To ensure data security, the system forcibly retains one valid backup set. If you want to delete the last backup set, the system prohibits your operation.
        
        @param request: DeleteBackupsRequest
        @return: DeleteBackupsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_backups_with_options(request, runtime)

    async def delete_backups_async(
        self,
        request: adb_20211201_models.DeleteBackupsRequest,
    ) -> adb_20211201_models.DeleteBackupsResponse:
        """
        @summary Manually deletes backup sets.
        
        @description    You can delete up to 100 backup sets at a time. If you want to delete more than 100 backup sets, call this operation twice.
        To ensure data security, the system forcibly retains one valid backup set. If you want to delete the last backup set, the system prohibits your operation.
        
        @param request: DeleteBackupsRequest
        @return: DeleteBackupsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_backups_with_options_async(request, runtime)

    def delete_dbcluster_with_options(
        self,
        request: adb_20211201_models.DeleteDBClusterRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteDBClusterResponse:
        """
        @summary Deletes an AnalyticDB for MySQL cluster.
        
        @description ### [](#)
        You can delete only pay-as-you-go clusters.
        The cluster that you want to delete must be in the Running state.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteDBClusterRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteDBClusterResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteDBCluster',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteDBClusterResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteDBClusterResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_dbcluster_with_options_async(
        self,
        request: adb_20211201_models.DeleteDBClusterRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteDBClusterResponse:
        """
        @summary Deletes an AnalyticDB for MySQL cluster.
        
        @description ### [](#)
        You can delete only pay-as-you-go clusters.
        The cluster that you want to delete must be in the Running state.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteDBClusterRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteDBClusterResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteDBCluster',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteDBClusterResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteDBClusterResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_dbcluster(
        self,
        request: adb_20211201_models.DeleteDBClusterRequest,
    ) -> adb_20211201_models.DeleteDBClusterResponse:
        """
        @summary Deletes an AnalyticDB for MySQL cluster.
        
        @description ### [](#)
        You can delete only pay-as-you-go clusters.
        The cluster that you want to delete must be in the Running state.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteDBClusterRequest
        @return: DeleteDBClusterResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_dbcluster_with_options(request, runtime)

    async def delete_dbcluster_async(
        self,
        request: adb_20211201_models.DeleteDBClusterRequest,
    ) -> adb_20211201_models.DeleteDBClusterResponse:
        """
        @summary Deletes an AnalyticDB for MySQL cluster.
        
        @description ### [](#)
        You can delete only pay-as-you-go clusters.
        The cluster that you want to delete must be in the Running state.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteDBClusterRequest
        @return: DeleteDBClusterResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_dbcluster_with_options_async(request, runtime)

    def delete_dbresource_group_with_options(
        self,
        request: adb_20211201_models.DeleteDBResourceGroupRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteDBResourceGroupResponse:
        """
        @summary Deletes a resource group from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteDBResourceGroupRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteDBResourceGroupResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteDBResourceGroup',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteDBResourceGroupResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteDBResourceGroupResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_dbresource_group_with_options_async(
        self,
        request: adb_20211201_models.DeleteDBResourceGroupRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteDBResourceGroupResponse:
        """
        @summary Deletes a resource group from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteDBResourceGroupRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteDBResourceGroupResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteDBResourceGroup',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteDBResourceGroupResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteDBResourceGroupResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_dbresource_group(
        self,
        request: adb_20211201_models.DeleteDBResourceGroupRequest,
    ) -> adb_20211201_models.DeleteDBResourceGroupResponse:
        """
        @summary Deletes a resource group from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteDBResourceGroupRequest
        @return: DeleteDBResourceGroupResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_dbresource_group_with_options(request, runtime)

    async def delete_dbresource_group_async(
        self,
        request: adb_20211201_models.DeleteDBResourceGroupRequest,
    ) -> adb_20211201_models.DeleteDBResourceGroupResponse:
        """
        @summary Deletes a resource group from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteDBResourceGroupRequest
        @return: DeleteDBResourceGroupResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_dbresource_group_with_options_async(request, runtime)

    def delete_elastic_plan_with_options(
        self,
        request: adb_20211201_models.DeleteElasticPlanRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteElasticPlanResponse:
        """
        @summary Deletes a scaling plan from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteElasticPlanRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteElasticPlanResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteElasticPlan',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteElasticPlanResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteElasticPlanResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_elastic_plan_with_options_async(
        self,
        request: adb_20211201_models.DeleteElasticPlanRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteElasticPlanResponse:
        """
        @summary Deletes a scaling plan from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteElasticPlanRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteElasticPlanResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteElasticPlan',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteElasticPlanResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteElasticPlanResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_elastic_plan(
        self,
        request: adb_20211201_models.DeleteElasticPlanRequest,
    ) -> adb_20211201_models.DeleteElasticPlanResponse:
        """
        @summary Deletes a scaling plan from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteElasticPlanRequest
        @return: DeleteElasticPlanResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_elastic_plan_with_options(request, runtime)

    async def delete_elastic_plan_async(
        self,
        request: adb_20211201_models.DeleteElasticPlanRequest,
    ) -> adb_20211201_models.DeleteElasticPlanResponse:
        """
        @summary Deletes a scaling plan from an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteElasticPlanRequest
        @return: DeleteElasticPlanResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_elastic_plan_with_options_async(request, runtime)

    def delete_lake_storage_with_options(
        self,
        request: adb_20211201_models.DeleteLakeStorageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteLakeStorageResponse:
        """
        @summary Deletes a lake storage.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteLakeStorageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteLakeStorageResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.lake_storage_id):
            body['LakeStorageId'] = request.lake_storage_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DeleteLakeStorage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteLakeStorageResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteLakeStorageResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_lake_storage_with_options_async(
        self,
        request: adb_20211201_models.DeleteLakeStorageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteLakeStorageResponse:
        """
        @summary Deletes a lake storage.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteLakeStorageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteLakeStorageResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.lake_storage_id):
            body['LakeStorageId'] = request.lake_storage_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DeleteLakeStorage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteLakeStorageResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteLakeStorageResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_lake_storage(
        self,
        request: adb_20211201_models.DeleteLakeStorageRequest,
    ) -> adb_20211201_models.DeleteLakeStorageResponse:
        """
        @summary Deletes a lake storage.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteLakeStorageRequest
        @return: DeleteLakeStorageResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_lake_storage_with_options(request, runtime)

    async def delete_lake_storage_async(
        self,
        request: adb_20211201_models.DeleteLakeStorageRequest,
    ) -> adb_20211201_models.DeleteLakeStorageResponse:
        """
        @summary Deletes a lake storage.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DeleteLakeStorageRequest
        @return: DeleteLakeStorageResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_lake_storage_with_options_async(request, runtime)

    def delete_performance_view_with_options(
        self,
        request: adb_20211201_models.DeletePerformanceViewRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeletePerformanceViewResponse:
        """
        @summary Deletes a monitoring view.
        
        @param request: DeletePerformanceViewRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeletePerformanceViewResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.view_name):
            query['ViewName'] = request.view_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeletePerformanceView',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeletePerformanceViewResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeletePerformanceViewResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_performance_view_with_options_async(
        self,
        request: adb_20211201_models.DeletePerformanceViewRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeletePerformanceViewResponse:
        """
        @summary Deletes a monitoring view.
        
        @param request: DeletePerformanceViewRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeletePerformanceViewResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.view_name):
            query['ViewName'] = request.view_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeletePerformanceView',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeletePerformanceViewResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeletePerformanceViewResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_performance_view(
        self,
        request: adb_20211201_models.DeletePerformanceViewRequest,
    ) -> adb_20211201_models.DeletePerformanceViewResponse:
        """
        @summary Deletes a monitoring view.
        
        @param request: DeletePerformanceViewRequest
        @return: DeletePerformanceViewResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_performance_view_with_options(request, runtime)

    async def delete_performance_view_async(
        self,
        request: adb_20211201_models.DeletePerformanceViewRequest,
    ) -> adb_20211201_models.DeletePerformanceViewResponse:
        """
        @summary Deletes a monitoring view.
        
        @param request: DeletePerformanceViewRequest
        @return: DeletePerformanceViewResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_performance_view_with_options_async(request, runtime)

    def delete_process_instance_with_options(
        self,
        request: adb_20211201_models.DeleteProcessInstanceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteProcessInstanceResponse:
        """
        @summary Deletes a worflow instance from an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DeleteProcessInstanceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteProcessInstanceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.process_instance_id):
            query['ProcessInstanceId'] = request.process_instance_id
        if not UtilClient.is_unset(request.project_code):
            query['ProjectCode'] = request.project_code
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteProcessInstance',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteProcessInstanceResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteProcessInstanceResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_process_instance_with_options_async(
        self,
        request: adb_20211201_models.DeleteProcessInstanceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteProcessInstanceResponse:
        """
        @summary Deletes a worflow instance from an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DeleteProcessInstanceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteProcessInstanceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.process_instance_id):
            query['ProcessInstanceId'] = request.process_instance_id
        if not UtilClient.is_unset(request.project_code):
            query['ProjectCode'] = request.project_code
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DeleteProcessInstance',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteProcessInstanceResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteProcessInstanceResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_process_instance(
        self,
        request: adb_20211201_models.DeleteProcessInstanceRequest,
    ) -> adb_20211201_models.DeleteProcessInstanceResponse:
        """
        @summary Deletes a worflow instance from an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DeleteProcessInstanceRequest
        @return: DeleteProcessInstanceResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_process_instance_with_options(request, runtime)

    async def delete_process_instance_async(
        self,
        request: adb_20211201_models.DeleteProcessInstanceRequest,
    ) -> adb_20211201_models.DeleteProcessInstanceResponse:
        """
        @summary Deletes a worflow instance from an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DeleteProcessInstanceRequest
        @return: DeleteProcessInstanceResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_process_instance_with_options_async(request, runtime)

    def delete_spark_template_with_options(
        self,
        request: adb_20211201_models.DeleteSparkTemplateRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteSparkTemplateResponse:
        """
        @summary Deletes Spark template files.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: DeleteSparkTemplateRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteSparkTemplateResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.id):
            body['Id'] = request.id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DeleteSparkTemplate',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteSparkTemplateResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteSparkTemplateResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_spark_template_with_options_async(
        self,
        request: adb_20211201_models.DeleteSparkTemplateRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteSparkTemplateResponse:
        """
        @summary Deletes Spark template files.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: DeleteSparkTemplateRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteSparkTemplateResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.id):
            body['Id'] = request.id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DeleteSparkTemplate',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteSparkTemplateResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteSparkTemplateResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_spark_template(
        self,
        request: adb_20211201_models.DeleteSparkTemplateRequest,
    ) -> adb_20211201_models.DeleteSparkTemplateResponse:
        """
        @summary Deletes Spark template files.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: DeleteSparkTemplateRequest
        @return: DeleteSparkTemplateResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_spark_template_with_options(request, runtime)

    async def delete_spark_template_async(
        self,
        request: adb_20211201_models.DeleteSparkTemplateRequest,
    ) -> adb_20211201_models.DeleteSparkTemplateResponse:
        """
        @summary Deletes Spark template files.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: DeleteSparkTemplateRequest
        @return: DeleteSparkTemplateResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_spark_template_with_options_async(request, runtime)

    def delete_spark_template_file_with_options(
        self,
        request: adb_20211201_models.DeleteSparkTemplateFileRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteSparkTemplateFileResponse:
        """
        @summary Deletes Spark template files.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: DeleteSparkTemplateFileRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteSparkTemplateFileResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.id):
            body['Id'] = request.id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DeleteSparkTemplateFile',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteSparkTemplateFileResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteSparkTemplateFileResponse(),
                self.execute(params, req, runtime)
            )

    async def delete_spark_template_file_with_options_async(
        self,
        request: adb_20211201_models.DeleteSparkTemplateFileRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DeleteSparkTemplateFileResponse:
        """
        @summary Deletes Spark template files.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: DeleteSparkTemplateFileRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DeleteSparkTemplateFileResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.id):
            body['Id'] = request.id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DeleteSparkTemplateFile',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DeleteSparkTemplateFileResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DeleteSparkTemplateFileResponse(),
                await self.execute_async(params, req, runtime)
            )

    def delete_spark_template_file(
        self,
        request: adb_20211201_models.DeleteSparkTemplateFileRequest,
    ) -> adb_20211201_models.DeleteSparkTemplateFileResponse:
        """
        @summary Deletes Spark template files.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: DeleteSparkTemplateFileRequest
        @return: DeleteSparkTemplateFileResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.delete_spark_template_file_with_options(request, runtime)

    async def delete_spark_template_file_async(
        self,
        request: adb_20211201_models.DeleteSparkTemplateFileRequest,
    ) -> adb_20211201_models.DeleteSparkTemplateFileResponse:
        """
        @summary Deletes Spark template files.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: DeleteSparkTemplateFileRequest
        @return: DeleteSparkTemplateFileResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.delete_spark_template_file_with_options_async(request, runtime)

    def describe_apsadbinstances_with_options(
        self,
        request: adb_20211201_models.DescribeAPSADBInstancesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAPSADBInstancesResponse:
        """
        @summary Queries a list of AnalyticDB for MySQL clusters for AnalyticDB Pipeline Service (APS) federated analytics.
        
        @description You can call this operation to query the performance data of a cluster over a time range based on performance metrics. The collection granularity is 30 seconds. This operation allows you to query information about slow queries, such as the SQL query duration, number of scanned rows, and amount of scanned data.
        
        @param request: DescribeAPSADBInstancesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAPSADBInstancesResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAPSADBInstances',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAPSADBInstancesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAPSADBInstancesResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_apsadbinstances_with_options_async(
        self,
        request: adb_20211201_models.DescribeAPSADBInstancesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAPSADBInstancesResponse:
        """
        @summary Queries a list of AnalyticDB for MySQL clusters for AnalyticDB Pipeline Service (APS) federated analytics.
        
        @description You can call this operation to query the performance data of a cluster over a time range based on performance metrics. The collection granularity is 30 seconds. This operation allows you to query information about slow queries, such as the SQL query duration, number of scanned rows, and amount of scanned data.
        
        @param request: DescribeAPSADBInstancesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAPSADBInstancesResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAPSADBInstances',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAPSADBInstancesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAPSADBInstancesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_apsadbinstances(
        self,
        request: adb_20211201_models.DescribeAPSADBInstancesRequest,
    ) -> adb_20211201_models.DescribeAPSADBInstancesResponse:
        """
        @summary Queries a list of AnalyticDB for MySQL clusters for AnalyticDB Pipeline Service (APS) federated analytics.
        
        @description You can call this operation to query the performance data of a cluster over a time range based on performance metrics. The collection granularity is 30 seconds. This operation allows you to query information about slow queries, such as the SQL query duration, number of scanned rows, and amount of scanned data.
        
        @param request: DescribeAPSADBInstancesRequest
        @return: DescribeAPSADBInstancesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_apsadbinstances_with_options(request, runtime)

    async def describe_apsadbinstances_async(
        self,
        request: adb_20211201_models.DescribeAPSADBInstancesRequest,
    ) -> adb_20211201_models.DescribeAPSADBInstancesResponse:
        """
        @summary Queries a list of AnalyticDB for MySQL clusters for AnalyticDB Pipeline Service (APS) federated analytics.
        
        @description You can call this operation to query the performance data of a cluster over a time range based on performance metrics. The collection granularity is 30 seconds. This operation allows you to query information about slow queries, such as the SQL query duration, number of scanned rows, and amount of scanned data.
        
        @param request: DescribeAPSADBInstancesRequest
        @return: DescribeAPSADBInstancesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_apsadbinstances_with_options_async(request, runtime)

    def describe_abnormal_pattern_detection_with_options(
        self,
        request: adb_20211201_models.DescribeAbnormalPatternDetectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAbnormalPatternDetectionResponse:
        """
        @summary Queries abnormal SQL patterns within a time range.
        
        @param request: DescribeAbnormalPatternDetectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAbnormalPatternDetectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAbnormalPatternDetection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAbnormalPatternDetectionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAbnormalPatternDetectionResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_abnormal_pattern_detection_with_options_async(
        self,
        request: adb_20211201_models.DescribeAbnormalPatternDetectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAbnormalPatternDetectionResponse:
        """
        @summary Queries abnormal SQL patterns within a time range.
        
        @param request: DescribeAbnormalPatternDetectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAbnormalPatternDetectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAbnormalPatternDetection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAbnormalPatternDetectionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAbnormalPatternDetectionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_abnormal_pattern_detection(
        self,
        request: adb_20211201_models.DescribeAbnormalPatternDetectionRequest,
    ) -> adb_20211201_models.DescribeAbnormalPatternDetectionResponse:
        """
        @summary Queries abnormal SQL patterns within a time range.
        
        @param request: DescribeAbnormalPatternDetectionRequest
        @return: DescribeAbnormalPatternDetectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_abnormal_pattern_detection_with_options(request, runtime)

    async def describe_abnormal_pattern_detection_async(
        self,
        request: adb_20211201_models.DescribeAbnormalPatternDetectionRequest,
    ) -> adb_20211201_models.DescribeAbnormalPatternDetectionResponse:
        """
        @summary Queries abnormal SQL patterns within a time range.
        
        @param request: DescribeAbnormalPatternDetectionRequest
        @return: DescribeAbnormalPatternDetectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_abnormal_pattern_detection_with_options_async(request, runtime)

    def describe_account_all_privileges_with_options(
        self,
        request: adb_20211201_models.DescribeAccountAllPrivilegesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAccountAllPrivilegesResponse:
        """
        @summary Queries the permissions of a database account on all permission levels.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountAllPrivilegesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAccountAllPrivilegesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.marker):
            query['Marker'] = request.marker
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAccountAllPrivileges',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountAllPrivilegesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountAllPrivilegesResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_account_all_privileges_with_options_async(
        self,
        request: adb_20211201_models.DescribeAccountAllPrivilegesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAccountAllPrivilegesResponse:
        """
        @summary Queries the permissions of a database account on all permission levels.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountAllPrivilegesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAccountAllPrivilegesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.marker):
            query['Marker'] = request.marker
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAccountAllPrivileges',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountAllPrivilegesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountAllPrivilegesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_account_all_privileges(
        self,
        request: adb_20211201_models.DescribeAccountAllPrivilegesRequest,
    ) -> adb_20211201_models.DescribeAccountAllPrivilegesResponse:
        """
        @summary Queries the permissions of a database account on all permission levels.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountAllPrivilegesRequest
        @return: DescribeAccountAllPrivilegesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_account_all_privileges_with_options(request, runtime)

    async def describe_account_all_privileges_async(
        self,
        request: adb_20211201_models.DescribeAccountAllPrivilegesRequest,
    ) -> adb_20211201_models.DescribeAccountAllPrivilegesResponse:
        """
        @summary Queries the permissions of a database account on all permission levels.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountAllPrivilegesRequest
        @return: DescribeAccountAllPrivilegesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_account_all_privileges_with_options_async(request, runtime)

    def describe_account_privilege_objects_with_options(
        self,
        request: adb_20211201_models.DescribeAccountPrivilegeObjectsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAccountPrivilegeObjectsResponse:
        """
        @summary Queries the databases, tables, and columns on which a database account has permissions.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountPrivilegeObjectsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAccountPrivilegeObjectsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.column_privilege_object):
            query['ColumnPrivilegeObject'] = request.column_privilege_object
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.database_privilege_object):
            query['DatabasePrivilegeObject'] = request.database_privilege_object
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.privilege_type):
            query['PrivilegeType'] = request.privilege_type
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.table_privilege_object):
            query['TablePrivilegeObject'] = request.table_privilege_object
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAccountPrivilegeObjects',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountPrivilegeObjectsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountPrivilegeObjectsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_account_privilege_objects_with_options_async(
        self,
        request: adb_20211201_models.DescribeAccountPrivilegeObjectsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAccountPrivilegeObjectsResponse:
        """
        @summary Queries the databases, tables, and columns on which a database account has permissions.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountPrivilegeObjectsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAccountPrivilegeObjectsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.column_privilege_object):
            query['ColumnPrivilegeObject'] = request.column_privilege_object
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.database_privilege_object):
            query['DatabasePrivilegeObject'] = request.database_privilege_object
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.privilege_type):
            query['PrivilegeType'] = request.privilege_type
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.table_privilege_object):
            query['TablePrivilegeObject'] = request.table_privilege_object
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAccountPrivilegeObjects',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountPrivilegeObjectsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountPrivilegeObjectsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_account_privilege_objects(
        self,
        request: adb_20211201_models.DescribeAccountPrivilegeObjectsRequest,
    ) -> adb_20211201_models.DescribeAccountPrivilegeObjectsResponse:
        """
        @summary Queries the databases, tables, and columns on which a database account has permissions.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountPrivilegeObjectsRequest
        @return: DescribeAccountPrivilegeObjectsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_account_privilege_objects_with_options(request, runtime)

    async def describe_account_privilege_objects_async(
        self,
        request: adb_20211201_models.DescribeAccountPrivilegeObjectsRequest,
    ) -> adb_20211201_models.DescribeAccountPrivilegeObjectsResponse:
        """
        @summary Queries the databases, tables, and columns on which a database account has permissions.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountPrivilegeObjectsRequest
        @return: DescribeAccountPrivilegeObjectsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_account_privilege_objects_with_options_async(request, runtime)

    def describe_account_privileges_with_options(
        self,
        request: adb_20211201_models.DescribeAccountPrivilegesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAccountPrivilegesResponse:
        """
        @summary 获取某一ADB账户的权限
        
        @param request: DescribeAccountPrivilegesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAccountPrivilegesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.column_privilege_object):
            query['ColumnPrivilegeObject'] = request.column_privilege_object
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.database_privilege_object):
            query['DatabasePrivilegeObject'] = request.database_privilege_object
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.privilege_type):
            query['PrivilegeType'] = request.privilege_type
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.table_privilege_object):
            query['TablePrivilegeObject'] = request.table_privilege_object
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAccountPrivileges',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountPrivilegesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountPrivilegesResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_account_privileges_with_options_async(
        self,
        request: adb_20211201_models.DescribeAccountPrivilegesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAccountPrivilegesResponse:
        """
        @summary 获取某一ADB账户的权限
        
        @param request: DescribeAccountPrivilegesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAccountPrivilegesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.column_privilege_object):
            query['ColumnPrivilegeObject'] = request.column_privilege_object
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.database_privilege_object):
            query['DatabasePrivilegeObject'] = request.database_privilege_object
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.privilege_type):
            query['PrivilegeType'] = request.privilege_type
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.table_privilege_object):
            query['TablePrivilegeObject'] = request.table_privilege_object
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAccountPrivileges',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountPrivilegesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountPrivilegesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_account_privileges(
        self,
        request: adb_20211201_models.DescribeAccountPrivilegesRequest,
    ) -> adb_20211201_models.DescribeAccountPrivilegesResponse:
        """
        @summary 获取某一ADB账户的权限
        
        @param request: DescribeAccountPrivilegesRequest
        @return: DescribeAccountPrivilegesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_account_privileges_with_options(request, runtime)

    async def describe_account_privileges_async(
        self,
        request: adb_20211201_models.DescribeAccountPrivilegesRequest,
    ) -> adb_20211201_models.DescribeAccountPrivilegesResponse:
        """
        @summary 获取某一ADB账户的权限
        
        @param request: DescribeAccountPrivilegesRequest
        @return: DescribeAccountPrivilegesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_account_privileges_with_options_async(request, runtime)

    def describe_accounts_with_options(
        self,
        request: adb_20211201_models.DescribeAccountsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAccountsResponse:
        """
        @summary Queries the database accounts of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAccountsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAccounts',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_accounts_with_options_async(
        self,
        request: adb_20211201_models.DescribeAccountsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAccountsResponse:
        """
        @summary Queries the database accounts of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAccountsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAccounts',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAccountsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_accounts(
        self,
        request: adb_20211201_models.DescribeAccountsRequest,
    ) -> adb_20211201_models.DescribeAccountsResponse:
        """
        @summary Queries the database accounts of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountsRequest
        @return: DescribeAccountsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_accounts_with_options(request, runtime)

    async def describe_accounts_async(
        self,
        request: adb_20211201_models.DescribeAccountsRequest,
    ) -> adb_20211201_models.DescribeAccountsResponse:
        """
        @summary Queries the database accounts of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAccountsRequest
        @return: DescribeAccountsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_accounts_with_options_async(request, runtime)

    def describe_adb_my_sql_columns_with_options(
        self,
        request: adb_20211201_models.DescribeAdbMySqlColumnsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAdbMySqlColumnsResponse:
        """
        @summary Queries the information about table columns for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlColumnsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAdbMySqlColumnsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema):
            query['Schema'] = request.schema
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAdbMySqlColumns',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlColumnsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlColumnsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_adb_my_sql_columns_with_options_async(
        self,
        request: adb_20211201_models.DescribeAdbMySqlColumnsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAdbMySqlColumnsResponse:
        """
        @summary Queries the information about table columns for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlColumnsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAdbMySqlColumnsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema):
            query['Schema'] = request.schema
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAdbMySqlColumns',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlColumnsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlColumnsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_adb_my_sql_columns(
        self,
        request: adb_20211201_models.DescribeAdbMySqlColumnsRequest,
    ) -> adb_20211201_models.DescribeAdbMySqlColumnsResponse:
        """
        @summary Queries the information about table columns for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlColumnsRequest
        @return: DescribeAdbMySqlColumnsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_adb_my_sql_columns_with_options(request, runtime)

    async def describe_adb_my_sql_columns_async(
        self,
        request: adb_20211201_models.DescribeAdbMySqlColumnsRequest,
    ) -> adb_20211201_models.DescribeAdbMySqlColumnsResponse:
        """
        @summary Queries the information about table columns for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlColumnsRequest
        @return: DescribeAdbMySqlColumnsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_adb_my_sql_columns_with_options_async(request, runtime)

    def describe_adb_my_sql_schemas_with_options(
        self,
        request: adb_20211201_models.DescribeAdbMySqlSchemasRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAdbMySqlSchemasResponse:
        """
        @summary Queries a list of databases for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlSchemasRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAdbMySqlSchemasResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAdbMySqlSchemas',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlSchemasResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlSchemasResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_adb_my_sql_schemas_with_options_async(
        self,
        request: adb_20211201_models.DescribeAdbMySqlSchemasRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAdbMySqlSchemasResponse:
        """
        @summary Queries a list of databases for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlSchemasRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAdbMySqlSchemasResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAdbMySqlSchemas',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlSchemasResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlSchemasResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_adb_my_sql_schemas(
        self,
        request: adb_20211201_models.DescribeAdbMySqlSchemasRequest,
    ) -> adb_20211201_models.DescribeAdbMySqlSchemasResponse:
        """
        @summary Queries a list of databases for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlSchemasRequest
        @return: DescribeAdbMySqlSchemasResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_adb_my_sql_schemas_with_options(request, runtime)

    async def describe_adb_my_sql_schemas_async(
        self,
        request: adb_20211201_models.DescribeAdbMySqlSchemasRequest,
    ) -> adb_20211201_models.DescribeAdbMySqlSchemasResponse:
        """
        @summary Queries a list of databases for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlSchemasRequest
        @return: DescribeAdbMySqlSchemasResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_adb_my_sql_schemas_with_options_async(request, runtime)

    def describe_adb_my_sql_tables_with_options(
        self,
        request: adb_20211201_models.DescribeAdbMySqlTablesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAdbMySqlTablesResponse:
        """
        @summary Queries a list of tables for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlTablesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAdbMySqlTablesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema):
            query['Schema'] = request.schema
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAdbMySqlTables',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlTablesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlTablesResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_adb_my_sql_tables_with_options_async(
        self,
        request: adb_20211201_models.DescribeAdbMySqlTablesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAdbMySqlTablesResponse:
        """
        @summary Queries a list of tables for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlTablesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAdbMySqlTablesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema):
            query['Schema'] = request.schema
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAdbMySqlTables',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlTablesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdbMySqlTablesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_adb_my_sql_tables(
        self,
        request: adb_20211201_models.DescribeAdbMySqlTablesRequest,
    ) -> adb_20211201_models.DescribeAdbMySqlTablesResponse:
        """
        @summary Queries a list of tables for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlTablesRequest
        @return: DescribeAdbMySqlTablesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_adb_my_sql_tables_with_options(request, runtime)

    async def describe_adb_my_sql_tables_async(
        self,
        request: adb_20211201_models.DescribeAdbMySqlTablesRequest,
    ) -> adb_20211201_models.DescribeAdbMySqlTablesResponse:
        """
        @summary Queries a list of tables for an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAdbMySqlTablesRequest
        @return: DescribeAdbMySqlTablesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_adb_my_sql_tables_with_options_async(request, runtime)

    def describe_advice_service_enabled_with_options(
        self,
        request: adb_20211201_models.DescribeAdviceServiceEnabledRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAdviceServiceEnabledResponse:
        """
        @summary Queries whether the suggestion feature is enabled.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAdviceServiceEnabledRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAdviceServiceEnabledResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAdviceServiceEnabled',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdviceServiceEnabledResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdviceServiceEnabledResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_advice_service_enabled_with_options_async(
        self,
        request: adb_20211201_models.DescribeAdviceServiceEnabledRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAdviceServiceEnabledResponse:
        """
        @summary Queries whether the suggestion feature is enabled.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAdviceServiceEnabledRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAdviceServiceEnabledResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAdviceServiceEnabled',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdviceServiceEnabledResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAdviceServiceEnabledResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_advice_service_enabled(
        self,
        request: adb_20211201_models.DescribeAdviceServiceEnabledRequest,
    ) -> adb_20211201_models.DescribeAdviceServiceEnabledResponse:
        """
        @summary Queries whether the suggestion feature is enabled.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAdviceServiceEnabledRequest
        @return: DescribeAdviceServiceEnabledResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_advice_service_enabled_with_options(request, runtime)

    async def describe_advice_service_enabled_async(
        self,
        request: adb_20211201_models.DescribeAdviceServiceEnabledRequest,
    ) -> adb_20211201_models.DescribeAdviceServiceEnabledResponse:
        """
        @summary Queries whether the suggestion feature is enabled.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAdviceServiceEnabledRequest
        @return: DescribeAdviceServiceEnabledResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_advice_service_enabled_with_options_async(request, runtime)

    def describe_all_data_source_with_options(
        self,
        request: adb_20211201_models.DescribeAllDataSourceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAllDataSourceResponse:
        """
        @summary Queries a list of databases, tables, and columns in an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAllDataSourceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAllDataSourceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAllDataSource',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAllDataSourceResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAllDataSourceResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_all_data_source_with_options_async(
        self,
        request: adb_20211201_models.DescribeAllDataSourceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAllDataSourceResponse:
        """
        @summary Queries a list of databases, tables, and columns in an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAllDataSourceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAllDataSourceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAllDataSource',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAllDataSourceResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAllDataSourceResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_all_data_source(
        self,
        request: adb_20211201_models.DescribeAllDataSourceRequest,
    ) -> adb_20211201_models.DescribeAllDataSourceResponse:
        """
        @summary Queries a list of databases, tables, and columns in an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAllDataSourceRequest
        @return: DescribeAllDataSourceResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_all_data_source_with_options(request, runtime)

    async def describe_all_data_source_async(
        self,
        request: adb_20211201_models.DescribeAllDataSourceRequest,
    ) -> adb_20211201_models.DescribeAllDataSourceResponse:
        """
        @summary Queries a list of databases, tables, and columns in an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeAllDataSourceRequest
        @return: DescribeAllDataSourceResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_all_data_source_with_options_async(request, runtime)

    def describe_applied_advices_with_options(
        self,
        request: adb_20211201_models.DescribeAppliedAdvicesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAppliedAdvicesResponse:
        """
        @summary Queries the applied optimization suggestions for an AnalyticDB for MySQL cluster.
        
        @param request: DescribeAppliedAdvicesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAppliedAdvicesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.advice_type):
            query['AdviceType'] = request.advice_type
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_table_name):
            query['SchemaTableName'] = request.schema_table_name
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAppliedAdvices',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAppliedAdvicesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAppliedAdvicesResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_applied_advices_with_options_async(
        self,
        request: adb_20211201_models.DescribeAppliedAdvicesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAppliedAdvicesResponse:
        """
        @summary Queries the applied optimization suggestions for an AnalyticDB for MySQL cluster.
        
        @param request: DescribeAppliedAdvicesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAppliedAdvicesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.advice_type):
            query['AdviceType'] = request.advice_type
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_table_name):
            query['SchemaTableName'] = request.schema_table_name
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAppliedAdvices',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAppliedAdvicesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAppliedAdvicesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_applied_advices(
        self,
        request: adb_20211201_models.DescribeAppliedAdvicesRequest,
    ) -> adb_20211201_models.DescribeAppliedAdvicesResponse:
        """
        @summary Queries the applied optimization suggestions for an AnalyticDB for MySQL cluster.
        
        @param request: DescribeAppliedAdvicesRequest
        @return: DescribeAppliedAdvicesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_applied_advices_with_options(request, runtime)

    async def describe_applied_advices_async(
        self,
        request: adb_20211201_models.DescribeAppliedAdvicesRequest,
    ) -> adb_20211201_models.DescribeAppliedAdvicesResponse:
        """
        @summary Queries the applied optimization suggestions for an AnalyticDB for MySQL cluster.
        
        @param request: DescribeAppliedAdvicesRequest
        @return: DescribeAppliedAdvicesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_applied_advices_with_options_async(request, runtime)

    def describe_aps_action_logs_with_options(
        self,
        request: adb_20211201_models.DescribeApsActionLogsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsActionLogsResponse:
        """
        @summary Queries the logs of a real-time data ingestion job for an AnalyticDB for MySQL cluster.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeApsActionLogsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsActionLogsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.stage):
            query['Stage'] = request.stage
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.state):
            query['State'] = request.state
        if not UtilClient.is_unset(request.workload_id):
            query['WorkloadId'] = request.workload_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeApsActionLogs',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsActionLogsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsActionLogsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_aps_action_logs_with_options_async(
        self,
        request: adb_20211201_models.DescribeApsActionLogsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsActionLogsResponse:
        """
        @summary Queries the logs of a real-time data ingestion job for an AnalyticDB for MySQL cluster.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeApsActionLogsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsActionLogsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.stage):
            query['Stage'] = request.stage
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.state):
            query['State'] = request.state
        if not UtilClient.is_unset(request.workload_id):
            query['WorkloadId'] = request.workload_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeApsActionLogs',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsActionLogsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsActionLogsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_aps_action_logs(
        self,
        request: adb_20211201_models.DescribeApsActionLogsRequest,
    ) -> adb_20211201_models.DescribeApsActionLogsResponse:
        """
        @summary Queries the logs of a real-time data ingestion job for an AnalyticDB for MySQL cluster.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeApsActionLogsRequest
        @return: DescribeApsActionLogsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_aps_action_logs_with_options(request, runtime)

    async def describe_aps_action_logs_async(
        self,
        request: adb_20211201_models.DescribeApsActionLogsRequest,
    ) -> adb_20211201_models.DescribeApsActionLogsResponse:
        """
        @summary Queries the logs of a real-time data ingestion job for an AnalyticDB for MySQL cluster.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeApsActionLogsRequest
        @return: DescribeApsActionLogsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_aps_action_logs_with_options_async(request, runtime)

    def describe_aps_datasource_with_options(
        self,
        request: adb_20211201_models.DescribeApsDatasourceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsDatasourceResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) data source.
        
        @param request: DescribeApsDatasourceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsDatasourceResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsDatasource',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsDatasourceResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsDatasourceResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_aps_datasource_with_options_async(
        self,
        request: adb_20211201_models.DescribeApsDatasourceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsDatasourceResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) data source.
        
        @param request: DescribeApsDatasourceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsDatasourceResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsDatasource',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsDatasourceResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsDatasourceResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_aps_datasource(
        self,
        request: adb_20211201_models.DescribeApsDatasourceRequest,
    ) -> adb_20211201_models.DescribeApsDatasourceResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) data source.
        
        @param request: DescribeApsDatasourceRequest
        @return: DescribeApsDatasourceResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_aps_datasource_with_options(request, runtime)

    async def describe_aps_datasource_async(
        self,
        request: adb_20211201_models.DescribeApsDatasourceRequest,
    ) -> adb_20211201_models.DescribeApsDatasourceResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) data source.
        
        @param request: DescribeApsDatasourceRequest
        @return: DescribeApsDatasourceResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_aps_datasource_with_options_async(request, runtime)

    def describe_aps_datasources_with_options(
        self,
        request: adb_20211201_models.DescribeApsDatasourcesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsDatasourcesResponse:
        """
        @summary Queries a list of AnalyticDB Pipeline Service (APS) data sources.
        
        @param request: DescribeApsDatasourcesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsDatasourcesResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_name):
            body['DatasourceName'] = request.datasource_name
        if not UtilClient.is_unset(request.datasource_type):
            body['DatasourceType'] = request.datasource_type
        if not UtilClient.is_unset(request.end_time):
            body['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            body['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsDatasources',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsDatasourcesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsDatasourcesResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_aps_datasources_with_options_async(
        self,
        request: adb_20211201_models.DescribeApsDatasourcesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsDatasourcesResponse:
        """
        @summary Queries a list of AnalyticDB Pipeline Service (APS) data sources.
        
        @param request: DescribeApsDatasourcesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsDatasourcesResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_name):
            body['DatasourceName'] = request.datasource_name
        if not UtilClient.is_unset(request.datasource_type):
            body['DatasourceType'] = request.datasource_type
        if not UtilClient.is_unset(request.end_time):
            body['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            body['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsDatasources',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsDatasourcesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsDatasourcesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_aps_datasources(
        self,
        request: adb_20211201_models.DescribeApsDatasourcesRequest,
    ) -> adb_20211201_models.DescribeApsDatasourcesResponse:
        """
        @summary Queries a list of AnalyticDB Pipeline Service (APS) data sources.
        
        @param request: DescribeApsDatasourcesRequest
        @return: DescribeApsDatasourcesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_aps_datasources_with_options(request, runtime)

    async def describe_aps_datasources_async(
        self,
        request: adb_20211201_models.DescribeApsDatasourcesRequest,
    ) -> adb_20211201_models.DescribeApsDatasourcesResponse:
        """
        @summary Queries a list of AnalyticDB Pipeline Service (APS) data sources.
        
        @param request: DescribeApsDatasourcesRequest
        @return: DescribeApsDatasourcesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_aps_datasources_with_options_async(request, runtime)

    def describe_aps_hive_workload_with_options(
        self,
        request: adb_20211201_models.DescribeApsHiveWorkloadRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsHiveWorkloadResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) job from a Hive data source.
        
        @param request: DescribeApsHiveWorkloadRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsHiveWorkloadResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsHiveWorkload',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsHiveWorkloadResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsHiveWorkloadResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_aps_hive_workload_with_options_async(
        self,
        request: adb_20211201_models.DescribeApsHiveWorkloadRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsHiveWorkloadResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) job from a Hive data source.
        
        @param request: DescribeApsHiveWorkloadRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsHiveWorkloadResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsHiveWorkload',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsHiveWorkloadResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsHiveWorkloadResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_aps_hive_workload(
        self,
        request: adb_20211201_models.DescribeApsHiveWorkloadRequest,
    ) -> adb_20211201_models.DescribeApsHiveWorkloadResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) job from a Hive data source.
        
        @param request: DescribeApsHiveWorkloadRequest
        @return: DescribeApsHiveWorkloadResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_aps_hive_workload_with_options(request, runtime)

    async def describe_aps_hive_workload_async(
        self,
        request: adb_20211201_models.DescribeApsHiveWorkloadRequest,
    ) -> adb_20211201_models.DescribeApsHiveWorkloadResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) job from a Hive data source.
        
        @param request: DescribeApsHiveWorkloadRequest
        @return: DescribeApsHiveWorkloadResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_aps_hive_workload_with_options_async(request, runtime)

    def describe_aps_job_detail_with_options(
        self,
        request: adb_20211201_models.DescribeApsJobDetailRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsJobDetailResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) job.
        
        @param request: DescribeApsJobDetailRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsJobDetailResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_id):
            body['ApsJobId'] = request.aps_job_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsJobDetail',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsJobDetailResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsJobDetailResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_aps_job_detail_with_options_async(
        self,
        request: adb_20211201_models.DescribeApsJobDetailRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsJobDetailResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) job.
        
        @param request: DescribeApsJobDetailRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsJobDetailResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_id):
            body['ApsJobId'] = request.aps_job_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsJobDetail',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsJobDetailResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsJobDetailResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_aps_job_detail(
        self,
        request: adb_20211201_models.DescribeApsJobDetailRequest,
    ) -> adb_20211201_models.DescribeApsJobDetailResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) job.
        
        @param request: DescribeApsJobDetailRequest
        @return: DescribeApsJobDetailResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_aps_job_detail_with_options(request, runtime)

    async def describe_aps_job_detail_async(
        self,
        request: adb_20211201_models.DescribeApsJobDetailRequest,
    ) -> adb_20211201_models.DescribeApsJobDetailResponse:
        """
        @summary Queries the information about an AnalyticDB Pipeline Service (APS) job.
        
        @param request: DescribeApsJobDetailRequest
        @return: DescribeApsJobDetailResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_aps_job_detail_with_options_async(request, runtime)

    def describe_aps_jobs_with_options(
        self,
        request: adb_20211201_models.DescribeApsJobsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsJobsResponse:
        """
        @summary Queries a list of AnalyticDB Pipeline Service (APS) jobs.
        
        @param request: DescribeApsJobsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsJobsResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_name):
            body['ApsJobName'] = request.aps_job_name
        if not UtilClient.is_unset(request.create_time_end):
            body['CreateTimeEnd'] = request.create_time_end
        if not UtilClient.is_unset(request.create_time_start):
            body['CreateTimeStart'] = request.create_time_start
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsJobs',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsJobsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsJobsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_aps_jobs_with_options_async(
        self,
        request: adb_20211201_models.DescribeApsJobsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsJobsResponse:
        """
        @summary Queries a list of AnalyticDB Pipeline Service (APS) jobs.
        
        @param request: DescribeApsJobsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsJobsResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_name):
            body['ApsJobName'] = request.aps_job_name
        if not UtilClient.is_unset(request.create_time_end):
            body['CreateTimeEnd'] = request.create_time_end
        if not UtilClient.is_unset(request.create_time_start):
            body['CreateTimeStart'] = request.create_time_start
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsJobs',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsJobsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsJobsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_aps_jobs(
        self,
        request: adb_20211201_models.DescribeApsJobsRequest,
    ) -> adb_20211201_models.DescribeApsJobsResponse:
        """
        @summary Queries a list of AnalyticDB Pipeline Service (APS) jobs.
        
        @param request: DescribeApsJobsRequest
        @return: DescribeApsJobsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_aps_jobs_with_options(request, runtime)

    async def describe_aps_jobs_async(
        self,
        request: adb_20211201_models.DescribeApsJobsRequest,
    ) -> adb_20211201_models.DescribeApsJobsResponse:
        """
        @summary Queries a list of AnalyticDB Pipeline Service (APS) jobs.
        
        @param request: DescribeApsJobsRequest
        @return: DescribeApsJobsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_aps_jobs_with_options_async(request, runtime)

    def describe_aps_migration_workloads_with_options(
        self,
        request: adb_20211201_models.DescribeApsMigrationWorkloadsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsMigrationWorkloadsResponse:
        """
        @summary Queries the workloads of AnalyticDB Pipeline Service (APS) migration jobs.
        
        @param request: DescribeApsMigrationWorkloadsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsMigrationWorkloadsResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            body['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.oss_location):
            body['OssLocation'] = request.oss_location
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.start_time):
            body['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.workload_name):
            body['WorkloadName'] = request.workload_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsMigrationWorkloads',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsMigrationWorkloadsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsMigrationWorkloadsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_aps_migration_workloads_with_options_async(
        self,
        request: adb_20211201_models.DescribeApsMigrationWorkloadsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsMigrationWorkloadsResponse:
        """
        @summary Queries the workloads of AnalyticDB Pipeline Service (APS) migration jobs.
        
        @param request: DescribeApsMigrationWorkloadsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsMigrationWorkloadsResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            body['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.oss_location):
            body['OssLocation'] = request.oss_location
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.start_time):
            body['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.workload_name):
            body['WorkloadName'] = request.workload_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsMigrationWorkloads',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsMigrationWorkloadsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsMigrationWorkloadsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_aps_migration_workloads(
        self,
        request: adb_20211201_models.DescribeApsMigrationWorkloadsRequest,
    ) -> adb_20211201_models.DescribeApsMigrationWorkloadsResponse:
        """
        @summary Queries the workloads of AnalyticDB Pipeline Service (APS) migration jobs.
        
        @param request: DescribeApsMigrationWorkloadsRequest
        @return: DescribeApsMigrationWorkloadsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_aps_migration_workloads_with_options(request, runtime)

    async def describe_aps_migration_workloads_async(
        self,
        request: adb_20211201_models.DescribeApsMigrationWorkloadsRequest,
    ) -> adb_20211201_models.DescribeApsMigrationWorkloadsResponse:
        """
        @summary Queries the workloads of AnalyticDB Pipeline Service (APS) migration jobs.
        
        @param request: DescribeApsMigrationWorkloadsRequest
        @return: DescribeApsMigrationWorkloadsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_aps_migration_workloads_with_options_async(request, runtime)

    def describe_aps_progress_with_options(
        self,
        request: adb_20211201_models.DescribeApsProgressRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsProgressResponse:
        """
        @summary Queries the progress of an AnalyticDB Pipeline Service (APS) job.
        
        @param request: DescribeApsProgressRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsProgressResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsProgress',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsProgressResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsProgressResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_aps_progress_with_options_async(
        self,
        request: adb_20211201_models.DescribeApsProgressRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsProgressResponse:
        """
        @summary Queries the progress of an AnalyticDB Pipeline Service (APS) job.
        
        @param request: DescribeApsProgressRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsProgressResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsProgress',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsProgressResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsProgressResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_aps_progress(
        self,
        request: adb_20211201_models.DescribeApsProgressRequest,
    ) -> adb_20211201_models.DescribeApsProgressResponse:
        """
        @summary Queries the progress of an AnalyticDB Pipeline Service (APS) job.
        
        @param request: DescribeApsProgressRequest
        @return: DescribeApsProgressResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_aps_progress_with_options(request, runtime)

    async def describe_aps_progress_async(
        self,
        request: adb_20211201_models.DescribeApsProgressRequest,
    ) -> adb_20211201_models.DescribeApsProgressResponse:
        """
        @summary Queries the progress of an AnalyticDB Pipeline Service (APS) job.
        
        @param request: DescribeApsProgressRequest
        @return: DescribeApsProgressResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_aps_progress_with_options_async(request, runtime)

    def describe_aps_resource_groups_with_options(
        self,
        request: adb_20211201_models.DescribeApsResourceGroupsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsResourceGroupsResponse:
        """
        @summary Queries the information about resource groups of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeApsResourceGroupsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsResourceGroupsResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsResourceGroups',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsResourceGroupsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsResourceGroupsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_aps_resource_groups_with_options_async(
        self,
        request: adb_20211201_models.DescribeApsResourceGroupsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeApsResourceGroupsResponse:
        """
        @summary Queries the information about resource groups of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeApsResourceGroupsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeApsResourceGroupsResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='DescribeApsResourceGroups',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsResourceGroupsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeApsResourceGroupsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_aps_resource_groups(
        self,
        request: adb_20211201_models.DescribeApsResourceGroupsRequest,
    ) -> adb_20211201_models.DescribeApsResourceGroupsResponse:
        """
        @summary Queries the information about resource groups of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeApsResourceGroupsRequest
        @return: DescribeApsResourceGroupsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_aps_resource_groups_with_options(request, runtime)

    async def describe_aps_resource_groups_async(
        self,
        request: adb_20211201_models.DescribeApsResourceGroupsRequest,
    ) -> adb_20211201_models.DescribeApsResourceGroupsResponse:
        """
        @summary Queries the information about resource groups of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeApsResourceGroupsRequest
        @return: DescribeApsResourceGroupsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_aps_resource_groups_with_options_async(request, runtime)

    def describe_audit_log_records_with_options(
        self,
        request: adb_20211201_models.DescribeAuditLogRecordsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAuditLogRecordsResponse:
        """
        @summary Queries the SQL audit logs of an AnalyticDB for MySQL cluster.
        
        @description    SQL audit logs can be queried only when SQL audit is enabled. Only SQL audit logs within the last 30 days can be queried. If SQL audit was disabled and re-enabled, only SQL audit logs from the time when SQL audit was re-enabled can be queried. The following operations are not recorded in SQL audit logs: **INSERT INTO VALUES**, **REPLACE INTO VALUES**, and **UPSERT INTO VALUES**.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAuditLogRecordsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAuditLogRecordsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.dbname):
            query['DBName'] = request.dbname
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.host_address):
            query['HostAddress'] = request.host_address
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.order_type):
            query['OrderType'] = request.order_type
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.proxy_user):
            query['ProxyUser'] = request.proxy_user
        if not UtilClient.is_unset(request.query_keyword):
            query['QueryKeyword'] = request.query_keyword
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.sql_type):
            query['SqlType'] = request.sql_type
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.succeed):
            query['Succeed'] = request.succeed
        if not UtilClient.is_unset(request.user):
            query['User'] = request.user
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAuditLogRecords',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAuditLogRecordsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAuditLogRecordsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_audit_log_records_with_options_async(
        self,
        request: adb_20211201_models.DescribeAuditLogRecordsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAuditLogRecordsResponse:
        """
        @summary Queries the SQL audit logs of an AnalyticDB for MySQL cluster.
        
        @description    SQL audit logs can be queried only when SQL audit is enabled. Only SQL audit logs within the last 30 days can be queried. If SQL audit was disabled and re-enabled, only SQL audit logs from the time when SQL audit was re-enabled can be queried. The following operations are not recorded in SQL audit logs: **INSERT INTO VALUES**, **REPLACE INTO VALUES**, and **UPSERT INTO VALUES**.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAuditLogRecordsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAuditLogRecordsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.dbname):
            query['DBName'] = request.dbname
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.host_address):
            query['HostAddress'] = request.host_address
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.order_type):
            query['OrderType'] = request.order_type
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.proxy_user):
            query['ProxyUser'] = request.proxy_user
        if not UtilClient.is_unset(request.query_keyword):
            query['QueryKeyword'] = request.query_keyword
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.sql_type):
            query['SqlType'] = request.sql_type
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.succeed):
            query['Succeed'] = request.succeed
        if not UtilClient.is_unset(request.user):
            query['User'] = request.user
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAuditLogRecords',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAuditLogRecordsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAuditLogRecordsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_audit_log_records(
        self,
        request: adb_20211201_models.DescribeAuditLogRecordsRequest,
    ) -> adb_20211201_models.DescribeAuditLogRecordsResponse:
        """
        @summary Queries the SQL audit logs of an AnalyticDB for MySQL cluster.
        
        @description    SQL audit logs can be queried only when SQL audit is enabled. Only SQL audit logs within the last 30 days can be queried. If SQL audit was disabled and re-enabled, only SQL audit logs from the time when SQL audit was re-enabled can be queried. The following operations are not recorded in SQL audit logs: **INSERT INTO VALUES**, **REPLACE INTO VALUES**, and **UPSERT INTO VALUES**.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAuditLogRecordsRequest
        @return: DescribeAuditLogRecordsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_audit_log_records_with_options(request, runtime)

    async def describe_audit_log_records_async(
        self,
        request: adb_20211201_models.DescribeAuditLogRecordsRequest,
    ) -> adb_20211201_models.DescribeAuditLogRecordsResponse:
        """
        @summary Queries the SQL audit logs of an AnalyticDB for MySQL cluster.
        
        @description    SQL audit logs can be queried only when SQL audit is enabled. Only SQL audit logs within the last 30 days can be queried. If SQL audit was disabled and re-enabled, only SQL audit logs from the time when SQL audit was re-enabled can be queried. The following operations are not recorded in SQL audit logs: **INSERT INTO VALUES**, **REPLACE INTO VALUES**, and **UPSERT INTO VALUES**.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeAuditLogRecordsRequest
        @return: DescribeAuditLogRecordsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_audit_log_records_with_options_async(request, runtime)

    def describe_available_advices_with_options(
        self,
        request: adb_20211201_models.DescribeAvailableAdvicesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAvailableAdvicesResponse:
        """
        @summary Queries the available optimization suggestions for an AnalyticDB for MySQL cluster.
        
        @param request: DescribeAvailableAdvicesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAvailableAdvicesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.advice_date):
            query['AdviceDate'] = request.advice_date
        if not UtilClient.is_unset(request.advice_type):
            query['AdviceType'] = request.advice_type
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_table_name):
            query['SchemaTableName'] = request.schema_table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAvailableAdvices',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAvailableAdvicesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAvailableAdvicesResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_available_advices_with_options_async(
        self,
        request: adb_20211201_models.DescribeAvailableAdvicesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeAvailableAdvicesResponse:
        """
        @summary Queries the available optimization suggestions for an AnalyticDB for MySQL cluster.
        
        @param request: DescribeAvailableAdvicesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeAvailableAdvicesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.advice_date):
            query['AdviceDate'] = request.advice_date
        if not UtilClient.is_unset(request.advice_type):
            query['AdviceType'] = request.advice_type
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_table_name):
            query['SchemaTableName'] = request.schema_table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeAvailableAdvices',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeAvailableAdvicesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeAvailableAdvicesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_available_advices(
        self,
        request: adb_20211201_models.DescribeAvailableAdvicesRequest,
    ) -> adb_20211201_models.DescribeAvailableAdvicesResponse:
        """
        @summary Queries the available optimization suggestions for an AnalyticDB for MySQL cluster.
        
        @param request: DescribeAvailableAdvicesRequest
        @return: DescribeAvailableAdvicesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_available_advices_with_options(request, runtime)

    async def describe_available_advices_async(
        self,
        request: adb_20211201_models.DescribeAvailableAdvicesRequest,
    ) -> adb_20211201_models.DescribeAvailableAdvicesResponse:
        """
        @summary Queries the available optimization suggestions for an AnalyticDB for MySQL cluster.
        
        @param request: DescribeAvailableAdvicesRequest
        @return: DescribeAvailableAdvicesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_available_advices_with_options_async(request, runtime)

    def describe_backup_policy_with_options(
        self,
        request: adb_20211201_models.DescribeBackupPolicyRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeBackupPolicyResponse:
        """
        @summary 查看集群备份设置
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeBackupPolicyRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeBackupPolicyResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeBackupPolicy',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeBackupPolicyResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeBackupPolicyResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_backup_policy_with_options_async(
        self,
        request: adb_20211201_models.DescribeBackupPolicyRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeBackupPolicyResponse:
        """
        @summary 查看集群备份设置
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeBackupPolicyRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeBackupPolicyResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeBackupPolicy',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeBackupPolicyResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeBackupPolicyResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_backup_policy(
        self,
        request: adb_20211201_models.DescribeBackupPolicyRequest,
    ) -> adb_20211201_models.DescribeBackupPolicyResponse:
        """
        @summary 查看集群备份设置
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeBackupPolicyRequest
        @return: DescribeBackupPolicyResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_backup_policy_with_options(request, runtime)

    async def describe_backup_policy_async(
        self,
        request: adb_20211201_models.DescribeBackupPolicyRequest,
    ) -> adb_20211201_models.DescribeBackupPolicyResponse:
        """
        @summary 查看集群备份设置
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeBackupPolicyRequest
        @return: DescribeBackupPolicyResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_backup_policy_with_options_async(request, runtime)

    def describe_backups_with_options(
        self,
        request: adb_20211201_models.DescribeBackupsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeBackupsResponse:
        """
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeBackupsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeBackupsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.backup_id):
            query['BackupId'] = request.backup_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeBackups',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeBackupsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeBackupsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_backups_with_options_async(
        self,
        request: adb_20211201_models.DescribeBackupsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeBackupsResponse:
        """
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeBackupsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeBackupsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.backup_id):
            query['BackupId'] = request.backup_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeBackups',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeBackupsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeBackupsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_backups(
        self,
        request: adb_20211201_models.DescribeBackupsRequest,
    ) -> adb_20211201_models.DescribeBackupsResponse:
        """
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeBackupsRequest
        @return: DescribeBackupsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_backups_with_options(request, runtime)

    async def describe_backups_async(
        self,
        request: adb_20211201_models.DescribeBackupsRequest,
    ) -> adb_20211201_models.DescribeBackupsResponse:
        """
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeBackupsRequest
        @return: DescribeBackupsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_backups_with_options_async(request, runtime)

    def describe_bad_sql_detection_with_options(
        self,
        request: adb_20211201_models.DescribeBadSqlDetectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeBadSqlDetectionResponse:
        """
        @summary Queries the bad SQL statements that affect cluster stability within a time range.
        
        @param request: DescribeBadSqlDetectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeBadSqlDetectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeBadSqlDetection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeBadSqlDetectionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeBadSqlDetectionResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_bad_sql_detection_with_options_async(
        self,
        request: adb_20211201_models.DescribeBadSqlDetectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeBadSqlDetectionResponse:
        """
        @summary Queries the bad SQL statements that affect cluster stability within a time range.
        
        @param request: DescribeBadSqlDetectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeBadSqlDetectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeBadSqlDetection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeBadSqlDetectionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeBadSqlDetectionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_bad_sql_detection(
        self,
        request: adb_20211201_models.DescribeBadSqlDetectionRequest,
    ) -> adb_20211201_models.DescribeBadSqlDetectionResponse:
        """
        @summary Queries the bad SQL statements that affect cluster stability within a time range.
        
        @param request: DescribeBadSqlDetectionRequest
        @return: DescribeBadSqlDetectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_bad_sql_detection_with_options(request, runtime)

    async def describe_bad_sql_detection_async(
        self,
        request: adb_20211201_models.DescribeBadSqlDetectionRequest,
    ) -> adb_20211201_models.DescribeBadSqlDetectionResponse:
        """
        @summary Queries the bad SQL statements that affect cluster stability within a time range.
        
        @param request: DescribeBadSqlDetectionRequest
        @return: DescribeBadSqlDetectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_bad_sql_detection_with_options_async(request, runtime)

    def describe_cluster_access_white_list_with_options(
        self,
        request: adb_20211201_models.DescribeClusterAccessWhiteListRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeClusterAccessWhiteListResponse:
        """
        @summary Queries the IP address whitelists of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterAccessWhiteListRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeClusterAccessWhiteListResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeClusterAccessWhiteList',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterAccessWhiteListResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterAccessWhiteListResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_cluster_access_white_list_with_options_async(
        self,
        request: adb_20211201_models.DescribeClusterAccessWhiteListRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeClusterAccessWhiteListResponse:
        """
        @summary Queries the IP address whitelists of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterAccessWhiteListRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeClusterAccessWhiteListResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeClusterAccessWhiteList',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterAccessWhiteListResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterAccessWhiteListResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_cluster_access_white_list(
        self,
        request: adb_20211201_models.DescribeClusterAccessWhiteListRequest,
    ) -> adb_20211201_models.DescribeClusterAccessWhiteListResponse:
        """
        @summary Queries the IP address whitelists of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterAccessWhiteListRequest
        @return: DescribeClusterAccessWhiteListResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_cluster_access_white_list_with_options(request, runtime)

    async def describe_cluster_access_white_list_async(
        self,
        request: adb_20211201_models.DescribeClusterAccessWhiteListRequest,
    ) -> adb_20211201_models.DescribeClusterAccessWhiteListResponse:
        """
        @summary Queries the IP address whitelists of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterAccessWhiteListRequest
        @return: DescribeClusterAccessWhiteListResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_cluster_access_white_list_with_options_async(request, runtime)

    def describe_cluster_net_info_with_options(
        self,
        request: adb_20211201_models.DescribeClusterNetInfoRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeClusterNetInfoResponse:
        """
        @summary Queries the network information about an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterNetInfoRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeClusterNetInfoResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeClusterNetInfo',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterNetInfoResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterNetInfoResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_cluster_net_info_with_options_async(
        self,
        request: adb_20211201_models.DescribeClusterNetInfoRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeClusterNetInfoResponse:
        """
        @summary Queries the network information about an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterNetInfoRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeClusterNetInfoResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeClusterNetInfo',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterNetInfoResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterNetInfoResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_cluster_net_info(
        self,
        request: adb_20211201_models.DescribeClusterNetInfoRequest,
    ) -> adb_20211201_models.DescribeClusterNetInfoResponse:
        """
        @summary Queries the network information about an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterNetInfoRequest
        @return: DescribeClusterNetInfoResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_cluster_net_info_with_options(request, runtime)

    async def describe_cluster_net_info_async(
        self,
        request: adb_20211201_models.DescribeClusterNetInfoRequest,
    ) -> adb_20211201_models.DescribeClusterNetInfoResponse:
        """
        @summary Queries the network information about an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterNetInfoRequest
        @return: DescribeClusterNetInfoResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_cluster_net_info_with_options_async(request, runtime)

    def describe_cluster_resource_detail_with_options(
        self,
        request: adb_20211201_models.DescribeClusterResourceDetailRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeClusterResourceDetailResponse:
        """
        @summary Queries the information about resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterResourceDetailRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeClusterResourceDetailResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeClusterResourceDetail',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterResourceDetailResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterResourceDetailResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_cluster_resource_detail_with_options_async(
        self,
        request: adb_20211201_models.DescribeClusterResourceDetailRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeClusterResourceDetailResponse:
        """
        @summary Queries the information about resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterResourceDetailRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeClusterResourceDetailResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeClusterResourceDetail',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterResourceDetailResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterResourceDetailResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_cluster_resource_detail(
        self,
        request: adb_20211201_models.DescribeClusterResourceDetailRequest,
    ) -> adb_20211201_models.DescribeClusterResourceDetailResponse:
        """
        @summary Queries the information about resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterResourceDetailRequest
        @return: DescribeClusterResourceDetailResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_cluster_resource_detail_with_options(request, runtime)

    async def describe_cluster_resource_detail_async(
        self,
        request: adb_20211201_models.DescribeClusterResourceDetailRequest,
    ) -> adb_20211201_models.DescribeClusterResourceDetailResponse:
        """
        @summary Queries the information about resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterResourceDetailRequest
        @return: DescribeClusterResourceDetailResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_cluster_resource_detail_with_options_async(request, runtime)

    def describe_cluster_resource_usage_with_options(
        self,
        request: adb_20211201_models.DescribeClusterResourceUsageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeClusterResourceUsageResponse:
        """
        @summary Queries the resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterResourceUsageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeClusterResourceUsageResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeClusterResourceUsage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterResourceUsageResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterResourceUsageResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_cluster_resource_usage_with_options_async(
        self,
        request: adb_20211201_models.DescribeClusterResourceUsageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeClusterResourceUsageResponse:
        """
        @summary Queries the resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterResourceUsageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeClusterResourceUsageResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeClusterResourceUsage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterResourceUsageResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeClusterResourceUsageResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_cluster_resource_usage(
        self,
        request: adb_20211201_models.DescribeClusterResourceUsageRequest,
    ) -> adb_20211201_models.DescribeClusterResourceUsageResponse:
        """
        @summary Queries the resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterResourceUsageRequest
        @return: DescribeClusterResourceUsageResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_cluster_resource_usage_with_options(request, runtime)

    async def describe_cluster_resource_usage_async(
        self,
        request: adb_20211201_models.DescribeClusterResourceUsageRequest,
    ) -> adb_20211201_models.DescribeClusterResourceUsageResponse:
        """
        @summary Queries the resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeClusterResourceUsageRequest
        @return: DescribeClusterResourceUsageResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_cluster_resource_usage_with_options_async(request, runtime)

    def describe_columns_with_options(
        self,
        request: adb_20211201_models.DescribeColumnsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeColumnsResponse:
        """
        @summary Queries a list of columns in a table.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeColumnsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeColumnsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeColumns',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeColumnsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeColumnsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_columns_with_options_async(
        self,
        request: adb_20211201_models.DescribeColumnsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeColumnsResponse:
        """
        @summary Queries a list of columns in a table.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeColumnsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeColumnsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeColumns',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeColumnsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeColumnsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_columns(
        self,
        request: adb_20211201_models.DescribeColumnsRequest,
    ) -> adb_20211201_models.DescribeColumnsResponse:
        """
        @summary Queries a list of columns in a table.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeColumnsRequest
        @return: DescribeColumnsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_columns_with_options(request, runtime)

    async def describe_columns_async(
        self,
        request: adb_20211201_models.DescribeColumnsRequest,
    ) -> adb_20211201_models.DescribeColumnsResponse:
        """
        @summary Queries a list of columns in a table.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeColumnsRequest
        @return: DescribeColumnsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_columns_with_options_async(request, runtime)

    def describe_compaction_service_switch_with_options(
        self,
        request: adb_20211201_models.DescribeCompactionServiceSwitchRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeCompactionServiceSwitchResponse:
        """
        @summary Queries whether the remote build feature is enabled in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeCompactionServiceSwitchRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeCompactionServiceSwitchResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeCompactionServiceSwitch',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeCompactionServiceSwitchResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeCompactionServiceSwitchResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_compaction_service_switch_with_options_async(
        self,
        request: adb_20211201_models.DescribeCompactionServiceSwitchRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeCompactionServiceSwitchResponse:
        """
        @summary Queries whether the remote build feature is enabled in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeCompactionServiceSwitchRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeCompactionServiceSwitchResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeCompactionServiceSwitch',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeCompactionServiceSwitchResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeCompactionServiceSwitchResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_compaction_service_switch(
        self,
        request: adb_20211201_models.DescribeCompactionServiceSwitchRequest,
    ) -> adb_20211201_models.DescribeCompactionServiceSwitchResponse:
        """
        @summary Queries whether the remote build feature is enabled in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeCompactionServiceSwitchRequest
        @return: DescribeCompactionServiceSwitchResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_compaction_service_switch_with_options(request, runtime)

    async def describe_compaction_service_switch_async(
        self,
        request: adb_20211201_models.DescribeCompactionServiceSwitchRequest,
    ) -> adb_20211201_models.DescribeCompactionServiceSwitchResponse:
        """
        @summary Queries whether the remote build feature is enabled in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeCompactionServiceSwitchRequest
        @return: DescribeCompactionServiceSwitchResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_compaction_service_switch_with_options_async(request, runtime)

    def describe_compute_resource_usage_with_options(
        self,
        request: adb_20211201_models.DescribeComputeResourceUsageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeComputeResourceUsageResponse:
        """
        @summary Queries the computing resource usage of a resource group in an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeComputeResourceUsageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeComputeResourceUsageResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeComputeResourceUsage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeComputeResourceUsageResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeComputeResourceUsageResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_compute_resource_usage_with_options_async(
        self,
        request: adb_20211201_models.DescribeComputeResourceUsageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeComputeResourceUsageResponse:
        """
        @summary Queries the computing resource usage of a resource group in an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeComputeResourceUsageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeComputeResourceUsageResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeComputeResourceUsage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeComputeResourceUsageResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeComputeResourceUsageResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_compute_resource_usage(
        self,
        request: adb_20211201_models.DescribeComputeResourceUsageRequest,
    ) -> adb_20211201_models.DescribeComputeResourceUsageResponse:
        """
        @summary Queries the computing resource usage of a resource group in an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeComputeResourceUsageRequest
        @return: DescribeComputeResourceUsageResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_compute_resource_usage_with_options(request, runtime)

    async def describe_compute_resource_usage_async(
        self,
        request: adb_20211201_models.DescribeComputeResourceUsageRequest,
    ) -> adb_20211201_models.DescribeComputeResourceUsageResponse:
        """
        @summary Queries the computing resource usage of a resource group in an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeComputeResourceUsageRequest
        @return: DescribeComputeResourceUsageResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_compute_resource_usage_with_options_async(request, runtime)

    def describe_controller_detection_with_options(
        self,
        request: adb_20211201_models.DescribeControllerDetectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeControllerDetectionResponse:
        """
        @summary Queries the diagnostic results of the access layer.
        
        @param request: DescribeControllerDetectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeControllerDetectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeControllerDetection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeControllerDetectionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeControllerDetectionResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_controller_detection_with_options_async(
        self,
        request: adb_20211201_models.DescribeControllerDetectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeControllerDetectionResponse:
        """
        @summary Queries the diagnostic results of the access layer.
        
        @param request: DescribeControllerDetectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeControllerDetectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeControllerDetection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeControllerDetectionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeControllerDetectionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_controller_detection(
        self,
        request: adb_20211201_models.DescribeControllerDetectionRequest,
    ) -> adb_20211201_models.DescribeControllerDetectionResponse:
        """
        @summary Queries the diagnostic results of the access layer.
        
        @param request: DescribeControllerDetectionRequest
        @return: DescribeControllerDetectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_controller_detection_with_options(request, runtime)

    async def describe_controller_detection_async(
        self,
        request: adb_20211201_models.DescribeControllerDetectionRequest,
    ) -> adb_20211201_models.DescribeControllerDetectionResponse:
        """
        @summary Queries the diagnostic results of the access layer.
        
        @param request: DescribeControllerDetectionRequest
        @return: DescribeControllerDetectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_controller_detection_with_options_async(request, runtime)

    def describe_dbcluster_attribute_with_options(
        self,
        request: adb_20211201_models.DescribeDBClusterAttributeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClusterAttributeResponse:
        """
        @summary Queries the information about an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterAttributeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClusterAttributeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusterAttribute',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterAttributeResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterAttributeResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_dbcluster_attribute_with_options_async(
        self,
        request: adb_20211201_models.DescribeDBClusterAttributeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClusterAttributeResponse:
        """
        @summary Queries the information about an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterAttributeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClusterAttributeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusterAttribute',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterAttributeResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterAttributeResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_dbcluster_attribute(
        self,
        request: adb_20211201_models.DescribeDBClusterAttributeRequest,
    ) -> adb_20211201_models.DescribeDBClusterAttributeResponse:
        """
        @summary Queries the information about an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterAttributeRequest
        @return: DescribeDBClusterAttributeResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_dbcluster_attribute_with_options(request, runtime)

    async def describe_dbcluster_attribute_async(
        self,
        request: adb_20211201_models.DescribeDBClusterAttributeRequest,
    ) -> adb_20211201_models.DescribeDBClusterAttributeResponse:
        """
        @summary Queries the information about an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterAttributeRequest
        @return: DescribeDBClusterAttributeResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_dbcluster_attribute_with_options_async(request, runtime)

    def describe_dbcluster_health_status_with_options(
        self,
        request: adb_20211201_models.DescribeDBClusterHealthStatusRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClusterHealthStatusResponse:
        """
        @summary Queries the health status of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterHealthStatusRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClusterHealthStatusResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusterHealthStatus',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterHealthStatusResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterHealthStatusResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_dbcluster_health_status_with_options_async(
        self,
        request: adb_20211201_models.DescribeDBClusterHealthStatusRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClusterHealthStatusResponse:
        """
        @summary Queries the health status of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterHealthStatusRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClusterHealthStatusResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusterHealthStatus',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterHealthStatusResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterHealthStatusResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_dbcluster_health_status(
        self,
        request: adb_20211201_models.DescribeDBClusterHealthStatusRequest,
    ) -> adb_20211201_models.DescribeDBClusterHealthStatusResponse:
        """
        @summary Queries the health status of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterHealthStatusRequest
        @return: DescribeDBClusterHealthStatusResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_dbcluster_health_status_with_options(request, runtime)

    async def describe_dbcluster_health_status_async(
        self,
        request: adb_20211201_models.DescribeDBClusterHealthStatusRequest,
    ) -> adb_20211201_models.DescribeDBClusterHealthStatusResponse:
        """
        @summary Queries the health status of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterHealthStatusRequest
        @return: DescribeDBClusterHealthStatusResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_dbcluster_health_status_with_options_async(request, runtime)

    def describe_dbcluster_performance_with_options(
        self,
        request: adb_20211201_models.DescribeDBClusterPerformanceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClusterPerformanceResponse:
        """
        @summary Queries the performance data of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterPerformanceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClusterPerformanceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.key):
            query['Key'] = request.key
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_pools):
            query['ResourcePools'] = request.resource_pools
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusterPerformance',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterPerformanceResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterPerformanceResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_dbcluster_performance_with_options_async(
        self,
        request: adb_20211201_models.DescribeDBClusterPerformanceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClusterPerformanceResponse:
        """
        @summary Queries the performance data of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterPerformanceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClusterPerformanceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.key):
            query['Key'] = request.key
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_pools):
            query['ResourcePools'] = request.resource_pools
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusterPerformance',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterPerformanceResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterPerformanceResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_dbcluster_performance(
        self,
        request: adb_20211201_models.DescribeDBClusterPerformanceRequest,
    ) -> adb_20211201_models.DescribeDBClusterPerformanceResponse:
        """
        @summary Queries the performance data of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterPerformanceRequest
        @return: DescribeDBClusterPerformanceResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_dbcluster_performance_with_options(request, runtime)

    async def describe_dbcluster_performance_async(
        self,
        request: adb_20211201_models.DescribeDBClusterPerformanceRequest,
    ) -> adb_20211201_models.DescribeDBClusterPerformanceResponse:
        """
        @summary Queries the performance data of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterPerformanceRequest
        @return: DescribeDBClusterPerformanceResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_dbcluster_performance_with_options_async(request, runtime)

    def describe_dbcluster_space_summary_with_options(
        self,
        request: adb_20211201_models.DescribeDBClusterSpaceSummaryRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClusterSpaceSummaryResponse:
        """
        @summary Queries the storage overview information of an AnalyticDB for MySQL cluster, such as the total data size, hot data size, cold data size, and data growth.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterSpaceSummaryRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClusterSpaceSummaryResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusterSpaceSummary',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterSpaceSummaryResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterSpaceSummaryResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_dbcluster_space_summary_with_options_async(
        self,
        request: adb_20211201_models.DescribeDBClusterSpaceSummaryRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClusterSpaceSummaryResponse:
        """
        @summary Queries the storage overview information of an AnalyticDB for MySQL cluster, such as the total data size, hot data size, cold data size, and data growth.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterSpaceSummaryRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClusterSpaceSummaryResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusterSpaceSummary',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterSpaceSummaryResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterSpaceSummaryResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_dbcluster_space_summary(
        self,
        request: adb_20211201_models.DescribeDBClusterSpaceSummaryRequest,
    ) -> adb_20211201_models.DescribeDBClusterSpaceSummaryResponse:
        """
        @summary Queries the storage overview information of an AnalyticDB for MySQL cluster, such as the total data size, hot data size, cold data size, and data growth.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterSpaceSummaryRequest
        @return: DescribeDBClusterSpaceSummaryResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_dbcluster_space_summary_with_options(request, runtime)

    async def describe_dbcluster_space_summary_async(
        self,
        request: adb_20211201_models.DescribeDBClusterSpaceSummaryRequest,
    ) -> adb_20211201_models.DescribeDBClusterSpaceSummaryResponse:
        """
        @summary Queries the storage overview information of an AnalyticDB for MySQL cluster, such as the total data size, hot data size, cold data size, and data growth.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterSpaceSummaryRequest
        @return: DescribeDBClusterSpaceSummaryResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_dbcluster_space_summary_with_options_async(request, runtime)

    def describe_dbcluster_status_with_options(
        self,
        request: adb_20211201_models.DescribeDBClusterStatusRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClusterStatusResponse:
        """
        @summary Queries the statuses of AnalyticDB for MySQL clusters within a region.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterStatusRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClusterStatusResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusterStatus',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterStatusResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterStatusResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_dbcluster_status_with_options_async(
        self,
        request: adb_20211201_models.DescribeDBClusterStatusRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClusterStatusResponse:
        """
        @summary Queries the statuses of AnalyticDB for MySQL clusters within a region.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterStatusRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClusterStatusResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusterStatus',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterStatusResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClusterStatusResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_dbcluster_status(
        self,
        request: adb_20211201_models.DescribeDBClusterStatusRequest,
    ) -> adb_20211201_models.DescribeDBClusterStatusResponse:
        """
        @summary Queries the statuses of AnalyticDB for MySQL clusters within a region.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterStatusRequest
        @return: DescribeDBClusterStatusResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_dbcluster_status_with_options(request, runtime)

    async def describe_dbcluster_status_async(
        self,
        request: adb_20211201_models.DescribeDBClusterStatusRequest,
    ) -> adb_20211201_models.DescribeDBClusterStatusResponse:
        """
        @summary Queries the statuses of AnalyticDB for MySQL clusters within a region.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClusterStatusRequest
        @return: DescribeDBClusterStatusResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_dbcluster_status_with_options_async(request, runtime)

    def describe_dbclusters_with_options(
        self,
        request: adb_20211201_models.DescribeDBClustersRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClustersResponse:
        """
        @summary Queries the information about AnalyticDB for MySQL Data Lakehouse Edition clusters within a region.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClustersRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClustersResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_description):
            query['DBClusterDescription'] = request.dbcluster_description
        if not UtilClient.is_unset(request.dbcluster_ids):
            query['DBClusterIds'] = request.dbcluster_ids
        if not UtilClient.is_unset(request.dbcluster_status):
            query['DBClusterStatus'] = request.dbcluster_status
        if not UtilClient.is_unset(request.dbcluster_version):
            query['DBClusterVersion'] = request.dbcluster_version
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.product_version):
            query['ProductVersion'] = request.product_version
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group_id):
            query['ResourceGroupId'] = request.resource_group_id
        if not UtilClient.is_unset(request.tag):
            query['Tag'] = request.tag
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusters',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClustersResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClustersResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_dbclusters_with_options_async(
        self,
        request: adb_20211201_models.DescribeDBClustersRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBClustersResponse:
        """
        @summary Queries the information about AnalyticDB for MySQL Data Lakehouse Edition clusters within a region.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClustersRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBClustersResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_description):
            query['DBClusterDescription'] = request.dbcluster_description
        if not UtilClient.is_unset(request.dbcluster_ids):
            query['DBClusterIds'] = request.dbcluster_ids
        if not UtilClient.is_unset(request.dbcluster_status):
            query['DBClusterStatus'] = request.dbcluster_status
        if not UtilClient.is_unset(request.dbcluster_version):
            query['DBClusterVersion'] = request.dbcluster_version
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.product_version):
            query['ProductVersion'] = request.product_version
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group_id):
            query['ResourceGroupId'] = request.resource_group_id
        if not UtilClient.is_unset(request.tag):
            query['Tag'] = request.tag
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBClusters',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClustersResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBClustersResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_dbclusters(
        self,
        request: adb_20211201_models.DescribeDBClustersRequest,
    ) -> adb_20211201_models.DescribeDBClustersResponse:
        """
        @summary Queries the information about AnalyticDB for MySQL Data Lakehouse Edition clusters within a region.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClustersRequest
        @return: DescribeDBClustersResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_dbclusters_with_options(request, runtime)

    async def describe_dbclusters_async(
        self,
        request: adb_20211201_models.DescribeDBClustersRequest,
    ) -> adb_20211201_models.DescribeDBClustersResponse:
        """
        @summary Queries the information about AnalyticDB for MySQL Data Lakehouse Edition clusters within a region.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBClustersRequest
        @return: DescribeDBClustersResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_dbclusters_with_options_async(request, runtime)

    def describe_dbresource_group_with_options(
        self,
        request: adb_20211201_models.DescribeDBResourceGroupRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBResourceGroupResponse:
        """
        @summary Queries the information about resource groups of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBResourceGroupRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBResourceGroupResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        if not UtilClient.is_unset(request.group_type):
            query['GroupType'] = request.group_type
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBResourceGroup',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBResourceGroupResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBResourceGroupResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_dbresource_group_with_options_async(
        self,
        request: adb_20211201_models.DescribeDBResourceGroupRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDBResourceGroupResponse:
        """
        @summary Queries the information about resource groups of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBResourceGroupRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDBResourceGroupResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        if not UtilClient.is_unset(request.group_type):
            query['GroupType'] = request.group_type
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDBResourceGroup',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBResourceGroupResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDBResourceGroupResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_dbresource_group(
        self,
        request: adb_20211201_models.DescribeDBResourceGroupRequest,
    ) -> adb_20211201_models.DescribeDBResourceGroupResponse:
        """
        @summary Queries the information about resource groups of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBResourceGroupRequest
        @return: DescribeDBResourceGroupResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_dbresource_group_with_options(request, runtime)

    async def describe_dbresource_group_async(
        self,
        request: adb_20211201_models.DescribeDBResourceGroupRequest,
    ) -> adb_20211201_models.DescribeDBResourceGroupResponse:
        """
        @summary Queries the information about resource groups of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeDBResourceGroupRequest
        @return: DescribeDBResourceGroupResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_dbresource_group_with_options_async(request, runtime)

    def describe_diagnosis_dimensions_with_options(
        self,
        request: adb_20211201_models.DescribeDiagnosisDimensionsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDiagnosisDimensionsResponse:
        """
        @summary Queries the deduplicated statistics of resource groups, databases, usernames, and source IP addresses about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisDimensionsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDiagnosisDimensionsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.query_condition):
            query['QueryCondition'] = request.query_condition
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDiagnosisDimensions',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisDimensionsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisDimensionsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_diagnosis_dimensions_with_options_async(
        self,
        request: adb_20211201_models.DescribeDiagnosisDimensionsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDiagnosisDimensionsResponse:
        """
        @summary Queries the deduplicated statistics of resource groups, databases, usernames, and source IP addresses about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisDimensionsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDiagnosisDimensionsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.query_condition):
            query['QueryCondition'] = request.query_condition
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDiagnosisDimensions',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisDimensionsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisDimensionsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_diagnosis_dimensions(
        self,
        request: adb_20211201_models.DescribeDiagnosisDimensionsRequest,
    ) -> adb_20211201_models.DescribeDiagnosisDimensionsResponse:
        """
        @summary Queries the deduplicated statistics of resource groups, databases, usernames, and source IP addresses about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisDimensionsRequest
        @return: DescribeDiagnosisDimensionsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_diagnosis_dimensions_with_options(request, runtime)

    async def describe_diagnosis_dimensions_async(
        self,
        request: adb_20211201_models.DescribeDiagnosisDimensionsRequest,
    ) -> adb_20211201_models.DescribeDiagnosisDimensionsResponse:
        """
        @summary Queries the deduplicated statistics of resource groups, databases, usernames, and source IP addresses about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisDimensionsRequest
        @return: DescribeDiagnosisDimensionsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_diagnosis_dimensions_with_options_async(request, runtime)

    def describe_diagnosis_records_with_options(
        self,
        request: adb_20211201_models.DescribeDiagnosisRecordsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDiagnosisRecordsResponse:
        """
        @summary Queries the diagnostic information about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisRecordsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDiagnosisRecordsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.client_ip):
            query['ClientIp'] = request.client_ip
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.database):
            query['Database'] = request.database
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.max_peak_memory):
            query['MaxPeakMemory'] = request.max_peak_memory
        if not UtilClient.is_unset(request.max_scan_size):
            query['MaxScanSize'] = request.max_scan_size
        if not UtilClient.is_unset(request.min_peak_memory):
            query['MinPeakMemory'] = request.min_peak_memory
        if not UtilClient.is_unset(request.min_scan_size):
            query['MinScanSize'] = request.min_scan_size
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.pattern_id):
            query['PatternId'] = request.pattern_id
        if not UtilClient.is_unset(request.query_condition):
            query['QueryCondition'] = request.query_condition
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            query['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.user_name):
            query['UserName'] = request.user_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDiagnosisRecords',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisRecordsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisRecordsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_diagnosis_records_with_options_async(
        self,
        request: adb_20211201_models.DescribeDiagnosisRecordsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDiagnosisRecordsResponse:
        """
        @summary Queries the diagnostic information about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisRecordsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDiagnosisRecordsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.client_ip):
            query['ClientIp'] = request.client_ip
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.database):
            query['Database'] = request.database
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.max_peak_memory):
            query['MaxPeakMemory'] = request.max_peak_memory
        if not UtilClient.is_unset(request.max_scan_size):
            query['MaxScanSize'] = request.max_scan_size
        if not UtilClient.is_unset(request.min_peak_memory):
            query['MinPeakMemory'] = request.min_peak_memory
        if not UtilClient.is_unset(request.min_scan_size):
            query['MinScanSize'] = request.min_scan_size
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.pattern_id):
            query['PatternId'] = request.pattern_id
        if not UtilClient.is_unset(request.query_condition):
            query['QueryCondition'] = request.query_condition
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            query['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.user_name):
            query['UserName'] = request.user_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDiagnosisRecords',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisRecordsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisRecordsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_diagnosis_records(
        self,
        request: adb_20211201_models.DescribeDiagnosisRecordsRequest,
    ) -> adb_20211201_models.DescribeDiagnosisRecordsResponse:
        """
        @summary Queries the diagnostic information about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisRecordsRequest
        @return: DescribeDiagnosisRecordsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_diagnosis_records_with_options(request, runtime)

    async def describe_diagnosis_records_async(
        self,
        request: adb_20211201_models.DescribeDiagnosisRecordsRequest,
    ) -> adb_20211201_models.DescribeDiagnosisRecordsResponse:
        """
        @summary Queries the diagnostic information about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisRecordsRequest
        @return: DescribeDiagnosisRecordsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_diagnosis_records_with_options_async(request, runtime)

    def describe_diagnosis_sqlinfo_with_options(
        self,
        request: adb_20211201_models.DescribeDiagnosisSQLInfoRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDiagnosisSQLInfoResponse:
        """
        @summary Queries the execution information about an SQL statement, including the execution plan, execution information, resource usage, and self-diagnostics results.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisSQLInfoRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDiagnosisSQLInfoResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDiagnosisSQLInfo',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisSQLInfoResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisSQLInfoResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_diagnosis_sqlinfo_with_options_async(
        self,
        request: adb_20211201_models.DescribeDiagnosisSQLInfoRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDiagnosisSQLInfoResponse:
        """
        @summary Queries the execution information about an SQL statement, including the execution plan, execution information, resource usage, and self-diagnostics results.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisSQLInfoRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDiagnosisSQLInfoResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDiagnosisSQLInfo',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisSQLInfoResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDiagnosisSQLInfoResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_diagnosis_sqlinfo(
        self,
        request: adb_20211201_models.DescribeDiagnosisSQLInfoRequest,
    ) -> adb_20211201_models.DescribeDiagnosisSQLInfoResponse:
        """
        @summary Queries the execution information about an SQL statement, including the execution plan, execution information, resource usage, and self-diagnostics results.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisSQLInfoRequest
        @return: DescribeDiagnosisSQLInfoResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_diagnosis_sqlinfo_with_options(request, runtime)

    async def describe_diagnosis_sqlinfo_async(
        self,
        request: adb_20211201_models.DescribeDiagnosisSQLInfoRequest,
    ) -> adb_20211201_models.DescribeDiagnosisSQLInfoResponse:
        """
        @summary Queries the execution information about an SQL statement, including the execution plan, execution information, resource usage, and self-diagnostics results.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDiagnosisSQLInfoRequest
        @return: DescribeDiagnosisSQLInfoResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_diagnosis_sqlinfo_with_options_async(request, runtime)

    def describe_download_records_with_options(
        self,
        request: adb_20211201_models.DescribeDownloadRecordsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDownloadRecordsResponse:
        """
        @summary Queries the last five SQL query download tasks of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDownloadRecordsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDownloadRecordsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDownloadRecords',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDownloadRecordsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDownloadRecordsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_download_records_with_options_async(
        self,
        request: adb_20211201_models.DescribeDownloadRecordsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeDownloadRecordsResponse:
        """
        @summary Queries the last five SQL query download tasks of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDownloadRecordsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeDownloadRecordsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeDownloadRecords',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeDownloadRecordsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeDownloadRecordsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_download_records(
        self,
        request: adb_20211201_models.DescribeDownloadRecordsRequest,
    ) -> adb_20211201_models.DescribeDownloadRecordsResponse:
        """
        @summary Queries the last five SQL query download tasks of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDownloadRecordsRequest
        @return: DescribeDownloadRecordsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_download_records_with_options(request, runtime)

    async def describe_download_records_async(
        self,
        request: adb_20211201_models.DescribeDownloadRecordsRequest,
    ) -> adb_20211201_models.DescribeDownloadRecordsResponse:
        """
        @summary Queries the last five SQL query download tasks of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeDownloadRecordsRequest
        @return: DescribeDownloadRecordsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_download_records_with_options_async(request, runtime)

    def describe_elastic_plan_attribute_with_options(
        self,
        request: adb_20211201_models.DescribeElasticPlanAttributeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeElasticPlanAttributeResponse:
        """
        @summary Queries the information about a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlanAttributeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeElasticPlanAttributeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeElasticPlanAttribute',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanAttributeResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanAttributeResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_elastic_plan_attribute_with_options_async(
        self,
        request: adb_20211201_models.DescribeElasticPlanAttributeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeElasticPlanAttributeResponse:
        """
        @summary Queries the information about a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlanAttributeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeElasticPlanAttributeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeElasticPlanAttribute',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanAttributeResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanAttributeResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_elastic_plan_attribute(
        self,
        request: adb_20211201_models.DescribeElasticPlanAttributeRequest,
    ) -> adb_20211201_models.DescribeElasticPlanAttributeResponse:
        """
        @summary Queries the information about a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlanAttributeRequest
        @return: DescribeElasticPlanAttributeResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_elastic_plan_attribute_with_options(request, runtime)

    async def describe_elastic_plan_attribute_async(
        self,
        request: adb_20211201_models.DescribeElasticPlanAttributeRequest,
    ) -> adb_20211201_models.DescribeElasticPlanAttributeResponse:
        """
        @summary Queries the information about a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlanAttributeRequest
        @return: DescribeElasticPlanAttributeResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_elastic_plan_attribute_with_options_async(request, runtime)

    def describe_elastic_plan_jobs_with_options(
        self,
        request: adb_20211201_models.DescribeElasticPlanJobsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeElasticPlanJobsResponse:
        """
        @summary Queries a list of scaling plan jobs for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeElasticPlanJobsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeElasticPlanJobsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.status):
            query['Status'] = request.status
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeElasticPlanJobs',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanJobsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanJobsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_elastic_plan_jobs_with_options_async(
        self,
        request: adb_20211201_models.DescribeElasticPlanJobsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeElasticPlanJobsResponse:
        """
        @summary Queries a list of scaling plan jobs for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeElasticPlanJobsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeElasticPlanJobsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.status):
            query['Status'] = request.status
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeElasticPlanJobs',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanJobsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanJobsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_elastic_plan_jobs(
        self,
        request: adb_20211201_models.DescribeElasticPlanJobsRequest,
    ) -> adb_20211201_models.DescribeElasticPlanJobsResponse:
        """
        @summary Queries a list of scaling plan jobs for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeElasticPlanJobsRequest
        @return: DescribeElasticPlanJobsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_elastic_plan_jobs_with_options(request, runtime)

    async def describe_elastic_plan_jobs_async(
        self,
        request: adb_20211201_models.DescribeElasticPlanJobsRequest,
    ) -> adb_20211201_models.DescribeElasticPlanJobsResponse:
        """
        @summary Queries a list of scaling plan jobs for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeElasticPlanJobsRequest
        @return: DescribeElasticPlanJobsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_elastic_plan_jobs_with_options_async(request, runtime)

    def describe_elastic_plan_specifications_with_options(
        self,
        request: adb_20211201_models.DescribeElasticPlanSpecificationsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeElasticPlanSpecificationsResponse:
        """
        @summary Queries the resource specifications that are supported by different types of scaling plans of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlanSpecificationsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeElasticPlanSpecificationsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.type):
            query['Type'] = request.type
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeElasticPlanSpecifications',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanSpecificationsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanSpecificationsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_elastic_plan_specifications_with_options_async(
        self,
        request: adb_20211201_models.DescribeElasticPlanSpecificationsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeElasticPlanSpecificationsResponse:
        """
        @summary Queries the resource specifications that are supported by different types of scaling plans of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlanSpecificationsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeElasticPlanSpecificationsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.type):
            query['Type'] = request.type
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeElasticPlanSpecifications',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanSpecificationsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlanSpecificationsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_elastic_plan_specifications(
        self,
        request: adb_20211201_models.DescribeElasticPlanSpecificationsRequest,
    ) -> adb_20211201_models.DescribeElasticPlanSpecificationsResponse:
        """
        @summary Queries the resource specifications that are supported by different types of scaling plans of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlanSpecificationsRequest
        @return: DescribeElasticPlanSpecificationsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_elastic_plan_specifications_with_options(request, runtime)

    async def describe_elastic_plan_specifications_async(
        self,
        request: adb_20211201_models.DescribeElasticPlanSpecificationsRequest,
    ) -> adb_20211201_models.DescribeElasticPlanSpecificationsResponse:
        """
        @summary Queries the resource specifications that are supported by different types of scaling plans of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlanSpecificationsRequest
        @return: DescribeElasticPlanSpecificationsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_elastic_plan_specifications_with_options_async(request, runtime)

    def describe_elastic_plans_with_options(
        self,
        request: adb_20211201_models.DescribeElasticPlansRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeElasticPlansResponse:
        """
        @summary Queries scaling plans of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlansRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeElasticPlansResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        if not UtilClient.is_unset(request.enabled):
            query['Enabled'] = request.enabled
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.type):
            query['Type'] = request.type
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeElasticPlans',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlansResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlansResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_elastic_plans_with_options_async(
        self,
        request: adb_20211201_models.DescribeElasticPlansRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeElasticPlansResponse:
        """
        @summary Queries scaling plans of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlansRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeElasticPlansResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        if not UtilClient.is_unset(request.enabled):
            query['Enabled'] = request.enabled
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.type):
            query['Type'] = request.type
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeElasticPlans',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlansResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeElasticPlansResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_elastic_plans(
        self,
        request: adb_20211201_models.DescribeElasticPlansRequest,
    ) -> adb_20211201_models.DescribeElasticPlansResponse:
        """
        @summary Queries scaling plans of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlansRequest
        @return: DescribeElasticPlansResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_elastic_plans_with_options(request, runtime)

    async def describe_elastic_plans_async(
        self,
        request: adb_20211201_models.DescribeElasticPlansRequest,
    ) -> adb_20211201_models.DescribeElasticPlansResponse:
        """
        @summary Queries scaling plans of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeElasticPlansRequest
        @return: DescribeElasticPlansResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_elastic_plans_with_options_async(request, runtime)

    def describe_enabled_privileges_with_options(
        self,
        request: adb_20211201_models.DescribeEnabledPrivilegesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeEnabledPrivilegesResponse:
        """
        @summary Queries the permission level and permissions supported for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @param request: DescribeEnabledPrivilegesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeEnabledPrivilegesResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeEnabledPrivileges',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeEnabledPrivilegesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeEnabledPrivilegesResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_enabled_privileges_with_options_async(
        self,
        request: adb_20211201_models.DescribeEnabledPrivilegesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeEnabledPrivilegesResponse:
        """
        @summary Queries the permission level and permissions supported for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @param request: DescribeEnabledPrivilegesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeEnabledPrivilegesResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeEnabledPrivileges',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeEnabledPrivilegesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeEnabledPrivilegesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_enabled_privileges(
        self,
        request: adb_20211201_models.DescribeEnabledPrivilegesRequest,
    ) -> adb_20211201_models.DescribeEnabledPrivilegesResponse:
        """
        @summary Queries the permission level and permissions supported for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @param request: DescribeEnabledPrivilegesRequest
        @return: DescribeEnabledPrivilegesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_enabled_privileges_with_options(request, runtime)

    async def describe_enabled_privileges_async(
        self,
        request: adb_20211201_models.DescribeEnabledPrivilegesRequest,
    ) -> adb_20211201_models.DescribeEnabledPrivilegesResponse:
        """
        @summary Queries the permission level and permissions supported for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @param request: DescribeEnabledPrivilegesRequest
        @return: DescribeEnabledPrivilegesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_enabled_privileges_with_options_async(request, runtime)

    def describe_essd_cache_config_with_options(
        self,
        request: adb_20211201_models.DescribeEssdCacheConfigRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeEssdCacheConfigResponse:
        """
        @summary 查询EssdCache配置
        
        @param request: DescribeEssdCacheConfigRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeEssdCacheConfigResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeEssdCacheConfig',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeEssdCacheConfigResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeEssdCacheConfigResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_essd_cache_config_with_options_async(
        self,
        request: adb_20211201_models.DescribeEssdCacheConfigRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeEssdCacheConfigResponse:
        """
        @summary 查询EssdCache配置
        
        @param request: DescribeEssdCacheConfigRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeEssdCacheConfigResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeEssdCacheConfig',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeEssdCacheConfigResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeEssdCacheConfigResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_essd_cache_config(
        self,
        request: adb_20211201_models.DescribeEssdCacheConfigRequest,
    ) -> adb_20211201_models.DescribeEssdCacheConfigResponse:
        """
        @summary 查询EssdCache配置
        
        @param request: DescribeEssdCacheConfigRequest
        @return: DescribeEssdCacheConfigResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_essd_cache_config_with_options(request, runtime)

    async def describe_essd_cache_config_async(
        self,
        request: adb_20211201_models.DescribeEssdCacheConfigRequest,
    ) -> adb_20211201_models.DescribeEssdCacheConfigResponse:
        """
        @summary 查询EssdCache配置
        
        @param request: DescribeEssdCacheConfigRequest
        @return: DescribeEssdCacheConfigResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_essd_cache_config_with_options_async(request, runtime)

    def describe_excessive_primary_keys_with_options(
        self,
        request: adb_20211201_models.DescribeExcessivePrimaryKeysRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeExcessivePrimaryKeysResponse:
        """
        @summary Queries the information about tables that have excessive primary key fields in an AnalyticDB for MySQL Data Lakehouse Edition (V5.0) cluster.
        
        @param request: DescribeExcessivePrimaryKeysRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeExcessivePrimaryKeysResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeExcessivePrimaryKeys',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeExcessivePrimaryKeysResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeExcessivePrimaryKeysResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_excessive_primary_keys_with_options_async(
        self,
        request: adb_20211201_models.DescribeExcessivePrimaryKeysRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeExcessivePrimaryKeysResponse:
        """
        @summary Queries the information about tables that have excessive primary key fields in an AnalyticDB for MySQL Data Lakehouse Edition (V5.0) cluster.
        
        @param request: DescribeExcessivePrimaryKeysRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeExcessivePrimaryKeysResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeExcessivePrimaryKeys',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeExcessivePrimaryKeysResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeExcessivePrimaryKeysResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_excessive_primary_keys(
        self,
        request: adb_20211201_models.DescribeExcessivePrimaryKeysRequest,
    ) -> adb_20211201_models.DescribeExcessivePrimaryKeysResponse:
        """
        @summary Queries the information about tables that have excessive primary key fields in an AnalyticDB for MySQL Data Lakehouse Edition (V5.0) cluster.
        
        @param request: DescribeExcessivePrimaryKeysRequest
        @return: DescribeExcessivePrimaryKeysResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_excessive_primary_keys_with_options(request, runtime)

    async def describe_excessive_primary_keys_async(
        self,
        request: adb_20211201_models.DescribeExcessivePrimaryKeysRequest,
    ) -> adb_20211201_models.DescribeExcessivePrimaryKeysResponse:
        """
        @summary Queries the information about tables that have excessive primary key fields in an AnalyticDB for MySQL Data Lakehouse Edition (V5.0) cluster.
        
        @param request: DescribeExcessivePrimaryKeysRequest
        @return: DescribeExcessivePrimaryKeysResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_excessive_primary_keys_with_options_async(request, runtime)

    def describe_executor_detection_with_options(
        self,
        request: adb_20211201_models.DescribeExecutorDetectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeExecutorDetectionResponse:
        """
        @summary Queries the diagnostic results of the compute layer.
        
        @param request: DescribeExecutorDetectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeExecutorDetectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeExecutorDetection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeExecutorDetectionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeExecutorDetectionResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_executor_detection_with_options_async(
        self,
        request: adb_20211201_models.DescribeExecutorDetectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeExecutorDetectionResponse:
        """
        @summary Queries the diagnostic results of the compute layer.
        
        @param request: DescribeExecutorDetectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeExecutorDetectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeExecutorDetection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeExecutorDetectionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeExecutorDetectionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_executor_detection(
        self,
        request: adb_20211201_models.DescribeExecutorDetectionRequest,
    ) -> adb_20211201_models.DescribeExecutorDetectionResponse:
        """
        @summary Queries the diagnostic results of the compute layer.
        
        @param request: DescribeExecutorDetectionRequest
        @return: DescribeExecutorDetectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_executor_detection_with_options(request, runtime)

    async def describe_executor_detection_async(
        self,
        request: adb_20211201_models.DescribeExecutorDetectionRequest,
    ) -> adb_20211201_models.DescribeExecutorDetectionResponse:
        """
        @summary Queries the diagnostic results of the compute layer.
        
        @param request: DescribeExecutorDetectionRequest
        @return: DescribeExecutorDetectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_executor_detection_with_options_async(request, runtime)

    def describe_inclined_nodes_with_options(
        self,
        request: adb_20211201_models.DescribeInclinedNodesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeInclinedNodesResponse:
        """
        @summary Queries the disk usage of all storage nodes.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeInclinedNodesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeInclinedNodesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeInclinedNodes',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeInclinedNodesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeInclinedNodesResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_inclined_nodes_with_options_async(
        self,
        request: adb_20211201_models.DescribeInclinedNodesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeInclinedNodesResponse:
        """
        @summary Queries the disk usage of all storage nodes.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeInclinedNodesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeInclinedNodesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeInclinedNodes',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeInclinedNodesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeInclinedNodesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_inclined_nodes(
        self,
        request: adb_20211201_models.DescribeInclinedNodesRequest,
    ) -> adb_20211201_models.DescribeInclinedNodesResponse:
        """
        @summary Queries the disk usage of all storage nodes.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeInclinedNodesRequest
        @return: DescribeInclinedNodesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_inclined_nodes_with_options(request, runtime)

    async def describe_inclined_nodes_async(
        self,
        request: adb_20211201_models.DescribeInclinedNodesRequest,
    ) -> adb_20211201_models.DescribeInclinedNodesResponse:
        """
        @summary Queries the disk usage of all storage nodes.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeInclinedNodesRequest
        @return: DescribeInclinedNodesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_inclined_nodes_with_options_async(request, runtime)

    def describe_job_resource_usage_with_options(
        self,
        request: adb_20211201_models.DescribeJobResourceUsageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeJobResourceUsageResponse:
        """
        @summary 获取作业资源使用统计
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeJobResourceUsageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeJobResourceUsageResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeJobResourceUsage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeJobResourceUsageResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeJobResourceUsageResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_job_resource_usage_with_options_async(
        self,
        request: adb_20211201_models.DescribeJobResourceUsageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeJobResourceUsageResponse:
        """
        @summary 获取作业资源使用统计
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeJobResourceUsageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeJobResourceUsageResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeJobResourceUsage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeJobResourceUsageResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeJobResourceUsageResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_job_resource_usage(
        self,
        request: adb_20211201_models.DescribeJobResourceUsageRequest,
    ) -> adb_20211201_models.DescribeJobResourceUsageResponse:
        """
        @summary 获取作业资源使用统计
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeJobResourceUsageRequest
        @return: DescribeJobResourceUsageResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_job_resource_usage_with_options(request, runtime)

    async def describe_job_resource_usage_async(
        self,
        request: adb_20211201_models.DescribeJobResourceUsageRequest,
    ) -> adb_20211201_models.DescribeJobResourceUsageResponse:
        """
        @summary 获取作业资源使用统计
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeJobResourceUsageRequest
        @return: DescribeJobResourceUsageResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_job_resource_usage_with_options_async(request, runtime)

    def describe_kernel_version_with_options(
        self,
        request: adb_20211201_models.DescribeKernelVersionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeKernelVersionResponse:
        """
        @summary Queries the information about the minor version of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeKernelVersionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeKernelVersionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeKernelVersion',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeKernelVersionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeKernelVersionResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_kernel_version_with_options_async(
        self,
        request: adb_20211201_models.DescribeKernelVersionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeKernelVersionResponse:
        """
        @summary Queries the information about the minor version of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeKernelVersionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeKernelVersionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeKernelVersion',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeKernelVersionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeKernelVersionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_kernel_version(
        self,
        request: adb_20211201_models.DescribeKernelVersionRequest,
    ) -> adb_20211201_models.DescribeKernelVersionResponse:
        """
        @summary Queries the information about the minor version of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeKernelVersionRequest
        @return: DescribeKernelVersionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_kernel_version_with_options(request, runtime)

    async def describe_kernel_version_async(
        self,
        request: adb_20211201_models.DescribeKernelVersionRequest,
    ) -> adb_20211201_models.DescribeKernelVersionResponse:
        """
        @summary Queries the information about the minor version of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeKernelVersionRequest
        @return: DescribeKernelVersionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_kernel_version_with_options_async(request, runtime)

    def describe_lake_cache_size_with_options(
        self,
        request: adb_20211201_models.DescribeLakeCacheSizeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeLakeCacheSizeResponse:
        """
        @summary Queries the lake cache size of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeLakeCacheSizeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeLakeCacheSizeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeLakeCacheSize',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeLakeCacheSizeResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeLakeCacheSizeResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_lake_cache_size_with_options_async(
        self,
        request: adb_20211201_models.DescribeLakeCacheSizeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeLakeCacheSizeResponse:
        """
        @summary Queries the lake cache size of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeLakeCacheSizeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeLakeCacheSizeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeLakeCacheSize',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeLakeCacheSizeResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeLakeCacheSizeResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_lake_cache_size(
        self,
        request: adb_20211201_models.DescribeLakeCacheSizeRequest,
    ) -> adb_20211201_models.DescribeLakeCacheSizeResponse:
        """
        @summary Queries the lake cache size of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeLakeCacheSizeRequest
        @return: DescribeLakeCacheSizeResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_lake_cache_size_with_options(request, runtime)

    async def describe_lake_cache_size_async(
        self,
        request: adb_20211201_models.DescribeLakeCacheSizeRequest,
    ) -> adb_20211201_models.DescribeLakeCacheSizeResponse:
        """
        @summary Queries the lake cache size of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeLakeCacheSizeRequest
        @return: DescribeLakeCacheSizeResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_lake_cache_size_with_options_async(request, runtime)

    def describe_operator_permission_with_options(
        self,
        request: adb_20211201_models.DescribeOperatorPermissionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeOperatorPermissionResponse:
        """
        @summary Queries the service account permissions of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeOperatorPermissionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeOperatorPermissionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeOperatorPermission',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeOperatorPermissionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeOperatorPermissionResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_operator_permission_with_options_async(
        self,
        request: adb_20211201_models.DescribeOperatorPermissionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeOperatorPermissionResponse:
        """
        @summary Queries the service account permissions of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeOperatorPermissionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeOperatorPermissionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeOperatorPermission',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeOperatorPermissionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeOperatorPermissionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_operator_permission(
        self,
        request: adb_20211201_models.DescribeOperatorPermissionRequest,
    ) -> adb_20211201_models.DescribeOperatorPermissionResponse:
        """
        @summary Queries the service account permissions of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeOperatorPermissionRequest
        @return: DescribeOperatorPermissionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_operator_permission_with_options(request, runtime)

    async def describe_operator_permission_async(
        self,
        request: adb_20211201_models.DescribeOperatorPermissionRequest,
    ) -> adb_20211201_models.DescribeOperatorPermissionResponse:
        """
        @summary Queries the service account permissions of an AnalyticDB for MySQL cluster.
        
        @param request: DescribeOperatorPermissionRequest
        @return: DescribeOperatorPermissionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_operator_permission_with_options_async(request, runtime)

    def describe_oversize_non_partition_table_infos_with_options(
        self,
        request: adb_20211201_models.DescribeOversizeNonPartitionTableInfosRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeOversizeNonPartitionTableInfosResponse:
        """
        @summary Queries the information about oversized non-partitioned tables in an AnalyticDB for MySQL cluster.
        
        @param request: DescribeOversizeNonPartitionTableInfosRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeOversizeNonPartitionTableInfosResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeOversizeNonPartitionTableInfos',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeOversizeNonPartitionTableInfosResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeOversizeNonPartitionTableInfosResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_oversize_non_partition_table_infos_with_options_async(
        self,
        request: adb_20211201_models.DescribeOversizeNonPartitionTableInfosRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeOversizeNonPartitionTableInfosResponse:
        """
        @summary Queries the information about oversized non-partitioned tables in an AnalyticDB for MySQL cluster.
        
        @param request: DescribeOversizeNonPartitionTableInfosRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeOversizeNonPartitionTableInfosResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeOversizeNonPartitionTableInfos',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeOversizeNonPartitionTableInfosResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeOversizeNonPartitionTableInfosResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_oversize_non_partition_table_infos(
        self,
        request: adb_20211201_models.DescribeOversizeNonPartitionTableInfosRequest,
    ) -> adb_20211201_models.DescribeOversizeNonPartitionTableInfosResponse:
        """
        @summary Queries the information about oversized non-partitioned tables in an AnalyticDB for MySQL cluster.
        
        @param request: DescribeOversizeNonPartitionTableInfosRequest
        @return: DescribeOversizeNonPartitionTableInfosResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_oversize_non_partition_table_infos_with_options(request, runtime)

    async def describe_oversize_non_partition_table_infos_async(
        self,
        request: adb_20211201_models.DescribeOversizeNonPartitionTableInfosRequest,
    ) -> adb_20211201_models.DescribeOversizeNonPartitionTableInfosResponse:
        """
        @summary Queries the information about oversized non-partitioned tables in an AnalyticDB for MySQL cluster.
        
        @param request: DescribeOversizeNonPartitionTableInfosRequest
        @return: DescribeOversizeNonPartitionTableInfosResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_oversize_non_partition_table_infos_with_options_async(request, runtime)

    def describe_pattern_performance_with_options(
        self,
        request: adb_20211201_models.DescribePatternPerformanceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribePatternPerformanceResponse:
        """
        @summary Queries the information about performance metrics of an SQL pattern such as the query duration and average memory usage for an AnalyticDB for MySQL cluster within a time range.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribePatternPerformanceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribePatternPerformanceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.pattern_id):
            query['PatternId'] = request.pattern_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribePatternPerformance',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribePatternPerformanceResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribePatternPerformanceResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_pattern_performance_with_options_async(
        self,
        request: adb_20211201_models.DescribePatternPerformanceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribePatternPerformanceResponse:
        """
        @summary Queries the information about performance metrics of an SQL pattern such as the query duration and average memory usage for an AnalyticDB for MySQL cluster within a time range.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribePatternPerformanceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribePatternPerformanceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.pattern_id):
            query['PatternId'] = request.pattern_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribePatternPerformance',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribePatternPerformanceResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribePatternPerformanceResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_pattern_performance(
        self,
        request: adb_20211201_models.DescribePatternPerformanceRequest,
    ) -> adb_20211201_models.DescribePatternPerformanceResponse:
        """
        @summary Queries the information about performance metrics of an SQL pattern such as the query duration and average memory usage for an AnalyticDB for MySQL cluster within a time range.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribePatternPerformanceRequest
        @return: DescribePatternPerformanceResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_pattern_performance_with_options(request, runtime)

    async def describe_pattern_performance_async(
        self,
        request: adb_20211201_models.DescribePatternPerformanceRequest,
    ) -> adb_20211201_models.DescribePatternPerformanceResponse:
        """
        @summary Queries the information about performance metrics of an SQL pattern such as the query duration and average memory usage for an AnalyticDB for MySQL cluster within a time range.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribePatternPerformanceRequest
        @return: DescribePatternPerformanceResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_pattern_performance_with_options_async(request, runtime)

    def describe_performance_view_attribute_with_options(
        self,
        request: adb_20211201_models.DescribePerformanceViewAttributeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribePerformanceViewAttributeResponse:
        """
        @summary Queries the information about a monitoring view.
        
        @param request: DescribePerformanceViewAttributeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribePerformanceViewAttributeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.view_name):
            query['ViewName'] = request.view_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribePerformanceViewAttribute',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribePerformanceViewAttributeResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribePerformanceViewAttributeResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_performance_view_attribute_with_options_async(
        self,
        request: adb_20211201_models.DescribePerformanceViewAttributeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribePerformanceViewAttributeResponse:
        """
        @summary Queries the information about a monitoring view.
        
        @param request: DescribePerformanceViewAttributeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribePerformanceViewAttributeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.view_name):
            query['ViewName'] = request.view_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribePerformanceViewAttribute',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribePerformanceViewAttributeResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribePerformanceViewAttributeResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_performance_view_attribute(
        self,
        request: adb_20211201_models.DescribePerformanceViewAttributeRequest,
    ) -> adb_20211201_models.DescribePerformanceViewAttributeResponse:
        """
        @summary Queries the information about a monitoring view.
        
        @param request: DescribePerformanceViewAttributeRequest
        @return: DescribePerformanceViewAttributeResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_performance_view_attribute_with_options(request, runtime)

    async def describe_performance_view_attribute_async(
        self,
        request: adb_20211201_models.DescribePerformanceViewAttributeRequest,
    ) -> adb_20211201_models.DescribePerformanceViewAttributeResponse:
        """
        @summary Queries the information about a monitoring view.
        
        @param request: DescribePerformanceViewAttributeRequest
        @return: DescribePerformanceViewAttributeResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_performance_view_attribute_with_options_async(request, runtime)

    def describe_performance_views_with_options(
        self,
        request: adb_20211201_models.DescribePerformanceViewsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribePerformanceViewsResponse:
        """
        @summary Queries a list of monitoring views.
        
        @param request: DescribePerformanceViewsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribePerformanceViewsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribePerformanceViews',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribePerformanceViewsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribePerformanceViewsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_performance_views_with_options_async(
        self,
        request: adb_20211201_models.DescribePerformanceViewsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribePerformanceViewsResponse:
        """
        @summary Queries a list of monitoring views.
        
        @param request: DescribePerformanceViewsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribePerformanceViewsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribePerformanceViews',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribePerformanceViewsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribePerformanceViewsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_performance_views(
        self,
        request: adb_20211201_models.DescribePerformanceViewsRequest,
    ) -> adb_20211201_models.DescribePerformanceViewsResponse:
        """
        @summary Queries a list of monitoring views.
        
        @param request: DescribePerformanceViewsRequest
        @return: DescribePerformanceViewsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_performance_views_with_options(request, runtime)

    async def describe_performance_views_async(
        self,
        request: adb_20211201_models.DescribePerformanceViewsRequest,
    ) -> adb_20211201_models.DescribePerformanceViewsResponse:
        """
        @summary Queries a list of monitoring views.
        
        @param request: DescribePerformanceViewsRequest
        @return: DescribePerformanceViewsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_performance_views_with_options_async(request, runtime)

    def describe_regions_with_options(
        self,
        request: adb_20211201_models.DescribeRegionsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeRegionsResponse:
        """
        @summary Queries a list of regions and zones in which AnalyticDB for MySQL Data Lakehouse Edition (V3.0) is available.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeRegionsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeRegionsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.accept_language):
            query['AcceptLanguage'] = request.accept_language
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeRegions',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeRegionsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeRegionsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_regions_with_options_async(
        self,
        request: adb_20211201_models.DescribeRegionsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeRegionsResponse:
        """
        @summary Queries a list of regions and zones in which AnalyticDB for MySQL Data Lakehouse Edition (V3.0) is available.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeRegionsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeRegionsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.accept_language):
            query['AcceptLanguage'] = request.accept_language
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeRegions',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeRegionsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeRegionsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_regions(
        self,
        request: adb_20211201_models.DescribeRegionsRequest,
    ) -> adb_20211201_models.DescribeRegionsResponse:
        """
        @summary Queries a list of regions and zones in which AnalyticDB for MySQL Data Lakehouse Edition (V3.0) is available.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeRegionsRequest
        @return: DescribeRegionsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_regions_with_options(request, runtime)

    async def describe_regions_async(
        self,
        request: adb_20211201_models.DescribeRegionsRequest,
    ) -> adb_20211201_models.DescribeRegionsResponse:
        """
        @summary Queries a list of regions and zones in which AnalyticDB for MySQL Data Lakehouse Edition (V3.0) is available.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeRegionsRequest
        @return: DescribeRegionsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_regions_with_options_async(request, runtime)

    def describe_sqlpatterns_with_options(
        self,
        request: adb_20211201_models.DescribeSQLPatternsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSQLPatternsResponse:
        """
        @summary Queries a list of SQL patterns for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster within a time range.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSQLPatternsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSQLPatternsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSQLPatterns',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSQLPatternsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSQLPatternsResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_sqlpatterns_with_options_async(
        self,
        request: adb_20211201_models.DescribeSQLPatternsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSQLPatternsResponse:
        """
        @summary Queries a list of SQL patterns for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster within a time range.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSQLPatternsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSQLPatternsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSQLPatterns',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSQLPatternsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSQLPatternsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_sqlpatterns(
        self,
        request: adb_20211201_models.DescribeSQLPatternsRequest,
    ) -> adb_20211201_models.DescribeSQLPatternsResponse:
        """
        @summary Queries a list of SQL patterns for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster within a time range.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSQLPatternsRequest
        @return: DescribeSQLPatternsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_sqlpatterns_with_options(request, runtime)

    async def describe_sqlpatterns_async(
        self,
        request: adb_20211201_models.DescribeSQLPatternsRequest,
    ) -> adb_20211201_models.DescribeSQLPatternsResponse:
        """
        @summary Queries a list of SQL patterns for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster within a time range.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSQLPatternsRequest
        @return: DescribeSQLPatternsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_sqlpatterns_with_options_async(request, runtime)

    def describe_schemas_with_options(
        self,
        request: adb_20211201_models.DescribeSchemasRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSchemasResponse:
        """
        @summary Queries a list of databases in an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSchemasRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSchemasResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSchemas',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSchemasResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSchemasResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_schemas_with_options_async(
        self,
        request: adb_20211201_models.DescribeSchemasRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSchemasResponse:
        """
        @summary Queries a list of databases in an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSchemasRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSchemasResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSchemas',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSchemasResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSchemasResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_schemas(
        self,
        request: adb_20211201_models.DescribeSchemasRequest,
    ) -> adb_20211201_models.DescribeSchemasResponse:
        """
        @summary Queries a list of databases in an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSchemasRequest
        @return: DescribeSchemasResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_schemas_with_options(request, runtime)

    async def describe_schemas_async(
        self,
        request: adb_20211201_models.DescribeSchemasRequest,
    ) -> adb_20211201_models.DescribeSchemasResponse:
        """
        @summary Queries a list of databases in an AnalyticDB for MySQL cluster.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSchemasRequest
        @return: DescribeSchemasResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_schemas_with_options_async(request, runtime)

    def describe_spark_app_diagnosis_info_with_options(
        self,
        request: adb_20211201_models.DescribeSparkAppDiagnosisInfoRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkAppDiagnosisInfoResponse:
        """
        @summary Queries the diagnostic information about a Spark application.
        
        @param request: DescribeSparkAppDiagnosisInfoRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkAppDiagnosisInfoResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.app_id):
            query['AppId'] = request.app_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.language):
            query['Language'] = request.language
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkAppDiagnosisInfo',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkAppDiagnosisInfoResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkAppDiagnosisInfoResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_spark_app_diagnosis_info_with_options_async(
        self,
        request: adb_20211201_models.DescribeSparkAppDiagnosisInfoRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkAppDiagnosisInfoResponse:
        """
        @summary Queries the diagnostic information about a Spark application.
        
        @param request: DescribeSparkAppDiagnosisInfoRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkAppDiagnosisInfoResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.app_id):
            query['AppId'] = request.app_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.language):
            query['Language'] = request.language
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkAppDiagnosisInfo',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkAppDiagnosisInfoResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkAppDiagnosisInfoResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_spark_app_diagnosis_info(
        self,
        request: adb_20211201_models.DescribeSparkAppDiagnosisInfoRequest,
    ) -> adb_20211201_models.DescribeSparkAppDiagnosisInfoResponse:
        """
        @summary Queries the diagnostic information about a Spark application.
        
        @param request: DescribeSparkAppDiagnosisInfoRequest
        @return: DescribeSparkAppDiagnosisInfoResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_spark_app_diagnosis_info_with_options(request, runtime)

    async def describe_spark_app_diagnosis_info_async(
        self,
        request: adb_20211201_models.DescribeSparkAppDiagnosisInfoRequest,
    ) -> adb_20211201_models.DescribeSparkAppDiagnosisInfoResponse:
        """
        @summary Queries the diagnostic information about a Spark application.
        
        @param request: DescribeSparkAppDiagnosisInfoRequest
        @return: DescribeSparkAppDiagnosisInfoResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_spark_app_diagnosis_info_with_options_async(request, runtime)

    def describe_spark_app_type_with_options(
        self,
        request: adb_20211201_models.DescribeSparkAppTypeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkAppTypeResponse:
        """
        @summary Queries the type of a Spark application.
        
        @param request: DescribeSparkAppTypeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkAppTypeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.app_id):
            query['AppId'] = request.app_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkAppType',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkAppTypeResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkAppTypeResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_spark_app_type_with_options_async(
        self,
        request: adb_20211201_models.DescribeSparkAppTypeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkAppTypeResponse:
        """
        @summary Queries the type of a Spark application.
        
        @param request: DescribeSparkAppTypeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkAppTypeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.app_id):
            query['AppId'] = request.app_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkAppType',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkAppTypeResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkAppTypeResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_spark_app_type(
        self,
        request: adb_20211201_models.DescribeSparkAppTypeRequest,
    ) -> adb_20211201_models.DescribeSparkAppTypeResponse:
        """
        @summary Queries the type of a Spark application.
        
        @param request: DescribeSparkAppTypeRequest
        @return: DescribeSparkAppTypeResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_spark_app_type_with_options(request, runtime)

    async def describe_spark_app_type_async(
        self,
        request: adb_20211201_models.DescribeSparkAppTypeRequest,
    ) -> adb_20211201_models.DescribeSparkAppTypeResponse:
        """
        @summary Queries the type of a Spark application.
        
        @param request: DescribeSparkAppTypeRequest
        @return: DescribeSparkAppTypeResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_spark_app_type_with_options_async(request, runtime)

    def describe_spark_code_log_with_options(
        self,
        request: adb_20211201_models.DescribeSparkCodeLogRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkCodeLogResponse:
        """
        @summary Queries the execution logs of Spark code.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeLogRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkCodeLogResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.job_id):
            query['JobId'] = request.job_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkCodeLog',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeLogResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeLogResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_spark_code_log_with_options_async(
        self,
        request: adb_20211201_models.DescribeSparkCodeLogRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkCodeLogResponse:
        """
        @summary Queries the execution logs of Spark code.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeLogRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkCodeLogResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.job_id):
            query['JobId'] = request.job_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkCodeLog',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeLogResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeLogResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_spark_code_log(
        self,
        request: adb_20211201_models.DescribeSparkCodeLogRequest,
    ) -> adb_20211201_models.DescribeSparkCodeLogResponse:
        """
        @summary Queries the execution logs of Spark code.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeLogRequest
        @return: DescribeSparkCodeLogResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_spark_code_log_with_options(request, runtime)

    async def describe_spark_code_log_async(
        self,
        request: adb_20211201_models.DescribeSparkCodeLogRequest,
    ) -> adb_20211201_models.DescribeSparkCodeLogResponse:
        """
        @summary Queries the execution logs of Spark code.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeLogRequest
        @return: DescribeSparkCodeLogResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_spark_code_log_with_options_async(request, runtime)

    def describe_spark_code_output_with_options(
        self,
        request: adb_20211201_models.DescribeSparkCodeOutputRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkCodeOutputResponse:
        """
        @summary Queries the execution result of Spark code.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeOutputRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkCodeOutputResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.job_id):
            query['JobId'] = request.job_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkCodeOutput',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeOutputResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeOutputResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_spark_code_output_with_options_async(
        self,
        request: adb_20211201_models.DescribeSparkCodeOutputRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkCodeOutputResponse:
        """
        @summary Queries the execution result of Spark code.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeOutputRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkCodeOutputResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.job_id):
            query['JobId'] = request.job_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkCodeOutput',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeOutputResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeOutputResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_spark_code_output(
        self,
        request: adb_20211201_models.DescribeSparkCodeOutputRequest,
    ) -> adb_20211201_models.DescribeSparkCodeOutputResponse:
        """
        @summary Queries the execution result of Spark code.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeOutputRequest
        @return: DescribeSparkCodeOutputResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_spark_code_output_with_options(request, runtime)

    async def describe_spark_code_output_async(
        self,
        request: adb_20211201_models.DescribeSparkCodeOutputRequest,
    ) -> adb_20211201_models.DescribeSparkCodeOutputResponse:
        """
        @summary Queries the execution result of Spark code.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeOutputRequest
        @return: DescribeSparkCodeOutputResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_spark_code_output_with_options_async(request, runtime)

    def describe_spark_code_web_ui_with_options(
        self,
        request: adb_20211201_models.DescribeSparkCodeWebUiRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkCodeWebUiResponse:
        """
        @summary Queries the URL of the web UI for a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeWebUiRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkCodeWebUiResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.job_id):
            query['JobId'] = request.job_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkCodeWebUi',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeWebUiResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeWebUiResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_spark_code_web_ui_with_options_async(
        self,
        request: adb_20211201_models.DescribeSparkCodeWebUiRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkCodeWebUiResponse:
        """
        @summary Queries the URL of the web UI for a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeWebUiRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkCodeWebUiResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.job_id):
            query['JobId'] = request.job_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkCodeWebUi',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeWebUiResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkCodeWebUiResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_spark_code_web_ui(
        self,
        request: adb_20211201_models.DescribeSparkCodeWebUiRequest,
    ) -> adb_20211201_models.DescribeSparkCodeWebUiResponse:
        """
        @summary Queries the URL of the web UI for a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeWebUiRequest
        @return: DescribeSparkCodeWebUiResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_spark_code_web_ui_with_options(request, runtime)

    async def describe_spark_code_web_ui_async(
        self,
        request: adb_20211201_models.DescribeSparkCodeWebUiRequest,
    ) -> adb_20211201_models.DescribeSparkCodeWebUiResponse:
        """
        @summary Queries the URL of the web UI for a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeSparkCodeWebUiRequest
        @return: DescribeSparkCodeWebUiResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_spark_code_web_ui_with_options_async(request, runtime)

    def describe_spark_sqldiagnosis_attribute_with_options(
        self,
        request: adb_20211201_models.DescribeSparkSQLDiagnosisAttributeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkSQLDiagnosisAttributeResponse:
        """
        @summary Queries the diagnostic information about a Spark SQL query.
        
        @param request: DescribeSparkSQLDiagnosisAttributeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkSQLDiagnosisAttributeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.app_id):
            query['AppId'] = request.app_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.inner_query_id):
            query['InnerQueryId'] = request.inner_query_id
        if not UtilClient.is_unset(request.language):
            query['Language'] = request.language
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkSQLDiagnosisAttribute',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkSQLDiagnosisAttributeResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkSQLDiagnosisAttributeResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_spark_sqldiagnosis_attribute_with_options_async(
        self,
        request: adb_20211201_models.DescribeSparkSQLDiagnosisAttributeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkSQLDiagnosisAttributeResponse:
        """
        @summary Queries the diagnostic information about a Spark SQL query.
        
        @param request: DescribeSparkSQLDiagnosisAttributeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkSQLDiagnosisAttributeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.app_id):
            query['AppId'] = request.app_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.inner_query_id):
            query['InnerQueryId'] = request.inner_query_id
        if not UtilClient.is_unset(request.language):
            query['Language'] = request.language
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkSQLDiagnosisAttribute',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkSQLDiagnosisAttributeResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkSQLDiagnosisAttributeResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_spark_sqldiagnosis_attribute(
        self,
        request: adb_20211201_models.DescribeSparkSQLDiagnosisAttributeRequest,
    ) -> adb_20211201_models.DescribeSparkSQLDiagnosisAttributeResponse:
        """
        @summary Queries the diagnostic information about a Spark SQL query.
        
        @param request: DescribeSparkSQLDiagnosisAttributeRequest
        @return: DescribeSparkSQLDiagnosisAttributeResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_spark_sqldiagnosis_attribute_with_options(request, runtime)

    async def describe_spark_sqldiagnosis_attribute_async(
        self,
        request: adb_20211201_models.DescribeSparkSQLDiagnosisAttributeRequest,
    ) -> adb_20211201_models.DescribeSparkSQLDiagnosisAttributeResponse:
        """
        @summary Queries the diagnostic information about a Spark SQL query.
        
        @param request: DescribeSparkSQLDiagnosisAttributeRequest
        @return: DescribeSparkSQLDiagnosisAttributeResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_spark_sqldiagnosis_attribute_with_options_async(request, runtime)

    def describe_spark_sqldiagnosis_list_with_options(
        self,
        request: adb_20211201_models.DescribeSparkSQLDiagnosisListRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkSQLDiagnosisListResponse:
        """
        @summary Queries the diagnostic information about Spark SQL queries.
        
        @param request: DescribeSparkSQLDiagnosisListRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkSQLDiagnosisListResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.max_start_time):
            query['MaxStartTime'] = request.max_start_time
        if not UtilClient.is_unset(request.min_start_time):
            query['MinStartTime'] = request.min_start_time
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.statement_id):
            query['StatementId'] = request.statement_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkSQLDiagnosisList',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkSQLDiagnosisListResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkSQLDiagnosisListResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_spark_sqldiagnosis_list_with_options_async(
        self,
        request: adb_20211201_models.DescribeSparkSQLDiagnosisListRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSparkSQLDiagnosisListResponse:
        """
        @summary Queries the diagnostic information about Spark SQL queries.
        
        @param request: DescribeSparkSQLDiagnosisListRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSparkSQLDiagnosisListResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.max_start_time):
            query['MaxStartTime'] = request.max_start_time
        if not UtilClient.is_unset(request.min_start_time):
            query['MinStartTime'] = request.min_start_time
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.statement_id):
            query['StatementId'] = request.statement_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSparkSQLDiagnosisList',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkSQLDiagnosisListResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSparkSQLDiagnosisListResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_spark_sqldiagnosis_list(
        self,
        request: adb_20211201_models.DescribeSparkSQLDiagnosisListRequest,
    ) -> adb_20211201_models.DescribeSparkSQLDiagnosisListResponse:
        """
        @summary Queries the diagnostic information about Spark SQL queries.
        
        @param request: DescribeSparkSQLDiagnosisListRequest
        @return: DescribeSparkSQLDiagnosisListResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_spark_sqldiagnosis_list_with_options(request, runtime)

    async def describe_spark_sqldiagnosis_list_async(
        self,
        request: adb_20211201_models.DescribeSparkSQLDiagnosisListRequest,
    ) -> adb_20211201_models.DescribeSparkSQLDiagnosisListResponse:
        """
        @summary Queries the diagnostic information about Spark SQL queries.
        
        @param request: DescribeSparkSQLDiagnosisListRequest
        @return: DescribeSparkSQLDiagnosisListResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_spark_sqldiagnosis_list_with_options_async(request, runtime)

    def describe_sql_pattern_with_options(
        self,
        request: adb_20211201_models.DescribeSqlPatternRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSqlPatternResponse:
        """
        @summary Queries the information about SQL patterns of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster within a time range.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeSqlPatternRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSqlPatternResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.sql_pattern):
            query['SqlPattern'] = request.sql_pattern
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.type):
            query['Type'] = request.type
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSqlPattern',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSqlPatternResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSqlPatternResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_sql_pattern_with_options_async(
        self,
        request: adb_20211201_models.DescribeSqlPatternRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeSqlPatternResponse:
        """
        @summary Queries the information about SQL patterns of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster within a time range.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeSqlPatternRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeSqlPatternResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.sql_pattern):
            query['SqlPattern'] = request.sql_pattern
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.type):
            query['Type'] = request.type
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeSqlPattern',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeSqlPatternResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeSqlPatternResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_sql_pattern(
        self,
        request: adb_20211201_models.DescribeSqlPatternRequest,
    ) -> adb_20211201_models.DescribeSqlPatternResponse:
        """
        @summary Queries the information about SQL patterns of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster within a time range.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeSqlPatternRequest
        @return: DescribeSqlPatternResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_sql_pattern_with_options(request, runtime)

    async def describe_sql_pattern_async(
        self,
        request: adb_20211201_models.DescribeSqlPatternRequest,
    ) -> adb_20211201_models.DescribeSqlPatternResponse:
        """
        @summary Queries the information about SQL patterns of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster within a time range.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeSqlPatternRequest
        @return: DescribeSqlPatternResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_sql_pattern_with_options_async(request, runtime)

    def describe_storage_resource_usage_with_options(
        self,
        request: adb_20211201_models.DescribeStorageResourceUsageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeStorageResourceUsageResponse:
        """
        @summary Queries the storage resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeStorageResourceUsageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeStorageResourceUsageResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeStorageResourceUsage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeStorageResourceUsageResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeStorageResourceUsageResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_storage_resource_usage_with_options_async(
        self,
        request: adb_20211201_models.DescribeStorageResourceUsageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeStorageResourceUsageResponse:
        """
        @summary Queries the storage resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeStorageResourceUsageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeStorageResourceUsageResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeStorageResourceUsage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeStorageResourceUsageResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeStorageResourceUsageResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_storage_resource_usage(
        self,
        request: adb_20211201_models.DescribeStorageResourceUsageRequest,
    ) -> adb_20211201_models.DescribeStorageResourceUsageResponse:
        """
        @summary Queries the storage resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeStorageResourceUsageRequest
        @return: DescribeStorageResourceUsageResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_storage_resource_usage_with_options(request, runtime)

    async def describe_storage_resource_usage_async(
        self,
        request: adb_20211201_models.DescribeStorageResourceUsageRequest,
    ) -> adb_20211201_models.DescribeStorageResourceUsageResponse:
        """
        @summary Queries the storage resource usage of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeStorageResourceUsageRequest
        @return: DescribeStorageResourceUsageResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_storage_resource_usage_with_options_async(request, runtime)

    def describe_table_access_count_with_options(
        self,
        request: adb_20211201_models.DescribeTableAccessCountRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeTableAccessCountResponse:
        """
        @summary Queries the number of accesses to a table or all tables in an AnalyticDB for MySQL cluster on a date.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeTableAccessCountRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeTableAccessCountResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeTableAccessCount',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeTableAccessCountResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeTableAccessCountResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_table_access_count_with_options_async(
        self,
        request: adb_20211201_models.DescribeTableAccessCountRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeTableAccessCountResponse:
        """
        @summary Queries the number of accesses to a table or all tables in an AnalyticDB for MySQL cluster on a date.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeTableAccessCountRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeTableAccessCountResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeTableAccessCount',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeTableAccessCountResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeTableAccessCountResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_table_access_count(
        self,
        request: adb_20211201_models.DescribeTableAccessCountRequest,
    ) -> adb_20211201_models.DescribeTableAccessCountResponse:
        """
        @summary Queries the number of accesses to a table or all tables in an AnalyticDB for MySQL cluster on a date.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeTableAccessCountRequest
        @return: DescribeTableAccessCountResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_table_access_count_with_options(request, runtime)

    async def describe_table_access_count_async(
        self,
        request: adb_20211201_models.DescribeTableAccessCountRequest,
    ) -> adb_20211201_models.DescribeTableAccessCountResponse:
        """
        @summary Queries the number of accesses to a table or all tables in an AnalyticDB for MySQL cluster on a date.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DescribeTableAccessCountRequest
        @return: DescribeTableAccessCountResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_table_access_count_with_options_async(request, runtime)

    def describe_table_detail_with_options(
        self,
        request: adb_20211201_models.DescribeTableDetailRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeTableDetailResponse:
        """
        @summary Queries the information about data distribution among shards of a table.
        
        @param request: DescribeTableDetailRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeTableDetailResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeTableDetail',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeTableDetailResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeTableDetailResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_table_detail_with_options_async(
        self,
        request: adb_20211201_models.DescribeTableDetailRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeTableDetailResponse:
        """
        @summary Queries the information about data distribution among shards of a table.
        
        @param request: DescribeTableDetailRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeTableDetailResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeTableDetail',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeTableDetailResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeTableDetailResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_table_detail(
        self,
        request: adb_20211201_models.DescribeTableDetailRequest,
    ) -> adb_20211201_models.DescribeTableDetailResponse:
        """
        @summary Queries the information about data distribution among shards of a table.
        
        @param request: DescribeTableDetailRequest
        @return: DescribeTableDetailResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_table_detail_with_options(request, runtime)

    async def describe_table_detail_async(
        self,
        request: adb_20211201_models.DescribeTableDetailRequest,
    ) -> adb_20211201_models.DescribeTableDetailResponse:
        """
        @summary Queries the information about data distribution among shards of a table.
        
        @param request: DescribeTableDetailRequest
        @return: DescribeTableDetailResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_table_detail_with_options_async(request, runtime)

    def describe_table_partition_diagnose_with_options(
        self,
        request: adb_20211201_models.DescribeTablePartitionDiagnoseRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeTablePartitionDiagnoseResponse:
        """
        @summary Queries the information about partition diagnostics.
        
        @param request: DescribeTablePartitionDiagnoseRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeTablePartitionDiagnoseResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeTablePartitionDiagnose',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeTablePartitionDiagnoseResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeTablePartitionDiagnoseResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_table_partition_diagnose_with_options_async(
        self,
        request: adb_20211201_models.DescribeTablePartitionDiagnoseRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeTablePartitionDiagnoseResponse:
        """
        @summary Queries the information about partition diagnostics.
        
        @param request: DescribeTablePartitionDiagnoseRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeTablePartitionDiagnoseResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.order):
            query['Order'] = request.order
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeTablePartitionDiagnose',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeTablePartitionDiagnoseResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeTablePartitionDiagnoseResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_table_partition_diagnose(
        self,
        request: adb_20211201_models.DescribeTablePartitionDiagnoseRequest,
    ) -> adb_20211201_models.DescribeTablePartitionDiagnoseResponse:
        """
        @summary Queries the information about partition diagnostics.
        
        @param request: DescribeTablePartitionDiagnoseRequest
        @return: DescribeTablePartitionDiagnoseResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_table_partition_diagnose_with_options(request, runtime)

    async def describe_table_partition_diagnose_async(
        self,
        request: adb_20211201_models.DescribeTablePartitionDiagnoseRequest,
    ) -> adb_20211201_models.DescribeTablePartitionDiagnoseResponse:
        """
        @summary Queries the information about partition diagnostics.
        
        @param request: DescribeTablePartitionDiagnoseRequest
        @return: DescribeTablePartitionDiagnoseResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_table_partition_diagnose_with_options_async(request, runtime)

    def describe_tables_with_options(
        self,
        request: adb_20211201_models.DescribeTablesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeTablesResponse:
        """
        @summary Queries a list of tables in a database.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeTablesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeTablesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeTables',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeTablesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeTablesResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_tables_with_options_async(
        self,
        request: adb_20211201_models.DescribeTablesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeTablesResponse:
        """
        @summary Queries a list of tables in a database.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeTablesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeTablesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeTables',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeTablesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeTablesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_tables(
        self,
        request: adb_20211201_models.DescribeTablesRequest,
    ) -> adb_20211201_models.DescribeTablesResponse:
        """
        @summary Queries a list of tables in a database.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeTablesRequest
        @return: DescribeTablesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_tables_with_options(request, runtime)

    async def describe_tables_async(
        self,
        request: adb_20211201_models.DescribeTablesRequest,
    ) -> adb_20211201_models.DescribeTablesResponse:
        """
        @summary Queries a list of tables in a database.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: DescribeTablesRequest
        @return: DescribeTablesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_tables_with_options_async(request, runtime)

    def describe_user_quota_with_options(
        self,
        request: adb_20211201_models.DescribeUserQuotaRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeUserQuotaResponse:
        """
        @summary Queries available quotas.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeUserQuotaRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeUserQuotaResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeUserQuota',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeUserQuotaResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeUserQuotaResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_user_quota_with_options_async(
        self,
        request: adb_20211201_models.DescribeUserQuotaRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeUserQuotaResponse:
        """
        @summary Queries available quotas.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeUserQuotaRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeUserQuotaResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeUserQuota',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeUserQuotaResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeUserQuotaResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_user_quota(
        self,
        request: adb_20211201_models.DescribeUserQuotaRequest,
    ) -> adb_20211201_models.DescribeUserQuotaResponse:
        """
        @summary Queries available quotas.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeUserQuotaRequest
        @return: DescribeUserQuotaResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_user_quota_with_options(request, runtime)

    async def describe_user_quota_async(
        self,
        request: adb_20211201_models.DescribeUserQuotaRequest,
    ) -> adb_20211201_models.DescribeUserQuotaResponse:
        """
        @summary Queries available quotas.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DescribeUserQuotaRequest
        @return: DescribeUserQuotaResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_user_quota_with_options_async(request, runtime)

    def describe_worker_detection_with_options(
        self,
        request: adb_20211201_models.DescribeWorkerDetectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeWorkerDetectionResponse:
        """
        @summary Queries the diagnostic results of the storage layer.
        
        @param request: DescribeWorkerDetectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeWorkerDetectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeWorkerDetection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeWorkerDetectionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeWorkerDetectionResponse(),
                self.execute(params, req, runtime)
            )

    async def describe_worker_detection_with_options_async(
        self,
        request: adb_20211201_models.DescribeWorkerDetectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DescribeWorkerDetectionResponse:
        """
        @summary Queries the diagnostic results of the storage layer.
        
        @param request: DescribeWorkerDetectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DescribeWorkerDetectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DescribeWorkerDetection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DescribeWorkerDetectionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DescribeWorkerDetectionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def describe_worker_detection(
        self,
        request: adb_20211201_models.DescribeWorkerDetectionRequest,
    ) -> adb_20211201_models.DescribeWorkerDetectionResponse:
        """
        @summary Queries the diagnostic results of the storage layer.
        
        @param request: DescribeWorkerDetectionRequest
        @return: DescribeWorkerDetectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.describe_worker_detection_with_options(request, runtime)

    async def describe_worker_detection_async(
        self,
        request: adb_20211201_models.DescribeWorkerDetectionRequest,
    ) -> adb_20211201_models.DescribeWorkerDetectionResponse:
        """
        @summary Queries the diagnostic results of the storage layer.
        
        @param request: DescribeWorkerDetectionRequest
        @return: DescribeWorkerDetectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.describe_worker_detection_with_options_async(request, runtime)

    def detach_user_eniwith_options(
        self,
        request: adb_20211201_models.DetachUserENIRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DetachUserENIResponse:
        """
        @summary 解绑用户弹性网卡
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DetachUserENIRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DetachUserENIResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DetachUserENI',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DetachUserENIResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DetachUserENIResponse(),
                self.execute(params, req, runtime)
            )

    async def detach_user_eniwith_options_async(
        self,
        request: adb_20211201_models.DetachUserENIRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DetachUserENIResponse:
        """
        @summary 解绑用户弹性网卡
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DetachUserENIRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DetachUserENIResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DetachUserENI',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DetachUserENIResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DetachUserENIResponse(),
                await self.execute_async(params, req, runtime)
            )

    def detach_user_eni(
        self,
        request: adb_20211201_models.DetachUserENIRequest,
    ) -> adb_20211201_models.DetachUserENIResponse:
        """
        @summary 解绑用户弹性网卡
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DetachUserENIRequest
        @return: DetachUserENIResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.detach_user_eniwith_options(request, runtime)

    async def detach_user_eni_async(
        self,
        request: adb_20211201_models.DetachUserENIRequest,
    ) -> adb_20211201_models.DetachUserENIResponse:
        """
        @summary 解绑用户弹性网卡
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DetachUserENIRequest
        @return: DetachUserENIResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.detach_user_eniwith_options_async(request, runtime)

    def disable_advice_service_with_options(
        self,
        request: adb_20211201_models.DisableAdviceServiceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DisableAdviceServiceResponse:
        """
        @summary Disables the suggestion feature.
        
        @param request: DisableAdviceServiceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DisableAdviceServiceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DisableAdviceService',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DisableAdviceServiceResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DisableAdviceServiceResponse(),
                self.execute(params, req, runtime)
            )

    async def disable_advice_service_with_options_async(
        self,
        request: adb_20211201_models.DisableAdviceServiceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DisableAdviceServiceResponse:
        """
        @summary Disables the suggestion feature.
        
        @param request: DisableAdviceServiceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DisableAdviceServiceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DisableAdviceService',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DisableAdviceServiceResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DisableAdviceServiceResponse(),
                await self.execute_async(params, req, runtime)
            )

    def disable_advice_service(
        self,
        request: adb_20211201_models.DisableAdviceServiceRequest,
    ) -> adb_20211201_models.DisableAdviceServiceResponse:
        """
        @summary Disables the suggestion feature.
        
        @param request: DisableAdviceServiceRequest
        @return: DisableAdviceServiceResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.disable_advice_service_with_options(request, runtime)

    async def disable_advice_service_async(
        self,
        request: adb_20211201_models.DisableAdviceServiceRequest,
    ) -> adb_20211201_models.DisableAdviceServiceResponse:
        """
        @summary Disables the suggestion feature.
        
        @param request: DisableAdviceServiceRequest
        @return: DisableAdviceServiceResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.disable_advice_service_with_options_async(request, runtime)

    def disable_elastic_plan_with_options(
        self,
        request: adb_20211201_models.DisableElasticPlanRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DisableElasticPlanResponse:
        """
        @summary Disables a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DisableElasticPlanRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DisableElasticPlanResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DisableElasticPlan',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DisableElasticPlanResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DisableElasticPlanResponse(),
                self.execute(params, req, runtime)
            )

    async def disable_elastic_plan_with_options_async(
        self,
        request: adb_20211201_models.DisableElasticPlanRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DisableElasticPlanResponse:
        """
        @summary Disables a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DisableElasticPlanRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DisableElasticPlanResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DisableElasticPlan',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DisableElasticPlanResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DisableElasticPlanResponse(),
                await self.execute_async(params, req, runtime)
            )

    def disable_elastic_plan(
        self,
        request: adb_20211201_models.DisableElasticPlanRequest,
    ) -> adb_20211201_models.DisableElasticPlanResponse:
        """
        @summary Disables a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DisableElasticPlanRequest
        @return: DisableElasticPlanResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.disable_elastic_plan_with_options(request, runtime)

    async def disable_elastic_plan_async(
        self,
        request: adb_20211201_models.DisableElasticPlanRequest,
    ) -> adb_20211201_models.DisableElasticPlanResponse:
        """
        @summary Disables a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: DisableElasticPlanRequest
        @return: DisableElasticPlanResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.disable_elastic_plan_with_options_async(request, runtime)

    def download_diagnosis_records_with_options(
        self,
        request: adb_20211201_models.DownloadDiagnosisRecordsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DownloadDiagnosisRecordsResponse:
        """
        @summary Downloads the diagnostic information about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DownloadDiagnosisRecordsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DownloadDiagnosisRecordsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.client_ip):
            query['ClientIp'] = request.client_ip
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.database):
            query['Database'] = request.database
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.max_peak_memory):
            query['MaxPeakMemory'] = request.max_peak_memory
        if not UtilClient.is_unset(request.max_scan_size):
            query['MaxScanSize'] = request.max_scan_size
        if not UtilClient.is_unset(request.min_peak_memory):
            query['MinPeakMemory'] = request.min_peak_memory
        if not UtilClient.is_unset(request.min_scan_size):
            query['MinScanSize'] = request.min_scan_size
        if not UtilClient.is_unset(request.query_condition):
            query['QueryCondition'] = request.query_condition
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            query['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.user_name):
            query['UserName'] = request.user_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DownloadDiagnosisRecords',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DownloadDiagnosisRecordsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DownloadDiagnosisRecordsResponse(),
                self.execute(params, req, runtime)
            )

    async def download_diagnosis_records_with_options_async(
        self,
        request: adb_20211201_models.DownloadDiagnosisRecordsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DownloadDiagnosisRecordsResponse:
        """
        @summary Downloads the diagnostic information about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DownloadDiagnosisRecordsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DownloadDiagnosisRecordsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.client_ip):
            query['ClientIp'] = request.client_ip
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.database):
            query['Database'] = request.database
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.keyword):
            query['Keyword'] = request.keyword
        if not UtilClient.is_unset(request.lang):
            query['Lang'] = request.lang
        if not UtilClient.is_unset(request.max_peak_memory):
            query['MaxPeakMemory'] = request.max_peak_memory
        if not UtilClient.is_unset(request.max_scan_size):
            query['MaxScanSize'] = request.max_scan_size
        if not UtilClient.is_unset(request.min_peak_memory):
            query['MinPeakMemory'] = request.min_peak_memory
        if not UtilClient.is_unset(request.min_scan_size):
            query['MinScanSize'] = request.min_scan_size
        if not UtilClient.is_unset(request.query_condition):
            query['QueryCondition'] = request.query_condition
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            query['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.user_name):
            query['UserName'] = request.user_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DownloadDiagnosisRecords',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DownloadDiagnosisRecordsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DownloadDiagnosisRecordsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def download_diagnosis_records(
        self,
        request: adb_20211201_models.DownloadDiagnosisRecordsRequest,
    ) -> adb_20211201_models.DownloadDiagnosisRecordsResponse:
        """
        @summary Downloads the diagnostic information about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DownloadDiagnosisRecordsRequest
        @return: DownloadDiagnosisRecordsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.download_diagnosis_records_with_options(request, runtime)

    async def download_diagnosis_records_async(
        self,
        request: adb_20211201_models.DownloadDiagnosisRecordsRequest,
    ) -> adb_20211201_models.DownloadDiagnosisRecordsResponse:
        """
        @summary Downloads the diagnostic information about SQL statements that meet a query condition for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: DownloadDiagnosisRecordsRequest
        @return: DownloadDiagnosisRecordsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.download_diagnosis_records_with_options_async(request, runtime)

    def download_instance_cacertificate_with_options(
        self,
        request: adb_20211201_models.DownloadInstanceCACertificateRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DownloadInstanceCACertificateResponse:
        """
        @summary Queries the Object Storage Service (OSS) URL of the downloaded certificate authority (CA) certificate that is used to connect to the wide table engine.
        
        @param request: DownloadInstanceCACertificateRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DownloadInstanceCACertificateResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DownloadInstanceCACertificate',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DownloadInstanceCACertificateResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DownloadInstanceCACertificateResponse(),
                self.execute(params, req, runtime)
            )

    async def download_instance_cacertificate_with_options_async(
        self,
        request: adb_20211201_models.DownloadInstanceCACertificateRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.DownloadInstanceCACertificateResponse:
        """
        @summary Queries the Object Storage Service (OSS) URL of the downloaded certificate authority (CA) certificate that is used to connect to the wide table engine.
        
        @param request: DownloadInstanceCACertificateRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: DownloadInstanceCACertificateResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='DownloadInstanceCACertificate',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.DownloadInstanceCACertificateResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.DownloadInstanceCACertificateResponse(),
                await self.execute_async(params, req, runtime)
            )

    def download_instance_cacertificate(
        self,
        request: adb_20211201_models.DownloadInstanceCACertificateRequest,
    ) -> adb_20211201_models.DownloadInstanceCACertificateResponse:
        """
        @summary Queries the Object Storage Service (OSS) URL of the downloaded certificate authority (CA) certificate that is used to connect to the wide table engine.
        
        @param request: DownloadInstanceCACertificateRequest
        @return: DownloadInstanceCACertificateResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.download_instance_cacertificate_with_options(request, runtime)

    async def download_instance_cacertificate_async(
        self,
        request: adb_20211201_models.DownloadInstanceCACertificateRequest,
    ) -> adb_20211201_models.DownloadInstanceCACertificateResponse:
        """
        @summary Queries the Object Storage Service (OSS) URL of the downloaded certificate authority (CA) certificate that is used to connect to the wide table engine.
        
        @param request: DownloadInstanceCACertificateRequest
        @return: DownloadInstanceCACertificateResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.download_instance_cacertificate_with_options_async(request, runtime)

    def enable_advice_service_with_options(
        self,
        request: adb_20211201_models.EnableAdviceServiceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.EnableAdviceServiceResponse:
        """
        @summary Enables the suggestion feature.
        
        @param request: EnableAdviceServiceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: EnableAdviceServiceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='EnableAdviceService',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.EnableAdviceServiceResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.EnableAdviceServiceResponse(),
                self.execute(params, req, runtime)
            )

    async def enable_advice_service_with_options_async(
        self,
        request: adb_20211201_models.EnableAdviceServiceRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.EnableAdviceServiceResponse:
        """
        @summary Enables the suggestion feature.
        
        @param request: EnableAdviceServiceRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: EnableAdviceServiceResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='EnableAdviceService',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.EnableAdviceServiceResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.EnableAdviceServiceResponse(),
                await self.execute_async(params, req, runtime)
            )

    def enable_advice_service(
        self,
        request: adb_20211201_models.EnableAdviceServiceRequest,
    ) -> adb_20211201_models.EnableAdviceServiceResponse:
        """
        @summary Enables the suggestion feature.
        
        @param request: EnableAdviceServiceRequest
        @return: EnableAdviceServiceResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.enable_advice_service_with_options(request, runtime)

    async def enable_advice_service_async(
        self,
        request: adb_20211201_models.EnableAdviceServiceRequest,
    ) -> adb_20211201_models.EnableAdviceServiceResponse:
        """
        @summary Enables the suggestion feature.
        
        @param request: EnableAdviceServiceRequest
        @return: EnableAdviceServiceResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.enable_advice_service_with_options_async(request, runtime)

    def enable_elastic_plan_with_options(
        self,
        request: adb_20211201_models.EnableElasticPlanRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.EnableElasticPlanResponse:
        """
        @summary Enables a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: EnableElasticPlanRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: EnableElasticPlanResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='EnableElasticPlan',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.EnableElasticPlanResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.EnableElasticPlanResponse(),
                self.execute(params, req, runtime)
            )

    async def enable_elastic_plan_with_options_async(
        self,
        request: adb_20211201_models.EnableElasticPlanRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.EnableElasticPlanResponse:
        """
        @summary Enables a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: EnableElasticPlanRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: EnableElasticPlanResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='EnableElasticPlan',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.EnableElasticPlanResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.EnableElasticPlanResponse(),
                await self.execute_async(params, req, runtime)
            )

    def enable_elastic_plan(
        self,
        request: adb_20211201_models.EnableElasticPlanRequest,
    ) -> adb_20211201_models.EnableElasticPlanResponse:
        """
        @summary Enables a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: EnableElasticPlanRequest
        @return: EnableElasticPlanResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.enable_elastic_plan_with_options(request, runtime)

    async def enable_elastic_plan_async(
        self,
        request: adb_20211201_models.EnableElasticPlanRequest,
    ) -> adb_20211201_models.EnableElasticPlanResponse:
        """
        @summary Enables a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: EnableElasticPlanRequest
        @return: EnableElasticPlanResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.enable_elastic_plan_with_options_async(request, runtime)

    def execute_spark_repl_statement_with_options(
        self,
        request: adb_20211201_models.ExecuteSparkReplStatementRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ExecuteSparkReplStatementResponse:
        """
        @summary Executes part of the code in a Spark job.
        
        @param request: ExecuteSparkReplStatementRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ExecuteSparkReplStatementResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        if not UtilClient.is_unset(request.code):
            body['Code'] = request.code
        if not UtilClient.is_unset(request.code_type):
            body['CodeType'] = request.code_type
        if not UtilClient.is_unset(request.session_id):
            body['SessionId'] = request.session_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ExecuteSparkReplStatement',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ExecuteSparkReplStatementResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ExecuteSparkReplStatementResponse(),
                self.execute(params, req, runtime)
            )

    async def execute_spark_repl_statement_with_options_async(
        self,
        request: adb_20211201_models.ExecuteSparkReplStatementRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ExecuteSparkReplStatementResponse:
        """
        @summary Executes part of the code in a Spark job.
        
        @param request: ExecuteSparkReplStatementRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ExecuteSparkReplStatementResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        if not UtilClient.is_unset(request.code):
            body['Code'] = request.code
        if not UtilClient.is_unset(request.code_type):
            body['CodeType'] = request.code_type
        if not UtilClient.is_unset(request.session_id):
            body['SessionId'] = request.session_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ExecuteSparkReplStatement',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ExecuteSparkReplStatementResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ExecuteSparkReplStatementResponse(),
                await self.execute_async(params, req, runtime)
            )

    def execute_spark_repl_statement(
        self,
        request: adb_20211201_models.ExecuteSparkReplStatementRequest,
    ) -> adb_20211201_models.ExecuteSparkReplStatementResponse:
        """
        @summary Executes part of the code in a Spark job.
        
        @param request: ExecuteSparkReplStatementRequest
        @return: ExecuteSparkReplStatementResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.execute_spark_repl_statement_with_options(request, runtime)

    async def execute_spark_repl_statement_async(
        self,
        request: adb_20211201_models.ExecuteSparkReplStatementRequest,
    ) -> adb_20211201_models.ExecuteSparkReplStatementResponse:
        """
        @summary Executes part of the code in a Spark job.
        
        @param request: ExecuteSparkReplStatementRequest
        @return: ExecuteSparkReplStatementResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.execute_spark_repl_statement_with_options_async(request, runtime)

    def execute_spark_warehouse_batch_sqlwith_options(
        self,
        request: adb_20211201_models.ExecuteSparkWarehouseBatchSQLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ExecuteSparkWarehouseBatchSQLResponse:
        """
        @summary 执行一段Spark Batch SQL
        
        @param request: ExecuteSparkWarehouseBatchSQLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ExecuteSparkWarehouseBatchSQLResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.agency):
            body['Agency'] = request.agency
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.execute_result_limit):
            body['ExecuteResultLimit'] = request.execute_result_limit
        if not UtilClient.is_unset(request.execute_time_limit_in_seconds):
            body['ExecuteTimeLimitInSeconds'] = request.execute_time_limit_in_seconds
        if not UtilClient.is_unset(request.query):
            body['Query'] = request.query
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.runtime_config):
            body['RuntimeConfig'] = request.runtime_config
        if not UtilClient.is_unset(request.schema):
            body['Schema'] = request.schema
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ExecuteSparkWarehouseBatchSQL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ExecuteSparkWarehouseBatchSQLResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ExecuteSparkWarehouseBatchSQLResponse(),
                self.execute(params, req, runtime)
            )

    async def execute_spark_warehouse_batch_sqlwith_options_async(
        self,
        request: adb_20211201_models.ExecuteSparkWarehouseBatchSQLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ExecuteSparkWarehouseBatchSQLResponse:
        """
        @summary 执行一段Spark Batch SQL
        
        @param request: ExecuteSparkWarehouseBatchSQLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ExecuteSparkWarehouseBatchSQLResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.agency):
            body['Agency'] = request.agency
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.execute_result_limit):
            body['ExecuteResultLimit'] = request.execute_result_limit
        if not UtilClient.is_unset(request.execute_time_limit_in_seconds):
            body['ExecuteTimeLimitInSeconds'] = request.execute_time_limit_in_seconds
        if not UtilClient.is_unset(request.query):
            body['Query'] = request.query
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.runtime_config):
            body['RuntimeConfig'] = request.runtime_config
        if not UtilClient.is_unset(request.schema):
            body['Schema'] = request.schema
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ExecuteSparkWarehouseBatchSQL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ExecuteSparkWarehouseBatchSQLResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ExecuteSparkWarehouseBatchSQLResponse(),
                await self.execute_async(params, req, runtime)
            )

    def execute_spark_warehouse_batch_sql(
        self,
        request: adb_20211201_models.ExecuteSparkWarehouseBatchSQLRequest,
    ) -> adb_20211201_models.ExecuteSparkWarehouseBatchSQLResponse:
        """
        @summary 执行一段Spark Batch SQL
        
        @param request: ExecuteSparkWarehouseBatchSQLRequest
        @return: ExecuteSparkWarehouseBatchSQLResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.execute_spark_warehouse_batch_sqlwith_options(request, runtime)

    async def execute_spark_warehouse_batch_sql_async(
        self,
        request: adb_20211201_models.ExecuteSparkWarehouseBatchSQLRequest,
    ) -> adb_20211201_models.ExecuteSparkWarehouseBatchSQLResponse:
        """
        @summary 执行一段Spark Batch SQL
        
        @param request: ExecuteSparkWarehouseBatchSQLRequest
        @return: ExecuteSparkWarehouseBatchSQLResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.execute_spark_warehouse_batch_sqlwith_options_async(request, runtime)

    def exist_running_sqlengine_with_options(
        self,
        request: adb_20211201_models.ExistRunningSQLEngineRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ExistRunningSQLEngineResponse:
        """
        @summary Queries whether a running SQL engine exists.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ExistRunningSQLEngineRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ExistRunningSQLEngineResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ExistRunningSQLEngine',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ExistRunningSQLEngineResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ExistRunningSQLEngineResponse(),
                self.execute(params, req, runtime)
            )

    async def exist_running_sqlengine_with_options_async(
        self,
        request: adb_20211201_models.ExistRunningSQLEngineRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ExistRunningSQLEngineResponse:
        """
        @summary Queries whether a running SQL engine exists.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ExistRunningSQLEngineRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ExistRunningSQLEngineResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ExistRunningSQLEngine',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ExistRunningSQLEngineResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ExistRunningSQLEngineResponse(),
                await self.execute_async(params, req, runtime)
            )

    def exist_running_sqlengine(
        self,
        request: adb_20211201_models.ExistRunningSQLEngineRequest,
    ) -> adb_20211201_models.ExistRunningSQLEngineResponse:
        """
        @summary Queries whether a running SQL engine exists.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ExistRunningSQLEngineRequest
        @return: ExistRunningSQLEngineResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.exist_running_sqlengine_with_options(request, runtime)

    async def exist_running_sqlengine_async(
        self,
        request: adb_20211201_models.ExistRunningSQLEngineRequest,
    ) -> adb_20211201_models.ExistRunningSQLEngineResponse:
        """
        @summary Queries whether a running SQL engine exists.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ExistRunningSQLEngineRequest
        @return: ExistRunningSQLEngineResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.exist_running_sqlengine_with_options_async(request, runtime)

    def get_aps_managed_databases_with_options(
        self,
        request: adb_20211201_models.GetApsManagedDatabasesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetApsManagedDatabasesResponse:
        """
        @summary Queries a list of databases.
        
        @param request: GetApsManagedDatabasesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetApsManagedDatabasesResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetApsManagedDatabases',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetApsManagedDatabasesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetApsManagedDatabasesResponse(),
                self.execute(params, req, runtime)
            )

    async def get_aps_managed_databases_with_options_async(
        self,
        request: adb_20211201_models.GetApsManagedDatabasesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetApsManagedDatabasesResponse:
        """
        @summary Queries a list of databases.
        
        @param request: GetApsManagedDatabasesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetApsManagedDatabasesResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetApsManagedDatabases',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetApsManagedDatabasesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetApsManagedDatabasesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_aps_managed_databases(
        self,
        request: adb_20211201_models.GetApsManagedDatabasesRequest,
    ) -> adb_20211201_models.GetApsManagedDatabasesResponse:
        """
        @summary Queries a list of databases.
        
        @param request: GetApsManagedDatabasesRequest
        @return: GetApsManagedDatabasesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_aps_managed_databases_with_options(request, runtime)

    async def get_aps_managed_databases_async(
        self,
        request: adb_20211201_models.GetApsManagedDatabasesRequest,
    ) -> adb_20211201_models.GetApsManagedDatabasesResponse:
        """
        @summary Queries a list of databases.
        
        @param request: GetApsManagedDatabasesRequest
        @return: GetApsManagedDatabasesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_aps_managed_databases_with_options_async(request, runtime)

    def get_create_table_sqlwith_options(
        self,
        request: adb_20211201_models.GetCreateTableSQLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetCreateTableSQLResponse:
        """
        @summary Queries the table creation statement for tables.
        
        @param request: GetCreateTableSQLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetCreateTableSQLResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetCreateTableSQL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetCreateTableSQLResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetCreateTableSQLResponse(),
                self.execute(params, req, runtime)
            )

    async def get_create_table_sqlwith_options_async(
        self,
        request: adb_20211201_models.GetCreateTableSQLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetCreateTableSQLResponse:
        """
        @summary Queries the table creation statement for tables.
        
        @param request: GetCreateTableSQLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetCreateTableSQLResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetCreateTableSQL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetCreateTableSQLResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetCreateTableSQLResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_create_table_sql(
        self,
        request: adb_20211201_models.GetCreateTableSQLRequest,
    ) -> adb_20211201_models.GetCreateTableSQLResponse:
        """
        @summary Queries the table creation statement for tables.
        
        @param request: GetCreateTableSQLRequest
        @return: GetCreateTableSQLResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_create_table_sqlwith_options(request, runtime)

    async def get_create_table_sql_async(
        self,
        request: adb_20211201_models.GetCreateTableSQLRequest,
    ) -> adb_20211201_models.GetCreateTableSQLResponse:
        """
        @summary Queries the table creation statement for tables.
        
        @param request: GetCreateTableSQLRequest
        @return: GetCreateTableSQLResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_create_table_sqlwith_options_async(request, runtime)

    def get_database_objects_with_options(
        self,
        request: adb_20211201_models.GetDatabaseObjectsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetDatabaseObjectsResponse:
        """
        @summary Queries the information about databases.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetDatabaseObjectsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetDatabaseObjectsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.filter_owner):
            query['FilterOwner'] = request.filter_owner
        if not UtilClient.is_unset(request.filter_schema_name):
            query['FilterSchemaName'] = request.filter_schema_name
        if not UtilClient.is_unset(request.order_by):
            query['OrderBy'] = request.order_by
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetDatabaseObjects',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetDatabaseObjectsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetDatabaseObjectsResponse(),
                self.execute(params, req, runtime)
            )

    async def get_database_objects_with_options_async(
        self,
        request: adb_20211201_models.GetDatabaseObjectsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetDatabaseObjectsResponse:
        """
        @summary Queries the information about databases.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetDatabaseObjectsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetDatabaseObjectsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.filter_owner):
            query['FilterOwner'] = request.filter_owner
        if not UtilClient.is_unset(request.filter_schema_name):
            query['FilterSchemaName'] = request.filter_schema_name
        if not UtilClient.is_unset(request.order_by):
            query['OrderBy'] = request.order_by
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetDatabaseObjects',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetDatabaseObjectsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetDatabaseObjectsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_database_objects(
        self,
        request: adb_20211201_models.GetDatabaseObjectsRequest,
    ) -> adb_20211201_models.GetDatabaseObjectsResponse:
        """
        @summary Queries the information about databases.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetDatabaseObjectsRequest
        @return: GetDatabaseObjectsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_database_objects_with_options(request, runtime)

    async def get_database_objects_async(
        self,
        request: adb_20211201_models.GetDatabaseObjectsRequest,
    ) -> adb_20211201_models.GetDatabaseObjectsResponse:
        """
        @summary Queries the information about databases.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetDatabaseObjectsRequest
        @return: GetDatabaseObjectsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_database_objects_with_options_async(request, runtime)

    def get_lake_storage_with_options(
        self,
        request: adb_20211201_models.GetLakeStorageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetLakeStorageResponse:
        """
        @summary Queries a lake storage.
        
        @param request: GetLakeStorageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetLakeStorageResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.lake_storage_id):
            query['LakeStorageId'] = request.lake_storage_id
        body = {}
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetLakeStorage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetLakeStorageResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetLakeStorageResponse(),
                self.execute(params, req, runtime)
            )

    async def get_lake_storage_with_options_async(
        self,
        request: adb_20211201_models.GetLakeStorageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetLakeStorageResponse:
        """
        @summary Queries a lake storage.
        
        @param request: GetLakeStorageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetLakeStorageResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.lake_storage_id):
            query['LakeStorageId'] = request.lake_storage_id
        body = {}
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetLakeStorage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetLakeStorageResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetLakeStorageResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_lake_storage(
        self,
        request: adb_20211201_models.GetLakeStorageRequest,
    ) -> adb_20211201_models.GetLakeStorageResponse:
        """
        @summary Queries a lake storage.
        
        @param request: GetLakeStorageRequest
        @return: GetLakeStorageResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_lake_storage_with_options(request, runtime)

    async def get_lake_storage_async(
        self,
        request: adb_20211201_models.GetLakeStorageRequest,
    ) -> adb_20211201_models.GetLakeStorageResponse:
        """
        @summary Queries a lake storage.
        
        @param request: GetLakeStorageRequest
        @return: GetLakeStorageResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_lake_storage_with_options_async(request, runtime)

    def get_spark_app_attempt_log_with_options(
        self,
        request: adb_20211201_models.GetSparkAppAttemptLogRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppAttemptLogResponse:
        """
        @summary Queries the information about the retry log of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppAttemptLogRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppAttemptLogResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        body = {}
        if not UtilClient.is_unset(request.attempt_id):
            body['AttemptId'] = request.attempt_id
        if not UtilClient.is_unset(request.log_length):
            body['LogLength'] = request.log_length
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppAttemptLog',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppAttemptLogResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppAttemptLogResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_app_attempt_log_with_options_async(
        self,
        request: adb_20211201_models.GetSparkAppAttemptLogRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppAttemptLogResponse:
        """
        @summary Queries the information about the retry log of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppAttemptLogRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppAttemptLogResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        body = {}
        if not UtilClient.is_unset(request.attempt_id):
            body['AttemptId'] = request.attempt_id
        if not UtilClient.is_unset(request.log_length):
            body['LogLength'] = request.log_length
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppAttemptLog',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppAttemptLogResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppAttemptLogResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_app_attempt_log(
        self,
        request: adb_20211201_models.GetSparkAppAttemptLogRequest,
    ) -> adb_20211201_models.GetSparkAppAttemptLogResponse:
        """
        @summary Queries the information about the retry log of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppAttemptLogRequest
        @return: GetSparkAppAttemptLogResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_app_attempt_log_with_options(request, runtime)

    async def get_spark_app_attempt_log_async(
        self,
        request: adb_20211201_models.GetSparkAppAttemptLogRequest,
    ) -> adb_20211201_models.GetSparkAppAttemptLogResponse:
        """
        @summary Queries the information about the retry log of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppAttemptLogRequest
        @return: GetSparkAppAttemptLogResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_app_attempt_log_with_options_async(request, runtime)

    def get_spark_app_info_with_options(
        self,
        request: adb_20211201_models.GetSparkAppInfoRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppInfoResponse:
        """
        @summary Queries the information about an Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppInfoRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppInfoResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppInfo',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppInfoResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppInfoResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_app_info_with_options_async(
        self,
        request: adb_20211201_models.GetSparkAppInfoRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppInfoResponse:
        """
        @summary Queries the information about an Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppInfoRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppInfoResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppInfo',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppInfoResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppInfoResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_app_info(
        self,
        request: adb_20211201_models.GetSparkAppInfoRequest,
    ) -> adb_20211201_models.GetSparkAppInfoResponse:
        """
        @summary Queries the information about an Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppInfoRequest
        @return: GetSparkAppInfoResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_app_info_with_options(request, runtime)

    async def get_spark_app_info_async(
        self,
        request: adb_20211201_models.GetSparkAppInfoRequest,
    ) -> adb_20211201_models.GetSparkAppInfoResponse:
        """
        @summary Queries the information about an Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppInfoRequest
        @return: GetSparkAppInfoResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_app_info_with_options_async(request, runtime)

    def get_spark_app_log_with_options(
        self,
        request: adb_20211201_models.GetSparkAppLogRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppLogResponse:
        """
        @summary Queries the logs of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppLogRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppLogResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        if not UtilClient.is_unset(request.log_length):
            body['LogLength'] = request.log_length
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppLog',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppLogResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppLogResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_app_log_with_options_async(
        self,
        request: adb_20211201_models.GetSparkAppLogRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppLogResponse:
        """
        @summary Queries the logs of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppLogRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppLogResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        if not UtilClient.is_unset(request.log_length):
            body['LogLength'] = request.log_length
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppLog',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppLogResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppLogResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_app_log(
        self,
        request: adb_20211201_models.GetSparkAppLogRequest,
    ) -> adb_20211201_models.GetSparkAppLogResponse:
        """
        @summary Queries the logs of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppLogRequest
        @return: GetSparkAppLogResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_app_log_with_options(request, runtime)

    async def get_spark_app_log_async(
        self,
        request: adb_20211201_models.GetSparkAppLogRequest,
    ) -> adb_20211201_models.GetSparkAppLogResponse:
        """
        @summary Queries the logs of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppLogRequest
        @return: GetSparkAppLogResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_app_log_with_options_async(request, runtime)

    def get_spark_app_metrics_with_options(
        self,
        request: adb_20211201_models.GetSparkAppMetricsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppMetricsResponse:
        """
        @summary Queries the metrics of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppMetricsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppMetricsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppMetrics',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppMetricsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppMetricsResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_app_metrics_with_options_async(
        self,
        request: adb_20211201_models.GetSparkAppMetricsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppMetricsResponse:
        """
        @summary Queries the metrics of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppMetricsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppMetricsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppMetrics',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppMetricsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppMetricsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_app_metrics(
        self,
        request: adb_20211201_models.GetSparkAppMetricsRequest,
    ) -> adb_20211201_models.GetSparkAppMetricsResponse:
        """
        @summary Queries the metrics of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppMetricsRequest
        @return: GetSparkAppMetricsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_app_metrics_with_options(request, runtime)

    async def get_spark_app_metrics_async(
        self,
        request: adb_20211201_models.GetSparkAppMetricsRequest,
    ) -> adb_20211201_models.GetSparkAppMetricsResponse:
        """
        @summary Queries the metrics of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppMetricsRequest
        @return: GetSparkAppMetricsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_app_metrics_with_options_async(request, runtime)

    def get_spark_app_state_with_options(
        self,
        request: adb_20211201_models.GetSparkAppStateRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppStateResponse:
        """
        @summary Queries the status of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppStateRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppStateResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppState',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppStateResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppStateResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_app_state_with_options_async(
        self,
        request: adb_20211201_models.GetSparkAppStateRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppStateResponse:
        """
        @summary Queries the status of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppStateRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppStateResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppState',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppStateResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppStateResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_app_state(
        self,
        request: adb_20211201_models.GetSparkAppStateRequest,
    ) -> adb_20211201_models.GetSparkAppStateResponse:
        """
        @summary Queries the status of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppStateRequest
        @return: GetSparkAppStateResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_app_state_with_options(request, runtime)

    async def get_spark_app_state_async(
        self,
        request: adb_20211201_models.GetSparkAppStateRequest,
    ) -> adb_20211201_models.GetSparkAppStateResponse:
        """
        @summary Queries the status of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkAppStateRequest
        @return: GetSparkAppStateResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_app_state_with_options_async(request, runtime)

    def get_spark_app_web_ui_address_with_options(
        self,
        request: adb_20211201_models.GetSparkAppWebUiAddressRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppWebUiAddressResponse:
        """
        @summary Queries the URL of the web UI for a Spark application.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetSparkAppWebUiAddressRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppWebUiAddressResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppWebUiAddress',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppWebUiAddressResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppWebUiAddressResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_app_web_ui_address_with_options_async(
        self,
        request: adb_20211201_models.GetSparkAppWebUiAddressRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkAppWebUiAddressResponse:
        """
        @summary Queries the URL of the web UI for a Spark application.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetSparkAppWebUiAddressRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkAppWebUiAddressResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkAppWebUiAddress',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppWebUiAddressResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkAppWebUiAddressResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_app_web_ui_address(
        self,
        request: adb_20211201_models.GetSparkAppWebUiAddressRequest,
    ) -> adb_20211201_models.GetSparkAppWebUiAddressResponse:
        """
        @summary Queries the URL of the web UI for a Spark application.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetSparkAppWebUiAddressRequest
        @return: GetSparkAppWebUiAddressResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_app_web_ui_address_with_options(request, runtime)

    async def get_spark_app_web_ui_address_async(
        self,
        request: adb_20211201_models.GetSparkAppWebUiAddressRequest,
    ) -> adb_20211201_models.GetSparkAppWebUiAddressResponse:
        """
        @summary Queries the URL of the web UI for a Spark application.
        
        @description    General endpoint: `adb.aliyuncs.com`.
        Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetSparkAppWebUiAddressRequest
        @return: GetSparkAppWebUiAddressResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_app_web_ui_address_with_options_async(request, runtime)

    def get_spark_config_log_path_with_options(
        self,
        request: adb_20211201_models.GetSparkConfigLogPathRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkConfigLogPathResponse:
        """
        @summary Queries the Spark log configuration of an AnalyticDB for MySQL cluster, including the default Spark log path.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkConfigLogPathRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkConfigLogPathResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkConfigLogPath',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkConfigLogPathResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkConfigLogPathResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_config_log_path_with_options_async(
        self,
        request: adb_20211201_models.GetSparkConfigLogPathRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkConfigLogPathResponse:
        """
        @summary Queries the Spark log configuration of an AnalyticDB for MySQL cluster, including the default Spark log path.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkConfigLogPathRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkConfigLogPathResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkConfigLogPath',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkConfigLogPathResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkConfigLogPathResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_config_log_path(
        self,
        request: adb_20211201_models.GetSparkConfigLogPathRequest,
    ) -> adb_20211201_models.GetSparkConfigLogPathResponse:
        """
        @summary Queries the Spark log configuration of an AnalyticDB for MySQL cluster, including the default Spark log path.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkConfigLogPathRequest
        @return: GetSparkConfigLogPathResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_config_log_path_with_options(request, runtime)

    async def get_spark_config_log_path_async(
        self,
        request: adb_20211201_models.GetSparkConfigLogPathRequest,
    ) -> adb_20211201_models.GetSparkConfigLogPathResponse:
        """
        @summary Queries the Spark log configuration of an AnalyticDB for MySQL cluster, including the default Spark log path.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkConfigLogPathRequest
        @return: GetSparkConfigLogPathResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_config_log_path_with_options_async(request, runtime)

    def get_spark_log_analyze_task_with_options(
        self,
        request: adb_20211201_models.GetSparkLogAnalyzeTaskRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkLogAnalyzeTaskResponse:
        """
        @summary Queries the results of a Spark log analysis task.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkLogAnalyzeTaskRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkLogAnalyzeTaskResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.task_id):
            body['TaskId'] = request.task_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkLogAnalyzeTask',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkLogAnalyzeTaskResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkLogAnalyzeTaskResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_log_analyze_task_with_options_async(
        self,
        request: adb_20211201_models.GetSparkLogAnalyzeTaskRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkLogAnalyzeTaskResponse:
        """
        @summary Queries the results of a Spark log analysis task.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkLogAnalyzeTaskRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkLogAnalyzeTaskResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.task_id):
            body['TaskId'] = request.task_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkLogAnalyzeTask',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkLogAnalyzeTaskResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkLogAnalyzeTaskResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_log_analyze_task(
        self,
        request: adb_20211201_models.GetSparkLogAnalyzeTaskRequest,
    ) -> adb_20211201_models.GetSparkLogAnalyzeTaskResponse:
        """
        @summary Queries the results of a Spark log analysis task.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkLogAnalyzeTaskRequest
        @return: GetSparkLogAnalyzeTaskResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_log_analyze_task_with_options(request, runtime)

    async def get_spark_log_analyze_task_async(
        self,
        request: adb_20211201_models.GetSparkLogAnalyzeTaskRequest,
    ) -> adb_20211201_models.GetSparkLogAnalyzeTaskResponse:
        """
        @summary Queries the results of a Spark log analysis task.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkLogAnalyzeTaskRequest
        @return: GetSparkLogAnalyzeTaskResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_log_analyze_task_with_options_async(request, runtime)

    def get_spark_repl_session_with_options(
        self,
        request: adb_20211201_models.GetSparkReplSessionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkReplSessionResponse:
        """
        @summary Queries the status of a Spark session.
        
        @param request: GetSparkReplSessionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkReplSessionResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        if not UtilClient.is_unset(request.session_id):
            body['SessionId'] = request.session_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkReplSession',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkReplSessionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkReplSessionResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_repl_session_with_options_async(
        self,
        request: adb_20211201_models.GetSparkReplSessionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkReplSessionResponse:
        """
        @summary Queries the status of a Spark session.
        
        @param request: GetSparkReplSessionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkReplSessionResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        if not UtilClient.is_unset(request.session_id):
            body['SessionId'] = request.session_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkReplSession',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkReplSessionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkReplSessionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_repl_session(
        self,
        request: adb_20211201_models.GetSparkReplSessionRequest,
    ) -> adb_20211201_models.GetSparkReplSessionResponse:
        """
        @summary Queries the status of a Spark session.
        
        @param request: GetSparkReplSessionRequest
        @return: GetSparkReplSessionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_repl_session_with_options(request, runtime)

    async def get_spark_repl_session_async(
        self,
        request: adb_20211201_models.GetSparkReplSessionRequest,
    ) -> adb_20211201_models.GetSparkReplSessionResponse:
        """
        @summary Queries the status of a Spark session.
        
        @param request: GetSparkReplSessionRequest
        @return: GetSparkReplSessionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_repl_session_with_options_async(request, runtime)

    def get_spark_repl_statement_with_options(
        self,
        request: adb_20211201_models.GetSparkReplStatementRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkReplStatementResponse:
        """
        @summary Queries the execution result of a code block.
        
        @param request: GetSparkReplStatementRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkReplStatementResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        if not UtilClient.is_unset(request.session_id):
            body['SessionId'] = request.session_id
        if not UtilClient.is_unset(request.statement_id):
            body['StatementId'] = request.statement_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkReplStatement',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkReplStatementResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkReplStatementResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_repl_statement_with_options_async(
        self,
        request: adb_20211201_models.GetSparkReplStatementRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkReplStatementResponse:
        """
        @summary Queries the execution result of a code block.
        
        @param request: GetSparkReplStatementRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkReplStatementResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        if not UtilClient.is_unset(request.session_id):
            body['SessionId'] = request.session_id
        if not UtilClient.is_unset(request.statement_id):
            body['StatementId'] = request.statement_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkReplStatement',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkReplStatementResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkReplStatementResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_repl_statement(
        self,
        request: adb_20211201_models.GetSparkReplStatementRequest,
    ) -> adb_20211201_models.GetSparkReplStatementResponse:
        """
        @summary Queries the execution result of a code block.
        
        @param request: GetSparkReplStatementRequest
        @return: GetSparkReplStatementResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_repl_statement_with_options(request, runtime)

    async def get_spark_repl_statement_async(
        self,
        request: adb_20211201_models.GetSparkReplStatementRequest,
    ) -> adb_20211201_models.GetSparkReplStatementResponse:
        """
        @summary Queries the execution result of a code block.
        
        @param request: GetSparkReplStatementRequest
        @return: GetSparkReplStatementResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_repl_statement_with_options_async(request, runtime)

    def get_spark_sqlengine_state_with_options(
        self,
        request: adb_20211201_models.GetSparkSQLEngineStateRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkSQLEngineStateResponse:
        """
        @summary Queries the state information about the Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkSQLEngineStateRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkSQLEngineStateResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkSQLEngineState',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkSQLEngineStateResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkSQLEngineStateResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_sqlengine_state_with_options_async(
        self,
        request: adb_20211201_models.GetSparkSQLEngineStateRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkSQLEngineStateResponse:
        """
        @summary Queries the state information about the Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkSQLEngineStateRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkSQLEngineStateResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkSQLEngineState',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkSQLEngineStateResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkSQLEngineStateResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_sqlengine_state(
        self,
        request: adb_20211201_models.GetSparkSQLEngineStateRequest,
    ) -> adb_20211201_models.GetSparkSQLEngineStateResponse:
        """
        @summary Queries the state information about the Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkSQLEngineStateRequest
        @return: GetSparkSQLEngineStateResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_sqlengine_state_with_options(request, runtime)

    async def get_spark_sqlengine_state_async(
        self,
        request: adb_20211201_models.GetSparkSQLEngineStateRequest,
    ) -> adb_20211201_models.GetSparkSQLEngineStateResponse:
        """
        @summary Queries the state information about the Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkSQLEngineStateRequest
        @return: GetSparkSQLEngineStateResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_sqlengine_state_with_options_async(request, runtime)

    def get_spark_template_file_content_with_options(
        self,
        request: adb_20211201_models.GetSparkTemplateFileContentRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkTemplateFileContentResponse:
        """
        @summary Queries the content of a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFileContentRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkTemplateFileContentResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.id):
            body['Id'] = request.id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkTemplateFileContent',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFileContentResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFileContentResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_template_file_content_with_options_async(
        self,
        request: adb_20211201_models.GetSparkTemplateFileContentRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkTemplateFileContentResponse:
        """
        @summary Queries the content of a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFileContentRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkTemplateFileContentResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.id):
            body['Id'] = request.id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkTemplateFileContent',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFileContentResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFileContentResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_template_file_content(
        self,
        request: adb_20211201_models.GetSparkTemplateFileContentRequest,
    ) -> adb_20211201_models.GetSparkTemplateFileContentResponse:
        """
        @summary Queries the content of a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFileContentRequest
        @return: GetSparkTemplateFileContentResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_template_file_content_with_options(request, runtime)

    async def get_spark_template_file_content_async(
        self,
        request: adb_20211201_models.GetSparkTemplateFileContentRequest,
    ) -> adb_20211201_models.GetSparkTemplateFileContentResponse:
        """
        @summary Queries the content of a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFileContentRequest
        @return: GetSparkTemplateFileContentResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_template_file_content_with_options_async(request, runtime)

    def get_spark_template_folder_tree_with_options(
        self,
        request: adb_20211201_models.GetSparkTemplateFolderTreeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkTemplateFolderTreeResponse:
        """
        @summary Queries the directory structure of Spark applications.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFolderTreeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkTemplateFolderTreeResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkTemplateFolderTree',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFolderTreeResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFolderTreeResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_template_folder_tree_with_options_async(
        self,
        request: adb_20211201_models.GetSparkTemplateFolderTreeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkTemplateFolderTreeResponse:
        """
        @summary Queries the directory structure of Spark applications.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFolderTreeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkTemplateFolderTreeResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkTemplateFolderTree',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFolderTreeResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFolderTreeResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_template_folder_tree(
        self,
        request: adb_20211201_models.GetSparkTemplateFolderTreeRequest,
    ) -> adb_20211201_models.GetSparkTemplateFolderTreeResponse:
        """
        @summary Queries the directory structure of Spark applications.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFolderTreeRequest
        @return: GetSparkTemplateFolderTreeResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_template_folder_tree_with_options(request, runtime)

    async def get_spark_template_folder_tree_async(
        self,
        request: adb_20211201_models.GetSparkTemplateFolderTreeRequest,
    ) -> adb_20211201_models.GetSparkTemplateFolderTreeResponse:
        """
        @summary Queries the directory structure of Spark applications.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFolderTreeRequest
        @return: GetSparkTemplateFolderTreeResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_template_folder_tree_with_options_async(request, runtime)

    def get_spark_template_full_tree_with_options(
        self,
        request: adb_20211201_models.GetSparkTemplateFullTreeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkTemplateFullTreeResponse:
        """
        @summary Queries the directory structure of Spark applications.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFullTreeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkTemplateFullTreeResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkTemplateFullTree',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFullTreeResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFullTreeResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_template_full_tree_with_options_async(
        self,
        request: adb_20211201_models.GetSparkTemplateFullTreeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkTemplateFullTreeResponse:
        """
        @summary Queries the directory structure of Spark applications.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFullTreeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkTemplateFullTreeResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkTemplateFullTree',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFullTreeResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkTemplateFullTreeResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_template_full_tree(
        self,
        request: adb_20211201_models.GetSparkTemplateFullTreeRequest,
    ) -> adb_20211201_models.GetSparkTemplateFullTreeResponse:
        """
        @summary Queries the directory structure of Spark applications.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFullTreeRequest
        @return: GetSparkTemplateFullTreeResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_template_full_tree_with_options(request, runtime)

    async def get_spark_template_full_tree_async(
        self,
        request: adb_20211201_models.GetSparkTemplateFullTreeRequest,
    ) -> adb_20211201_models.GetSparkTemplateFullTreeResponse:
        """
        @summary Queries the directory structure of Spark applications.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: GetSparkTemplateFullTreeRequest
        @return: GetSparkTemplateFullTreeResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_template_full_tree_with_options_async(request, runtime)

    def get_spark_warehouse_batch_sqlwith_options(
        self,
        request: adb_20211201_models.GetSparkWarehouseBatchSQLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkWarehouseBatchSQLResponse:
        """
        @summary 获取一段Spark Batch SQL的状态
        
        @param request: GetSparkWarehouseBatchSQLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkWarehouseBatchSQLResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.agency):
            body['Agency'] = request.agency
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.query_id):
            body['QueryId'] = request.query_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkWarehouseBatchSQL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkWarehouseBatchSQLResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkWarehouseBatchSQLResponse(),
                self.execute(params, req, runtime)
            )

    async def get_spark_warehouse_batch_sqlwith_options_async(
        self,
        request: adb_20211201_models.GetSparkWarehouseBatchSQLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetSparkWarehouseBatchSQLResponse:
        """
        @summary 获取一段Spark Batch SQL的状态
        
        @param request: GetSparkWarehouseBatchSQLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetSparkWarehouseBatchSQLResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.agency):
            body['Agency'] = request.agency
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.query_id):
            body['QueryId'] = request.query_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='GetSparkWarehouseBatchSQL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetSparkWarehouseBatchSQLResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetSparkWarehouseBatchSQLResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_spark_warehouse_batch_sql(
        self,
        request: adb_20211201_models.GetSparkWarehouseBatchSQLRequest,
    ) -> adb_20211201_models.GetSparkWarehouseBatchSQLResponse:
        """
        @summary 获取一段Spark Batch SQL的状态
        
        @param request: GetSparkWarehouseBatchSQLRequest
        @return: GetSparkWarehouseBatchSQLResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_spark_warehouse_batch_sqlwith_options(request, runtime)

    async def get_spark_warehouse_batch_sql_async(
        self,
        request: adb_20211201_models.GetSparkWarehouseBatchSQLRequest,
    ) -> adb_20211201_models.GetSparkWarehouseBatchSQLResponse:
        """
        @summary 获取一段Spark Batch SQL的状态
        
        @param request: GetSparkWarehouseBatchSQLRequest
        @return: GetSparkWarehouseBatchSQLResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_spark_warehouse_batch_sqlwith_options_async(request, runtime)

    def get_table_with_options(
        self,
        request: adb_20211201_models.GetTableRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetTableResponse:
        """
        @summary 获取表
        
        @param request: GetTableRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetTableResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.db_name):
            query['DbName'] = request.db_name
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetTable',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetTableResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetTableResponse(),
                self.execute(params, req, runtime)
            )

    async def get_table_with_options_async(
        self,
        request: adb_20211201_models.GetTableRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetTableResponse:
        """
        @summary 获取表
        
        @param request: GetTableRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetTableResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.db_name):
            query['DbName'] = request.db_name
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetTable',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetTableResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetTableResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_table(
        self,
        request: adb_20211201_models.GetTableRequest,
    ) -> adb_20211201_models.GetTableResponse:
        """
        @summary 获取表
        
        @param request: GetTableRequest
        @return: GetTableResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_table_with_options(request, runtime)

    async def get_table_async(
        self,
        request: adb_20211201_models.GetTableRequest,
    ) -> adb_20211201_models.GetTableResponse:
        """
        @summary 获取表
        
        @param request: GetTableRequest
        @return: GetTableResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_table_with_options_async(request, runtime)

    def get_table_columns_with_options(
        self,
        request: adb_20211201_models.GetTableColumnsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetTableColumnsResponse:
        """
        @summary Queries the information about columns.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetTableColumnsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetTableColumnsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.column_name):
            query['ColumnName'] = request.column_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetTableColumns',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetTableColumnsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetTableColumnsResponse(),
                self.execute(params, req, runtime)
            )

    async def get_table_columns_with_options_async(
        self,
        request: adb_20211201_models.GetTableColumnsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetTableColumnsResponse:
        """
        @summary Queries the information about columns.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetTableColumnsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetTableColumnsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.column_name):
            query['ColumnName'] = request.column_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetTableColumns',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetTableColumnsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetTableColumnsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_table_columns(
        self,
        request: adb_20211201_models.GetTableColumnsRequest,
    ) -> adb_20211201_models.GetTableColumnsResponse:
        """
        @summary Queries the information about columns.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetTableColumnsRequest
        @return: GetTableColumnsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_table_columns_with_options(request, runtime)

    async def get_table_columns_async(
        self,
        request: adb_20211201_models.GetTableColumnsRequest,
    ) -> adb_20211201_models.GetTableColumnsResponse:
        """
        @summary Queries the information about columns.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetTableColumnsRequest
        @return: GetTableColumnsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_table_columns_with_options_async(request, runtime)

    def get_table_ddlwith_options(
        self,
        request: adb_20211201_models.GetTableDDLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetTableDDLResponse:
        """
        @summary Queries the statement that is used to create a table.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetTableDDLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetTableDDLResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetTableDDL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetTableDDLResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetTableDDLResponse(),
                self.execute(params, req, runtime)
            )

    async def get_table_ddlwith_options_async(
        self,
        request: adb_20211201_models.GetTableDDLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetTableDDLResponse:
        """
        @summary Queries the statement that is used to create a table.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetTableDDLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetTableDDLResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.table_name):
            query['TableName'] = request.table_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetTableDDL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetTableDDLResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetTableDDLResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_table_ddl(
        self,
        request: adb_20211201_models.GetTableDDLRequest,
    ) -> adb_20211201_models.GetTableDDLResponse:
        """
        @summary Queries the statement that is used to create a table.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetTableDDLRequest
        @return: GetTableDDLResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_table_ddlwith_options(request, runtime)

    async def get_table_ddl_async(
        self,
        request: adb_20211201_models.GetTableDDLRequest,
    ) -> adb_20211201_models.GetTableDDLResponse:
        """
        @summary Queries the statement that is used to create a table.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetTableDDLRequest
        @return: GetTableDDLResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_table_ddlwith_options_async(request, runtime)

    def get_table_objects_with_options(
        self,
        request: adb_20211201_models.GetTableObjectsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetTableObjectsResponse:
        """
        @summary 获取table概要信息
        
        @param request: GetTableObjectsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetTableObjectsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.filter_description):
            query['FilterDescription'] = request.filter_description
        if not UtilClient.is_unset(request.filter_owner):
            query['FilterOwner'] = request.filter_owner
        if not UtilClient.is_unset(request.filter_tbl_name):
            query['FilterTblName'] = request.filter_tbl_name
        if not UtilClient.is_unset(request.filter_tbl_type):
            query['FilterTblType'] = request.filter_tbl_type
        if not UtilClient.is_unset(request.order_by):
            query['OrderBy'] = request.order_by
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetTableObjects',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetTableObjectsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetTableObjectsResponse(),
                self.execute(params, req, runtime)
            )

    async def get_table_objects_with_options_async(
        self,
        request: adb_20211201_models.GetTableObjectsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetTableObjectsResponse:
        """
        @summary 获取table概要信息
        
        @param request: GetTableObjectsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetTableObjectsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.filter_description):
            query['FilterDescription'] = request.filter_description
        if not UtilClient.is_unset(request.filter_owner):
            query['FilterOwner'] = request.filter_owner
        if not UtilClient.is_unset(request.filter_tbl_name):
            query['FilterTblName'] = request.filter_tbl_name
        if not UtilClient.is_unset(request.filter_tbl_type):
            query['FilterTblType'] = request.filter_tbl_type
        if not UtilClient.is_unset(request.order_by):
            query['OrderBy'] = request.order_by
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetTableObjects',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetTableObjectsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetTableObjectsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_table_objects(
        self,
        request: adb_20211201_models.GetTableObjectsRequest,
    ) -> adb_20211201_models.GetTableObjectsResponse:
        """
        @summary 获取table概要信息
        
        @param request: GetTableObjectsRequest
        @return: GetTableObjectsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_table_objects_with_options(request, runtime)

    async def get_table_objects_async(
        self,
        request: adb_20211201_models.GetTableObjectsRequest,
    ) -> adb_20211201_models.GetTableObjectsResponse:
        """
        @summary 获取table概要信息
        
        @param request: GetTableObjectsRequest
        @return: GetTableObjectsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_table_objects_with_options_async(request, runtime)

    def get_view_ddlwith_options(
        self,
        request: adb_20211201_models.GetViewDDLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetViewDDLResponse:
        """
        @summary Queries the statement that is used to create a view.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetViewDDLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetViewDDLResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.view_name):
            query['ViewName'] = request.view_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetViewDDL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetViewDDLResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetViewDDLResponse(),
                self.execute(params, req, runtime)
            )

    async def get_view_ddlwith_options_async(
        self,
        request: adb_20211201_models.GetViewDDLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetViewDDLResponse:
        """
        @summary Queries the statement that is used to create a view.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetViewDDLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetViewDDLResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        if not UtilClient.is_unset(request.view_name):
            query['ViewName'] = request.view_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetViewDDL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetViewDDLResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetViewDDLResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_view_ddl(
        self,
        request: adb_20211201_models.GetViewDDLRequest,
    ) -> adb_20211201_models.GetViewDDLResponse:
        """
        @summary Queries the statement that is used to create a view.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetViewDDLRequest
        @return: GetViewDDLResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_view_ddlwith_options(request, runtime)

    async def get_view_ddl_async(
        self,
        request: adb_20211201_models.GetViewDDLRequest,
    ) -> adb_20211201_models.GetViewDDLResponse:
        """
        @summary Queries the statement that is used to create a view.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetViewDDLRequest
        @return: GetViewDDLResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_view_ddlwith_options_async(request, runtime)

    def get_view_objects_with_options(
        self,
        request: adb_20211201_models.GetViewObjectsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetViewObjectsResponse:
        """
        @summary Queries the information about views.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetViewObjectsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetViewObjectsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.filter_owner):
            query['FilterOwner'] = request.filter_owner
        if not UtilClient.is_unset(request.filter_view_name):
            query['FilterViewName'] = request.filter_view_name
        if not UtilClient.is_unset(request.filter_view_type):
            query['FilterViewType'] = request.filter_view_type
        if not UtilClient.is_unset(request.order_by):
            query['OrderBy'] = request.order_by
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetViewObjects',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetViewObjectsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetViewObjectsResponse(),
                self.execute(params, req, runtime)
            )

    async def get_view_objects_with_options_async(
        self,
        request: adb_20211201_models.GetViewObjectsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GetViewObjectsResponse:
        """
        @summary Queries the information about views.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetViewObjectsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GetViewObjectsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.filter_owner):
            query['FilterOwner'] = request.filter_owner
        if not UtilClient.is_unset(request.filter_view_name):
            query['FilterViewName'] = request.filter_view_name
        if not UtilClient.is_unset(request.filter_view_type):
            query['FilterViewType'] = request.filter_view_type
        if not UtilClient.is_unset(request.order_by):
            query['OrderBy'] = request.order_by
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.schema_name):
            query['SchemaName'] = request.schema_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GetViewObjects',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GetViewObjectsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GetViewObjectsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def get_view_objects(
        self,
        request: adb_20211201_models.GetViewObjectsRequest,
    ) -> adb_20211201_models.GetViewObjectsResponse:
        """
        @summary Queries the information about views.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetViewObjectsRequest
        @return: GetViewObjectsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.get_view_objects_with_options(request, runtime)

    async def get_view_objects_async(
        self,
        request: adb_20211201_models.GetViewObjectsRequest,
    ) -> adb_20211201_models.GetViewObjectsResponse:
        """
        @summary Queries the information about views.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        
        @param request: GetViewObjectsRequest
        @return: GetViewObjectsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.get_view_objects_with_options_async(request, runtime)

    def grant_operator_permission_with_options(
        self,
        request: adb_20211201_models.GrantOperatorPermissionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GrantOperatorPermissionResponse:
        """
        @summary Grants permissions to the service account of an AnalyticDB for MySQL cluster.
        
        @param request: GrantOperatorPermissionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GrantOperatorPermissionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.expired_time):
            query['ExpiredTime'] = request.expired_time
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.privileges):
            query['Privileges'] = request.privileges
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GrantOperatorPermission',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GrantOperatorPermissionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GrantOperatorPermissionResponse(),
                self.execute(params, req, runtime)
            )

    async def grant_operator_permission_with_options_async(
        self,
        request: adb_20211201_models.GrantOperatorPermissionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.GrantOperatorPermissionResponse:
        """
        @summary Grants permissions to the service account of an AnalyticDB for MySQL cluster.
        
        @param request: GrantOperatorPermissionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: GrantOperatorPermissionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.expired_time):
            query['ExpiredTime'] = request.expired_time
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.privileges):
            query['Privileges'] = request.privileges
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='GrantOperatorPermission',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.GrantOperatorPermissionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.GrantOperatorPermissionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def grant_operator_permission(
        self,
        request: adb_20211201_models.GrantOperatorPermissionRequest,
    ) -> adb_20211201_models.GrantOperatorPermissionResponse:
        """
        @summary Grants permissions to the service account of an AnalyticDB for MySQL cluster.
        
        @param request: GrantOperatorPermissionRequest
        @return: GrantOperatorPermissionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.grant_operator_permission_with_options(request, runtime)

    async def grant_operator_permission_async(
        self,
        request: adb_20211201_models.GrantOperatorPermissionRequest,
    ) -> adb_20211201_models.GrantOperatorPermissionResponse:
        """
        @summary Grants permissions to the service account of an AnalyticDB for MySQL cluster.
        
        @param request: GrantOperatorPermissionRequest
        @return: GrantOperatorPermissionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.grant_operator_permission_with_options_async(request, runtime)

    def kill_process_with_options(
        self,
        request: adb_20211201_models.KillProcessRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.KillProcessResponse:
        """
        @summary Terminates an ongoing query.
        
        @param request: KillProcessRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: KillProcessResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='KillProcess',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.KillProcessResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.KillProcessResponse(),
                self.execute(params, req, runtime)
            )

    async def kill_process_with_options_async(
        self,
        request: adb_20211201_models.KillProcessRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.KillProcessResponse:
        """
        @summary Terminates an ongoing query.
        
        @param request: KillProcessRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: KillProcessResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='KillProcess',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.KillProcessResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.KillProcessResponse(),
                await self.execute_async(params, req, runtime)
            )

    def kill_process(
        self,
        request: adb_20211201_models.KillProcessRequest,
    ) -> adb_20211201_models.KillProcessResponse:
        """
        @summary Terminates an ongoing query.
        
        @param request: KillProcessRequest
        @return: KillProcessResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.kill_process_with_options(request, runtime)

    async def kill_process_async(
        self,
        request: adb_20211201_models.KillProcessRequest,
    ) -> adb_20211201_models.KillProcessResponse:
        """
        @summary Terminates an ongoing query.
        
        @param request: KillProcessRequest
        @return: KillProcessResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.kill_process_with_options_async(request, runtime)

    def kill_spark_app_with_options(
        self,
        request: adb_20211201_models.KillSparkAppRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.KillSparkAppResponse:
        """
        @summary Terminates a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkAppRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: KillSparkAppResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='KillSparkApp',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.KillSparkAppResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.KillSparkAppResponse(),
                self.execute(params, req, runtime)
            )

    async def kill_spark_app_with_options_async(
        self,
        request: adb_20211201_models.KillSparkAppRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.KillSparkAppResponse:
        """
        @summary Terminates a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkAppRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: KillSparkAppResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='KillSparkApp',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.KillSparkAppResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.KillSparkAppResponse(),
                await self.execute_async(params, req, runtime)
            )

    def kill_spark_app(
        self,
        request: adb_20211201_models.KillSparkAppRequest,
    ) -> adb_20211201_models.KillSparkAppResponse:
        """
        @summary Terminates a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkAppRequest
        @return: KillSparkAppResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.kill_spark_app_with_options(request, runtime)

    async def kill_spark_app_async(
        self,
        request: adb_20211201_models.KillSparkAppRequest,
    ) -> adb_20211201_models.KillSparkAppResponse:
        """
        @summary Terminates a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkAppRequest
        @return: KillSparkAppResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.kill_spark_app_with_options_async(request, runtime)

    def kill_spark_log_analyze_task_with_options(
        self,
        request: adb_20211201_models.KillSparkLogAnalyzeTaskRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.KillSparkLogAnalyzeTaskResponse:
        """
        @summary Terminates a Spark log analysis task and queries the information about the analysis task.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkLogAnalyzeTaskRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: KillSparkLogAnalyzeTaskResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.task_id):
            body['TaskId'] = request.task_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='KillSparkLogAnalyzeTask',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.KillSparkLogAnalyzeTaskResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.KillSparkLogAnalyzeTaskResponse(),
                self.execute(params, req, runtime)
            )

    async def kill_spark_log_analyze_task_with_options_async(
        self,
        request: adb_20211201_models.KillSparkLogAnalyzeTaskRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.KillSparkLogAnalyzeTaskResponse:
        """
        @summary Terminates a Spark log analysis task and queries the information about the analysis task.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkLogAnalyzeTaskRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: KillSparkLogAnalyzeTaskResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.task_id):
            body['TaskId'] = request.task_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='KillSparkLogAnalyzeTask',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.KillSparkLogAnalyzeTaskResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.KillSparkLogAnalyzeTaskResponse(),
                await self.execute_async(params, req, runtime)
            )

    def kill_spark_log_analyze_task(
        self,
        request: adb_20211201_models.KillSparkLogAnalyzeTaskRequest,
    ) -> adb_20211201_models.KillSparkLogAnalyzeTaskResponse:
        """
        @summary Terminates a Spark log analysis task and queries the information about the analysis task.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkLogAnalyzeTaskRequest
        @return: KillSparkLogAnalyzeTaskResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.kill_spark_log_analyze_task_with_options(request, runtime)

    async def kill_spark_log_analyze_task_async(
        self,
        request: adb_20211201_models.KillSparkLogAnalyzeTaskRequest,
    ) -> adb_20211201_models.KillSparkLogAnalyzeTaskResponse:
        """
        @summary Terminates a Spark log analysis task and queries the information about the analysis task.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkLogAnalyzeTaskRequest
        @return: KillSparkLogAnalyzeTaskResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.kill_spark_log_analyze_task_with_options_async(request, runtime)

    def kill_spark_sqlengine_with_options(
        self,
        request: adb_20211201_models.KillSparkSQLEngineRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.KillSparkSQLEngineResponse:
        """
        @summary Shuts down a Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkSQLEngineRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: KillSparkSQLEngineResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='KillSparkSQLEngine',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.KillSparkSQLEngineResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.KillSparkSQLEngineResponse(),
                self.execute(params, req, runtime)
            )

    async def kill_spark_sqlengine_with_options_async(
        self,
        request: adb_20211201_models.KillSparkSQLEngineRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.KillSparkSQLEngineResponse:
        """
        @summary Shuts down a Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkSQLEngineRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: KillSparkSQLEngineResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='KillSparkSQLEngine',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.KillSparkSQLEngineResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.KillSparkSQLEngineResponse(),
                await self.execute_async(params, req, runtime)
            )

    def kill_spark_sqlengine(
        self,
        request: adb_20211201_models.KillSparkSQLEngineRequest,
    ) -> adb_20211201_models.KillSparkSQLEngineResponse:
        """
        @summary Shuts down a Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkSQLEngineRequest
        @return: KillSparkSQLEngineResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.kill_spark_sqlengine_with_options(request, runtime)

    async def kill_spark_sqlengine_async(
        self,
        request: adb_20211201_models.KillSparkSQLEngineRequest,
    ) -> adb_20211201_models.KillSparkSQLEngineResponse:
        """
        @summary Shuts down a Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: KillSparkSQLEngineRequest
        @return: KillSparkSQLEngineResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.kill_spark_sqlengine_with_options_async(request, runtime)

    def list_aps_lifecycle_strategy_with_options(
        self,
        request: adb_20211201_models.ListApsLifecycleStrategyRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListApsLifecycleStrategyResponse:
        """
        @summary Queries a list of lifecycle management policies of an AnalyticDB for MySQL cluster.
        
        @param request: ListApsLifecycleStrategyRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListApsLifecycleStrategyResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            body['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            body['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListApsLifecycleStrategy',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListApsLifecycleStrategyResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListApsLifecycleStrategyResponse(),
                self.execute(params, req, runtime)
            )

    async def list_aps_lifecycle_strategy_with_options_async(
        self,
        request: adb_20211201_models.ListApsLifecycleStrategyRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListApsLifecycleStrategyResponse:
        """
        @summary Queries a list of lifecycle management policies of an AnalyticDB for MySQL cluster.
        
        @param request: ListApsLifecycleStrategyRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListApsLifecycleStrategyResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            body['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            body['StartTime'] = request.start_time
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListApsLifecycleStrategy',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListApsLifecycleStrategyResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListApsLifecycleStrategyResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_aps_lifecycle_strategy(
        self,
        request: adb_20211201_models.ListApsLifecycleStrategyRequest,
    ) -> adb_20211201_models.ListApsLifecycleStrategyResponse:
        """
        @summary Queries a list of lifecycle management policies of an AnalyticDB for MySQL cluster.
        
        @param request: ListApsLifecycleStrategyRequest
        @return: ListApsLifecycleStrategyResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_aps_lifecycle_strategy_with_options(request, runtime)

    async def list_aps_lifecycle_strategy_async(
        self,
        request: adb_20211201_models.ListApsLifecycleStrategyRequest,
    ) -> adb_20211201_models.ListApsLifecycleStrategyResponse:
        """
        @summary Queries a list of lifecycle management policies of an AnalyticDB for MySQL cluster.
        
        @param request: ListApsLifecycleStrategyRequest
        @return: ListApsLifecycleStrategyResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_aps_lifecycle_strategy_with_options_async(request, runtime)

    def list_aps_optimization_strategy_with_options(
        self,
        request: adb_20211201_models.ListApsOptimizationStrategyRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListApsOptimizationStrategyResponse:
        """
        @summary Queries a list of lake storage optimization policies for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ListApsOptimizationStrategyRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListApsOptimizationStrategyResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListApsOptimizationStrategy',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListApsOptimizationStrategyResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListApsOptimizationStrategyResponse(),
                self.execute(params, req, runtime)
            )

    async def list_aps_optimization_strategy_with_options_async(
        self,
        request: adb_20211201_models.ListApsOptimizationStrategyRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListApsOptimizationStrategyResponse:
        """
        @summary Queries a list of lake storage optimization policies for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ListApsOptimizationStrategyRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListApsOptimizationStrategyResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListApsOptimizationStrategy',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListApsOptimizationStrategyResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListApsOptimizationStrategyResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_aps_optimization_strategy(
        self,
        request: adb_20211201_models.ListApsOptimizationStrategyRequest,
    ) -> adb_20211201_models.ListApsOptimizationStrategyResponse:
        """
        @summary Queries a list of lake storage optimization policies for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ListApsOptimizationStrategyRequest
        @return: ListApsOptimizationStrategyResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_aps_optimization_strategy_with_options(request, runtime)

    async def list_aps_optimization_strategy_async(
        self,
        request: adb_20211201_models.ListApsOptimizationStrategyRequest,
    ) -> adb_20211201_models.ListApsOptimizationStrategyResponse:
        """
        @summary Queries a list of lake storage optimization policies for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ListApsOptimizationStrategyRequest
        @return: ListApsOptimizationStrategyResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_aps_optimization_strategy_with_options_async(request, runtime)

    def list_aps_optimization_tasks_with_options(
        self,
        request: adb_20211201_models.ListApsOptimizationTasksRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListApsOptimizationTasksResponse:
        """
        @summary Queries a list of optimization jobs executed based on a lifecycle management policy. The system runs optimization jobs on a regular basis based on lifecycle management policies.
        
        @param request: ListApsOptimizationTasksRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListApsOptimizationTasksResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            body['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            body['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.strategy_type):
            body['StrategyType'] = request.strategy_type
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListApsOptimizationTasks',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListApsOptimizationTasksResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListApsOptimizationTasksResponse(),
                self.execute(params, req, runtime)
            )

    async def list_aps_optimization_tasks_with_options_async(
        self,
        request: adb_20211201_models.ListApsOptimizationTasksRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListApsOptimizationTasksResponse:
        """
        @summary Queries a list of optimization jobs executed based on a lifecycle management policy. The system runs optimization jobs on a regular basis based on lifecycle management policies.
        
        @param request: ListApsOptimizationTasksRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListApsOptimizationTasksResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.end_time):
            body['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.start_time):
            body['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.strategy_type):
            body['StrategyType'] = request.strategy_type
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListApsOptimizationTasks',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListApsOptimizationTasksResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListApsOptimizationTasksResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_aps_optimization_tasks(
        self,
        request: adb_20211201_models.ListApsOptimizationTasksRequest,
    ) -> adb_20211201_models.ListApsOptimizationTasksResponse:
        """
        @summary Queries a list of optimization jobs executed based on a lifecycle management policy. The system runs optimization jobs on a regular basis based on lifecycle management policies.
        
        @param request: ListApsOptimizationTasksRequest
        @return: ListApsOptimizationTasksResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_aps_optimization_tasks_with_options(request, runtime)

    async def list_aps_optimization_tasks_async(
        self,
        request: adb_20211201_models.ListApsOptimizationTasksRequest,
    ) -> adb_20211201_models.ListApsOptimizationTasksResponse:
        """
        @summary Queries a list of optimization jobs executed based on a lifecycle management policy. The system runs optimization jobs on a regular basis based on lifecycle management policies.
        
        @param request: ListApsOptimizationTasksRequest
        @return: ListApsOptimizationTasksResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_aps_optimization_tasks_with_options_async(request, runtime)

    def list_lake_storages_with_options(
        self,
        request: adb_20211201_models.ListLakeStoragesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListLakeStoragesResponse:
        """
        @summary Queries a list of lake storages.
        
        @param request: ListLakeStoragesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListLakeStoragesResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ListLakeStorages',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListLakeStoragesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListLakeStoragesResponse(),
                self.execute(params, req, runtime)
            )

    async def list_lake_storages_with_options_async(
        self,
        request: adb_20211201_models.ListLakeStoragesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListLakeStoragesResponse:
        """
        @summary Queries a list of lake storages.
        
        @param request: ListLakeStoragesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListLakeStoragesResponse
        """
        UtilClient.validate_model(request)
        query = OpenApiUtilClient.query(UtilClient.to_map(request))
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ListLakeStorages',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='GET',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListLakeStoragesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListLakeStoragesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_lake_storages(
        self,
        request: adb_20211201_models.ListLakeStoragesRequest,
    ) -> adb_20211201_models.ListLakeStoragesResponse:
        """
        @summary Queries a list of lake storages.
        
        @param request: ListLakeStoragesRequest
        @return: ListLakeStoragesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_lake_storages_with_options(request, runtime)

    async def list_lake_storages_async(
        self,
        request: adb_20211201_models.ListLakeStoragesRequest,
    ) -> adb_20211201_models.ListLakeStoragesResponse:
        """
        @summary Queries a list of lake storages.
        
        @param request: ListLakeStoragesRequest
        @return: ListLakeStoragesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_lake_storages_with_options_async(request, runtime)

    def list_result_export_job_history_with_options(
        self,
        tmp_req: adb_20211201_models.ListResultExportJobHistoryRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListResultExportJobHistoryResponse:
        """
        @summary Queries the execution records of result set export jobs of a Resource Access Management (RAM) user.
        
        @param tmp_req: ListResultExportJobHistoryRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListResultExportJobHistoryResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ListResultExportJobHistoryShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.order):
            request.order_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.order, 'Order', 'json')
        if not UtilClient.is_unset(tmp_req.status_list):
            request.status_list_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.status_list, 'StatusList', 'json')
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.database_user):
            body['DatabaseUser'] = request.database_user
        if not UtilClient.is_unset(request.end_time):
            body['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.order_shrink):
            body['Order'] = request.order_shrink
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            body['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.start_time):
            body['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.status_list_shrink):
            body['StatusList'] = request.status_list_shrink
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListResultExportJobHistory',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListResultExportJobHistoryResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListResultExportJobHistoryResponse(),
                self.execute(params, req, runtime)
            )

    async def list_result_export_job_history_with_options_async(
        self,
        tmp_req: adb_20211201_models.ListResultExportJobHistoryRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListResultExportJobHistoryResponse:
        """
        @summary Queries the execution records of result set export jobs of a Resource Access Management (RAM) user.
        
        @param tmp_req: ListResultExportJobHistoryRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListResultExportJobHistoryResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ListResultExportJobHistoryShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.order):
            request.order_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.order, 'Order', 'json')
        if not UtilClient.is_unset(tmp_req.status_list):
            request.status_list_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.status_list, 'StatusList', 'json')
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.database_user):
            body['DatabaseUser'] = request.database_user
        if not UtilClient.is_unset(request.end_time):
            body['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.order_shrink):
            body['Order'] = request.order_shrink
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            body['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.start_time):
            body['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.status_list_shrink):
            body['StatusList'] = request.status_list_shrink
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListResultExportJobHistory',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListResultExportJobHistoryResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListResultExportJobHistoryResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_result_export_job_history(
        self,
        request: adb_20211201_models.ListResultExportJobHistoryRequest,
    ) -> adb_20211201_models.ListResultExportJobHistoryResponse:
        """
        @summary Queries the execution records of result set export jobs of a Resource Access Management (RAM) user.
        
        @param request: ListResultExportJobHistoryRequest
        @return: ListResultExportJobHistoryResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_result_export_job_history_with_options(request, runtime)

    async def list_result_export_job_history_async(
        self,
        request: adb_20211201_models.ListResultExportJobHistoryRequest,
    ) -> adb_20211201_models.ListResultExportJobHistoryResponse:
        """
        @summary Queries the execution records of result set export jobs of a Resource Access Management (RAM) user.
        
        @param request: ListResultExportJobHistoryRequest
        @return: ListResultExportJobHistoryResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_result_export_job_history_with_options_async(request, runtime)

    def list_spark_app_attempts_with_options(
        self,
        request: adb_20211201_models.ListSparkAppAttemptsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListSparkAppAttemptsResponse:
        """
        @summary Queries the information about retry attempts of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkAppAttemptsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListSparkAppAttemptsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.app_id):
            query['AppId'] = request.app_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ListSparkAppAttempts',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListSparkAppAttemptsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListSparkAppAttemptsResponse(),
                self.execute(params, req, runtime)
            )

    async def list_spark_app_attempts_with_options_async(
        self,
        request: adb_20211201_models.ListSparkAppAttemptsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListSparkAppAttemptsResponse:
        """
        @summary Queries the information about retry attempts of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkAppAttemptsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListSparkAppAttemptsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.app_id):
            query['AppId'] = request.app_id
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ListSparkAppAttempts',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListSparkAppAttemptsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListSparkAppAttemptsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_spark_app_attempts(
        self,
        request: adb_20211201_models.ListSparkAppAttemptsRequest,
    ) -> adb_20211201_models.ListSparkAppAttemptsResponse:
        """
        @summary Queries the information about retry attempts of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkAppAttemptsRequest
        @return: ListSparkAppAttemptsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_spark_app_attempts_with_options(request, runtime)

    async def list_spark_app_attempts_async(
        self,
        request: adb_20211201_models.ListSparkAppAttemptsRequest,
    ) -> adb_20211201_models.ListSparkAppAttemptsResponse:
        """
        @summary Queries the information about retry attempts of a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkAppAttemptsRequest
        @return: ListSparkAppAttemptsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_spark_app_attempts_with_options_async(request, runtime)

    def list_spark_apps_with_options(
        self,
        request: adb_20211201_models.ListSparkAppsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListSparkAppsResponse:
        """
        @summary Queries the Spark applications that run on an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @param request: ListSparkAppsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListSparkAppsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.filters):
            query['Filters'] = request.filters
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ListSparkApps',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListSparkAppsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListSparkAppsResponse(),
                self.execute(params, req, runtime)
            )

    async def list_spark_apps_with_options_async(
        self,
        request: adb_20211201_models.ListSparkAppsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListSparkAppsResponse:
        """
        @summary Queries the Spark applications that run on an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @param request: ListSparkAppsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListSparkAppsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.filters):
            query['Filters'] = request.filters
        if not UtilClient.is_unset(request.page_number):
            query['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            query['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.resource_group_name):
            query['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ListSparkApps',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListSparkAppsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListSparkAppsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_spark_apps(
        self,
        request: adb_20211201_models.ListSparkAppsRequest,
    ) -> adb_20211201_models.ListSparkAppsResponse:
        """
        @summary Queries the Spark applications that run on an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @param request: ListSparkAppsRequest
        @return: ListSparkAppsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_spark_apps_with_options(request, runtime)

    async def list_spark_apps_async(
        self,
        request: adb_20211201_models.ListSparkAppsRequest,
    ) -> adb_20211201_models.ListSparkAppsResponse:
        """
        @summary Queries the Spark applications that run on an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @param request: ListSparkAppsRequest
        @return: ListSparkAppsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_spark_apps_with_options_async(request, runtime)

    def list_spark_log_analyze_tasks_with_options(
        self,
        request: adb_20211201_models.ListSparkLogAnalyzeTasksRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListSparkLogAnalyzeTasksResponse:
        """
        @summary Queries a list of Spark log analysis tasks.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkLogAnalyzeTasksRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListSparkLogAnalyzeTasksResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListSparkLogAnalyzeTasks',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListSparkLogAnalyzeTasksResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListSparkLogAnalyzeTasksResponse(),
                self.execute(params, req, runtime)
            )

    async def list_spark_log_analyze_tasks_with_options_async(
        self,
        request: adb_20211201_models.ListSparkLogAnalyzeTasksRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListSparkLogAnalyzeTasksResponse:
        """
        @summary Queries a list of Spark log analysis tasks.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkLogAnalyzeTasksRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListSparkLogAnalyzeTasksResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListSparkLogAnalyzeTasks',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListSparkLogAnalyzeTasksResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListSparkLogAnalyzeTasksResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_spark_log_analyze_tasks(
        self,
        request: adb_20211201_models.ListSparkLogAnalyzeTasksRequest,
    ) -> adb_20211201_models.ListSparkLogAnalyzeTasksResponse:
        """
        @summary Queries a list of Spark log analysis tasks.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkLogAnalyzeTasksRequest
        @return: ListSparkLogAnalyzeTasksResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_spark_log_analyze_tasks_with_options(request, runtime)

    async def list_spark_log_analyze_tasks_async(
        self,
        request: adb_20211201_models.ListSparkLogAnalyzeTasksRequest,
    ) -> adb_20211201_models.ListSparkLogAnalyzeTasksResponse:
        """
        @summary Queries a list of Spark log analysis tasks.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkLogAnalyzeTasksRequest
        @return: ListSparkLogAnalyzeTasksResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_spark_log_analyze_tasks_with_options_async(request, runtime)

    def list_spark_template_file_ids_with_options(
        self,
        request: adb_20211201_models.ListSparkTemplateFileIdsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListSparkTemplateFileIdsResponse:
        """
        @summary Queries a list of Spark template file IDs for AnalyticDB for MySQL clusters.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkTemplateFileIdsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListSparkTemplateFileIdsResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListSparkTemplateFileIds',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListSparkTemplateFileIdsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListSparkTemplateFileIdsResponse(),
                self.execute(params, req, runtime)
            )

    async def list_spark_template_file_ids_with_options_async(
        self,
        request: adb_20211201_models.ListSparkTemplateFileIdsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListSparkTemplateFileIdsResponse:
        """
        @summary Queries a list of Spark template file IDs for AnalyticDB for MySQL clusters.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkTemplateFileIdsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListSparkTemplateFileIdsResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListSparkTemplateFileIds',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListSparkTemplateFileIdsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListSparkTemplateFileIdsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_spark_template_file_ids(
        self,
        request: adb_20211201_models.ListSparkTemplateFileIdsRequest,
    ) -> adb_20211201_models.ListSparkTemplateFileIdsResponse:
        """
        @summary Queries a list of Spark template file IDs for AnalyticDB for MySQL clusters.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkTemplateFileIdsRequest
        @return: ListSparkTemplateFileIdsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_spark_template_file_ids_with_options(request, runtime)

    async def list_spark_template_file_ids_async(
        self,
        request: adb_20211201_models.ListSparkTemplateFileIdsRequest,
    ) -> adb_20211201_models.ListSparkTemplateFileIdsResponse:
        """
        @summary Queries a list of Spark template file IDs for AnalyticDB for MySQL clusters.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: ListSparkTemplateFileIdsRequest
        @return: ListSparkTemplateFileIdsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_spark_template_file_ids_with_options_async(request, runtime)

    def list_spark_warehouse_batch_sqlwith_options(
        self,
        request: adb_20211201_models.ListSparkWarehouseBatchSQLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListSparkWarehouseBatchSQLResponse:
        """
        @summary 列出提交的的SparkBatchSQL
        
        @param request: ListSparkWarehouseBatchSQLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListSparkWarehouseBatchSQLResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListSparkWarehouseBatchSQL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListSparkWarehouseBatchSQLResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListSparkWarehouseBatchSQLResponse(),
                self.execute(params, req, runtime)
            )

    async def list_spark_warehouse_batch_sqlwith_options_async(
        self,
        request: adb_20211201_models.ListSparkWarehouseBatchSQLRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListSparkWarehouseBatchSQLResponse:
        """
        @summary 列出提交的的SparkBatchSQL
        
        @param request: ListSparkWarehouseBatchSQLRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListSparkWarehouseBatchSQLResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.page_number):
            body['PageNumber'] = request.page_number
        if not UtilClient.is_unset(request.page_size):
            body['PageSize'] = request.page_size
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ListSparkWarehouseBatchSQL',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListSparkWarehouseBatchSQLResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListSparkWarehouseBatchSQLResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_spark_warehouse_batch_sql(
        self,
        request: adb_20211201_models.ListSparkWarehouseBatchSQLRequest,
    ) -> adb_20211201_models.ListSparkWarehouseBatchSQLResponse:
        """
        @summary 列出提交的的SparkBatchSQL
        
        @param request: ListSparkWarehouseBatchSQLRequest
        @return: ListSparkWarehouseBatchSQLResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_spark_warehouse_batch_sqlwith_options(request, runtime)

    async def list_spark_warehouse_batch_sql_async(
        self,
        request: adb_20211201_models.ListSparkWarehouseBatchSQLRequest,
    ) -> adb_20211201_models.ListSparkWarehouseBatchSQLResponse:
        """
        @summary 列出提交的的SparkBatchSQL
        
        @param request: ListSparkWarehouseBatchSQLRequest
        @return: ListSparkWarehouseBatchSQLResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_spark_warehouse_batch_sqlwith_options_async(request, runtime)

    def list_tag_resources_with_options(
        self,
        request: adb_20211201_models.ListTagResourcesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListTagResourcesResponse:
        """
        @summary Queries the tags that are added to AnalyticDB for MySQL clusters, or the AnalyticDB for MySQL clusters that have tags added.
        
        @param request: ListTagResourcesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListTagResourcesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.next_token):
            query['NextToken'] = request.next_token
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_id):
            query['ResourceId'] = request.resource_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.resource_type):
            query['ResourceType'] = request.resource_type
        if not UtilClient.is_unset(request.tag):
            query['Tag'] = request.tag
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ListTagResources',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListTagResourcesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListTagResourcesResponse(),
                self.execute(params, req, runtime)
            )

    async def list_tag_resources_with_options_async(
        self,
        request: adb_20211201_models.ListTagResourcesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ListTagResourcesResponse:
        """
        @summary Queries the tags that are added to AnalyticDB for MySQL clusters, or the AnalyticDB for MySQL clusters that have tags added.
        
        @param request: ListTagResourcesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ListTagResourcesResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.next_token):
            query['NextToken'] = request.next_token
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_id):
            query['ResourceId'] = request.resource_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.resource_type):
            query['ResourceType'] = request.resource_type
        if not UtilClient.is_unset(request.tag):
            query['Tag'] = request.tag
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ListTagResources',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ListTagResourcesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ListTagResourcesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def list_tag_resources(
        self,
        request: adb_20211201_models.ListTagResourcesRequest,
    ) -> adb_20211201_models.ListTagResourcesResponse:
        """
        @summary Queries the tags that are added to AnalyticDB for MySQL clusters, or the AnalyticDB for MySQL clusters that have tags added.
        
        @param request: ListTagResourcesRequest
        @return: ListTagResourcesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.list_tag_resources_with_options(request, runtime)

    async def list_tag_resources_async(
        self,
        request: adb_20211201_models.ListTagResourcesRequest,
    ) -> adb_20211201_models.ListTagResourcesResponse:
        """
        @summary Queries the tags that are added to AnalyticDB for MySQL clusters, or the AnalyticDB for MySQL clusters that have tags added.
        
        @param request: ListTagResourcesRequest
        @return: ListTagResourcesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.list_tag_resources_with_options_async(request, runtime)

    def load_sample_data_set_with_options(
        self,
        request: adb_20211201_models.LoadSampleDataSetRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.LoadSampleDataSetResponse:
        """
        @summary Loads a built-in dataset.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: LoadSampleDataSetRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: LoadSampleDataSetResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='LoadSampleDataSet',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.LoadSampleDataSetResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.LoadSampleDataSetResponse(),
                self.execute(params, req, runtime)
            )

    async def load_sample_data_set_with_options_async(
        self,
        request: adb_20211201_models.LoadSampleDataSetRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.LoadSampleDataSetResponse:
        """
        @summary Loads a built-in dataset.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: LoadSampleDataSetRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: LoadSampleDataSetResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='LoadSampleDataSet',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.LoadSampleDataSetResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.LoadSampleDataSetResponse(),
                await self.execute_async(params, req, runtime)
            )

    def load_sample_data_set(
        self,
        request: adb_20211201_models.LoadSampleDataSetRequest,
    ) -> adb_20211201_models.LoadSampleDataSetResponse:
        """
        @summary Loads a built-in dataset.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: LoadSampleDataSetRequest
        @return: LoadSampleDataSetResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.load_sample_data_set_with_options(request, runtime)

    async def load_sample_data_set_async(
        self,
        request: adb_20211201_models.LoadSampleDataSetRequest,
    ) -> adb_20211201_models.LoadSampleDataSetResponse:
        """
        @summary Loads a built-in dataset.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: LoadSampleDataSetRequest
        @return: LoadSampleDataSetResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.load_sample_data_set_with_options_async(request, runtime)

    def modify_account_description_with_options(
        self,
        request: adb_20211201_models.ModifyAccountDescriptionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyAccountDescriptionResponse:
        """
        @summary Modifies the description of a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyAccountDescriptionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyAccountDescriptionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_description):
            query['AccountDescription'] = request.account_description
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyAccountDescription',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyAccountDescriptionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyAccountDescriptionResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_account_description_with_options_async(
        self,
        request: adb_20211201_models.ModifyAccountDescriptionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyAccountDescriptionResponse:
        """
        @summary Modifies the description of a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyAccountDescriptionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyAccountDescriptionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_description):
            query['AccountDescription'] = request.account_description
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyAccountDescription',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyAccountDescriptionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyAccountDescriptionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_account_description(
        self,
        request: adb_20211201_models.ModifyAccountDescriptionRequest,
    ) -> adb_20211201_models.ModifyAccountDescriptionResponse:
        """
        @summary Modifies the description of a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyAccountDescriptionRequest
        @return: ModifyAccountDescriptionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_account_description_with_options(request, runtime)

    async def modify_account_description_async(
        self,
        request: adb_20211201_models.ModifyAccountDescriptionRequest,
    ) -> adb_20211201_models.ModifyAccountDescriptionResponse:
        """
        @summary Modifies the description of a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyAccountDescriptionRequest
        @return: ModifyAccountDescriptionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_account_description_with_options_async(request, runtime)

    def modify_account_privileges_with_options(
        self,
        tmp_req: adb_20211201_models.ModifyAccountPrivilegesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyAccountPrivilegesResponse:
        """
        @summary Modifies the permissions of a database account.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param tmp_req: ModifyAccountPrivilegesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyAccountPrivilegesResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ModifyAccountPrivilegesShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.account_privileges):
            request.account_privileges_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.account_privileges, 'AccountPrivileges', 'json')
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.account_privileges_shrink):
            query['AccountPrivileges'] = request.account_privileges_shrink
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyAccountPrivileges',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyAccountPrivilegesResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyAccountPrivilegesResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_account_privileges_with_options_async(
        self,
        tmp_req: adb_20211201_models.ModifyAccountPrivilegesRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyAccountPrivilegesResponse:
        """
        @summary Modifies the permissions of a database account.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param tmp_req: ModifyAccountPrivilegesRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyAccountPrivilegesResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ModifyAccountPrivilegesShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.account_privileges):
            request.account_privileges_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.account_privileges, 'AccountPrivileges', 'json')
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.account_privileges_shrink):
            query['AccountPrivileges'] = request.account_privileges_shrink
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyAccountPrivileges',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyAccountPrivilegesResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyAccountPrivilegesResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_account_privileges(
        self,
        request: adb_20211201_models.ModifyAccountPrivilegesRequest,
    ) -> adb_20211201_models.ModifyAccountPrivilegesResponse:
        """
        @summary Modifies the permissions of a database account.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyAccountPrivilegesRequest
        @return: ModifyAccountPrivilegesResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_account_privileges_with_options(request, runtime)

    async def modify_account_privileges_async(
        self,
        request: adb_20211201_models.ModifyAccountPrivilegesRequest,
    ) -> adb_20211201_models.ModifyAccountPrivilegesResponse:
        """
        @summary Modifies the permissions of a database account.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyAccountPrivilegesRequest
        @return: ModifyAccountPrivilegesResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_account_privileges_with_options_async(request, runtime)

    def modify_aps_datasoure_with_options(
        self,
        tmp_req: adb_20211201_models.ModifyApsDatasoureRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyApsDatasoureResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) data source.
        
        @description ### [](#)
        You can call this operation only for AnalyticDB for MySQL clusters in elastic mode for Cluster Edition that have 32 cores or more.
        You cannot modify the number of nodes for the USER_DEFAULT resource group.
        
        @param tmp_req: ModifyApsDatasoureRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyApsDatasoureResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ModifyApsDatasoureShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.kafka_info):
            request.kafka_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.kafka_info, 'KafkaInfo', 'json')
        if not UtilClient.is_unset(tmp_req.lakehouse_id):
            request.lakehouse_id_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.lakehouse_id, 'LakehouseId', 'json')
        if not UtilClient.is_unset(tmp_req.polar_dbmysql_info):
            request.polar_dbmysql_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.polar_dbmysql_info, 'PolarDBMysqlInfo', 'json')
        if not UtilClient.is_unset(tmp_req.rds_mysql_info):
            request.rds_mysql_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.rds_mysql_info, 'RdsMysqlInfo', 'json')
        if not UtilClient.is_unset(tmp_req.sls_info):
            request.sls_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.sls_info, 'SlsInfo', 'json')
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_description):
            body['DatasourceDescription'] = request.datasource_description
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.datasource_name):
            body['DatasourceName'] = request.datasource_name
        if not UtilClient.is_unset(request.kafka_info_shrink):
            body['KafkaInfo'] = request.kafka_info_shrink
        if not UtilClient.is_unset(request.lakehouse_id_shrink):
            body['LakehouseId'] = request.lakehouse_id_shrink
        if not UtilClient.is_unset(request.polar_dbmysql_info_shrink):
            body['PolarDBMysqlInfo'] = request.polar_dbmysql_info_shrink
        if not UtilClient.is_unset(request.rds_mysql_info_shrink):
            body['RdsMysqlInfo'] = request.rds_mysql_info_shrink
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.sls_info_shrink):
            body['SlsInfo'] = request.sls_info_shrink
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ModifyApsDatasoure',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsDatasoureResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsDatasoureResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_aps_datasoure_with_options_async(
        self,
        tmp_req: adb_20211201_models.ModifyApsDatasoureRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyApsDatasoureResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) data source.
        
        @description ### [](#)
        You can call this operation only for AnalyticDB for MySQL clusters in elastic mode for Cluster Edition that have 32 cores or more.
        You cannot modify the number of nodes for the USER_DEFAULT resource group.
        
        @param tmp_req: ModifyApsDatasoureRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyApsDatasoureResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ModifyApsDatasoureShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.kafka_info):
            request.kafka_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.kafka_info, 'KafkaInfo', 'json')
        if not UtilClient.is_unset(tmp_req.lakehouse_id):
            request.lakehouse_id_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.lakehouse_id, 'LakehouseId', 'json')
        if not UtilClient.is_unset(tmp_req.polar_dbmysql_info):
            request.polar_dbmysql_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.polar_dbmysql_info, 'PolarDBMysqlInfo', 'json')
        if not UtilClient.is_unset(tmp_req.rds_mysql_info):
            request.rds_mysql_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.rds_mysql_info, 'RdsMysqlInfo', 'json')
        if not UtilClient.is_unset(tmp_req.sls_info):
            request.sls_info_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.sls_info, 'SlsInfo', 'json')
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.datasource_description):
            body['DatasourceDescription'] = request.datasource_description
        if not UtilClient.is_unset(request.datasource_id):
            body['DatasourceId'] = request.datasource_id
        if not UtilClient.is_unset(request.datasource_name):
            body['DatasourceName'] = request.datasource_name
        if not UtilClient.is_unset(request.kafka_info_shrink):
            body['KafkaInfo'] = request.kafka_info_shrink
        if not UtilClient.is_unset(request.lakehouse_id_shrink):
            body['LakehouseId'] = request.lakehouse_id_shrink
        if not UtilClient.is_unset(request.polar_dbmysql_info_shrink):
            body['PolarDBMysqlInfo'] = request.polar_dbmysql_info_shrink
        if not UtilClient.is_unset(request.rds_mysql_info_shrink):
            body['RdsMysqlInfo'] = request.rds_mysql_info_shrink
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.sls_info_shrink):
            body['SlsInfo'] = request.sls_info_shrink
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ModifyApsDatasoure',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsDatasoureResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsDatasoureResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_aps_datasoure(
        self,
        request: adb_20211201_models.ModifyApsDatasoureRequest,
    ) -> adb_20211201_models.ModifyApsDatasoureResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) data source.
        
        @description ### [](#)
        You can call this operation only for AnalyticDB for MySQL clusters in elastic mode for Cluster Edition that have 32 cores or more.
        You cannot modify the number of nodes for the USER_DEFAULT resource group.
        
        @param request: ModifyApsDatasoureRequest
        @return: ModifyApsDatasoureResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_aps_datasoure_with_options(request, runtime)

    async def modify_aps_datasoure_async(
        self,
        request: adb_20211201_models.ModifyApsDatasoureRequest,
    ) -> adb_20211201_models.ModifyApsDatasoureResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) data source.
        
        @description ### [](#)
        You can call this operation only for AnalyticDB for MySQL clusters in elastic mode for Cluster Edition that have 32 cores or more.
        You cannot modify the number of nodes for the USER_DEFAULT resource group.
        
        @param request: ModifyApsDatasoureRequest
        @return: ModifyApsDatasoureResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_aps_datasoure_with_options_async(request, runtime)

    def modify_aps_job_with_options(
        self,
        request: adb_20211201_models.ModifyApsJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyApsJobResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) job.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyApsJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyApsJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_id):
            body['ApsJobId'] = request.aps_job_id
        if not UtilClient.is_unset(request.db_list):
            body['DbList'] = request.db_list
        if not UtilClient.is_unset(request.partition_list):
            body['PartitionList'] = request.partition_list
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ModifyApsJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsJobResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsJobResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_aps_job_with_options_async(
        self,
        request: adb_20211201_models.ModifyApsJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyApsJobResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) job.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyApsJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyApsJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_id):
            body['ApsJobId'] = request.aps_job_id
        if not UtilClient.is_unset(request.db_list):
            body['DbList'] = request.db_list
        if not UtilClient.is_unset(request.partition_list):
            body['PartitionList'] = request.partition_list
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ModifyApsJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsJobResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsJobResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_aps_job(
        self,
        request: adb_20211201_models.ModifyApsJobRequest,
    ) -> adb_20211201_models.ModifyApsJobResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) job.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyApsJobRequest
        @return: ModifyApsJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_aps_job_with_options(request, runtime)

    async def modify_aps_job_async(
        self,
        request: adb_20211201_models.ModifyApsJobRequest,
    ) -> adb_20211201_models.ModifyApsJobResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) job.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyApsJobRequest
        @return: ModifyApsJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_aps_job_with_options_async(request, runtime)

    def modify_aps_sls_adbjob_with_options(
        self,
        tmp_req: adb_20211201_models.ModifyApsSlsADBJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyApsSlsADBJobResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) job from Simple Log Service (SLS) to an AnalyticDB for MySQL Data Warehouse Edition cluster.
        
        @param tmp_req: ModifyApsSlsADBJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyApsSlsADBJobResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ModifyApsSlsADBJobShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.columns):
            request.columns_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.columns, 'Columns', 'json')
        body = {}
        if not UtilClient.is_unset(request.columns_shrink):
            body['Columns'] = request.columns_shrink
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.db_name):
            body['DbName'] = request.db_name
        if not UtilClient.is_unset(request.dirty_data_process_pattern):
            body['DirtyDataProcessPattern'] = request.dirty_data_process_pattern
        if not UtilClient.is_unset(request.exactly_once):
            body['ExactlyOnce'] = request.exactly_once
        if not UtilClient.is_unset(request.password):
            body['Password'] = request.password
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.starting_offsets):
            body['StartingOffsets'] = request.starting_offsets
        if not UtilClient.is_unset(request.table_name):
            body['TableName'] = request.table_name
        if not UtilClient.is_unset(request.unix_timestamp_convert):
            body['UnixTimestampConvert'] = request.unix_timestamp_convert
        if not UtilClient.is_unset(request.user_name):
            body['UserName'] = request.user_name
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        if not UtilClient.is_unset(request.workload_name):
            body['WorkloadName'] = request.workload_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ModifyApsSlsADBJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsSlsADBJobResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsSlsADBJobResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_aps_sls_adbjob_with_options_async(
        self,
        tmp_req: adb_20211201_models.ModifyApsSlsADBJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyApsSlsADBJobResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) job from Simple Log Service (SLS) to an AnalyticDB for MySQL Data Warehouse Edition cluster.
        
        @param tmp_req: ModifyApsSlsADBJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyApsSlsADBJobResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ModifyApsSlsADBJobShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.columns):
            request.columns_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.columns, 'Columns', 'json')
        body = {}
        if not UtilClient.is_unset(request.columns_shrink):
            body['Columns'] = request.columns_shrink
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.db_name):
            body['DbName'] = request.db_name
        if not UtilClient.is_unset(request.dirty_data_process_pattern):
            body['DirtyDataProcessPattern'] = request.dirty_data_process_pattern
        if not UtilClient.is_unset(request.exactly_once):
            body['ExactlyOnce'] = request.exactly_once
        if not UtilClient.is_unset(request.password):
            body['Password'] = request.password
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.starting_offsets):
            body['StartingOffsets'] = request.starting_offsets
        if not UtilClient.is_unset(request.table_name):
            body['TableName'] = request.table_name
        if not UtilClient.is_unset(request.unix_timestamp_convert):
            body['UnixTimestampConvert'] = request.unix_timestamp_convert
        if not UtilClient.is_unset(request.user_name):
            body['UserName'] = request.user_name
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        if not UtilClient.is_unset(request.workload_name):
            body['WorkloadName'] = request.workload_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ModifyApsSlsADBJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsSlsADBJobResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsSlsADBJobResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_aps_sls_adbjob(
        self,
        request: adb_20211201_models.ModifyApsSlsADBJobRequest,
    ) -> adb_20211201_models.ModifyApsSlsADBJobResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) job from Simple Log Service (SLS) to an AnalyticDB for MySQL Data Warehouse Edition cluster.
        
        @param request: ModifyApsSlsADBJobRequest
        @return: ModifyApsSlsADBJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_aps_sls_adbjob_with_options(request, runtime)

    async def modify_aps_sls_adbjob_async(
        self,
        request: adb_20211201_models.ModifyApsSlsADBJobRequest,
    ) -> adb_20211201_models.ModifyApsSlsADBJobResponse:
        """
        @summary Modifies an AnalyticDB Pipeline Service (APS) job from Simple Log Service (SLS) to an AnalyticDB for MySQL Data Warehouse Edition cluster.
        
        @param request: ModifyApsSlsADBJobRequest
        @return: ModifyApsSlsADBJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_aps_sls_adbjob_with_options_async(request, runtime)

    def modify_aps_workload_name_with_options(
        self,
        request: adb_20211201_models.ModifyApsWorkloadNameRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyApsWorkloadNameResponse:
        """
        @summary Modifies the AnalyticDB Pipeline Service (APS) workload name.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyApsWorkloadNameRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyApsWorkloadNameResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        if not UtilClient.is_unset(request.workload_name):
            body['WorkloadName'] = request.workload_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ModifyApsWorkloadName',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsWorkloadNameResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsWorkloadNameResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_aps_workload_name_with_options_async(
        self,
        request: adb_20211201_models.ModifyApsWorkloadNameRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyApsWorkloadNameResponse:
        """
        @summary Modifies the AnalyticDB Pipeline Service (APS) workload name.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyApsWorkloadNameRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyApsWorkloadNameResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.workload_id):
            body['WorkloadId'] = request.workload_id
        if not UtilClient.is_unset(request.workload_name):
            body['WorkloadName'] = request.workload_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ModifyApsWorkloadName',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsWorkloadNameResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyApsWorkloadNameResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_aps_workload_name(
        self,
        request: adb_20211201_models.ModifyApsWorkloadNameRequest,
    ) -> adb_20211201_models.ModifyApsWorkloadNameResponse:
        """
        @summary Modifies the AnalyticDB Pipeline Service (APS) workload name.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyApsWorkloadNameRequest
        @return: ModifyApsWorkloadNameResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_aps_workload_name_with_options(request, runtime)

    async def modify_aps_workload_name_async(
        self,
        request: adb_20211201_models.ModifyApsWorkloadNameRequest,
    ) -> adb_20211201_models.ModifyApsWorkloadNameResponse:
        """
        @summary Modifies the AnalyticDB Pipeline Service (APS) workload name.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyApsWorkloadNameRequest
        @return: ModifyApsWorkloadNameResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_aps_workload_name_with_options_async(request, runtime)

    def modify_audit_log_config_with_options(
        self,
        request: adb_20211201_models.ModifyAuditLogConfigRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyAuditLogConfigResponse:
        """
        @summary Modifies the SQL audit settings of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyAuditLogConfigRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyAuditLogConfigResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.audit_log_status):
            query['AuditLogStatus'] = request.audit_log_status
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine_type):
            query['EngineType'] = request.engine_type
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyAuditLogConfig',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyAuditLogConfigResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyAuditLogConfigResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_audit_log_config_with_options_async(
        self,
        request: adb_20211201_models.ModifyAuditLogConfigRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyAuditLogConfigResponse:
        """
        @summary Modifies the SQL audit settings of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyAuditLogConfigRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyAuditLogConfigResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.audit_log_status):
            query['AuditLogStatus'] = request.audit_log_status
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine_type):
            query['EngineType'] = request.engine_type
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyAuditLogConfig',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyAuditLogConfigResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyAuditLogConfigResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_audit_log_config(
        self,
        request: adb_20211201_models.ModifyAuditLogConfigRequest,
    ) -> adb_20211201_models.ModifyAuditLogConfigResponse:
        """
        @summary Modifies the SQL audit settings of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyAuditLogConfigRequest
        @return: ModifyAuditLogConfigResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_audit_log_config_with_options(request, runtime)

    async def modify_audit_log_config_async(
        self,
        request: adb_20211201_models.ModifyAuditLogConfigRequest,
    ) -> adb_20211201_models.ModifyAuditLogConfigResponse:
        """
        @summary Modifies the SQL audit settings of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyAuditLogConfigRequest
        @return: ModifyAuditLogConfigResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_audit_log_config_with_options_async(request, runtime)

    def modify_backup_policy_with_options(
        self,
        request: adb_20211201_models.ModifyBackupPolicyRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyBackupPolicyResponse:
        """
        @summary Modifies the backup policy of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyBackupPolicyRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyBackupPolicyResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.backup_retention_period):
            query['BackupRetentionPeriod'] = request.backup_retention_period
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_backup_log):
            query['EnableBackupLog'] = request.enable_backup_log
        if not UtilClient.is_unset(request.log_backup_retention_period):
            query['LogBackupRetentionPeriod'] = request.log_backup_retention_period
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.preferred_backup_period):
            query['PreferredBackupPeriod'] = request.preferred_backup_period
        if not UtilClient.is_unset(request.preferred_backup_time):
            query['PreferredBackupTime'] = request.preferred_backup_time
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyBackupPolicy',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyBackupPolicyResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyBackupPolicyResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_backup_policy_with_options_async(
        self,
        request: adb_20211201_models.ModifyBackupPolicyRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyBackupPolicyResponse:
        """
        @summary Modifies the backup policy of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyBackupPolicyRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyBackupPolicyResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.backup_retention_period):
            query['BackupRetentionPeriod'] = request.backup_retention_period
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_backup_log):
            query['EnableBackupLog'] = request.enable_backup_log
        if not UtilClient.is_unset(request.log_backup_retention_period):
            query['LogBackupRetentionPeriod'] = request.log_backup_retention_period
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.preferred_backup_period):
            query['PreferredBackupPeriod'] = request.preferred_backup_period
        if not UtilClient.is_unset(request.preferred_backup_time):
            query['PreferredBackupTime'] = request.preferred_backup_time
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyBackupPolicy',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyBackupPolicyResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyBackupPolicyResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_backup_policy(
        self,
        request: adb_20211201_models.ModifyBackupPolicyRequest,
    ) -> adb_20211201_models.ModifyBackupPolicyResponse:
        """
        @summary Modifies the backup policy of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyBackupPolicyRequest
        @return: ModifyBackupPolicyResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_backup_policy_with_options(request, runtime)

    async def modify_backup_policy_async(
        self,
        request: adb_20211201_models.ModifyBackupPolicyRequest,
    ) -> adb_20211201_models.ModifyBackupPolicyResponse:
        """
        @summary Modifies the backup policy of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyBackupPolicyRequest
        @return: ModifyBackupPolicyResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_backup_policy_with_options_async(request, runtime)

    def modify_clickhouse_engine_with_options(
        self,
        request: adb_20211201_models.ModifyClickhouseEngineRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyClickhouseEngineResponse:
        """
        @summary 开启宽表引擎
        
        @param request: ModifyClickhouseEngineRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyClickhouseEngineResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.cache_size):
            query['CacheSize'] = request.cache_size
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enabled):
            query['Enabled'] = request.enabled
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyClickhouseEngine',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyClickhouseEngineResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyClickhouseEngineResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_clickhouse_engine_with_options_async(
        self,
        request: adb_20211201_models.ModifyClickhouseEngineRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyClickhouseEngineResponse:
        """
        @summary 开启宽表引擎
        
        @param request: ModifyClickhouseEngineRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyClickhouseEngineResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.cache_size):
            query['CacheSize'] = request.cache_size
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enabled):
            query['Enabled'] = request.enabled
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyClickhouseEngine',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyClickhouseEngineResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyClickhouseEngineResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_clickhouse_engine(
        self,
        request: adb_20211201_models.ModifyClickhouseEngineRequest,
    ) -> adb_20211201_models.ModifyClickhouseEngineResponse:
        """
        @summary 开启宽表引擎
        
        @param request: ModifyClickhouseEngineRequest
        @return: ModifyClickhouseEngineResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_clickhouse_engine_with_options(request, runtime)

    async def modify_clickhouse_engine_async(
        self,
        request: adb_20211201_models.ModifyClickhouseEngineRequest,
    ) -> adb_20211201_models.ModifyClickhouseEngineResponse:
        """
        @summary 开启宽表引擎
        
        @param request: ModifyClickhouseEngineRequest
        @return: ModifyClickhouseEngineResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_clickhouse_engine_with_options_async(request, runtime)

    def modify_cluster_access_white_list_with_options(
        self,
        request: adb_20211201_models.ModifyClusterAccessWhiteListRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyClusterAccessWhiteListResponse:
        """
        @summary Modifies the IP address whitelist of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: ModifyClusterAccessWhiteListRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyClusterAccessWhiteListResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_iparray_attribute):
            query['DBClusterIPArrayAttribute'] = request.dbcluster_iparray_attribute
        if not UtilClient.is_unset(request.dbcluster_iparray_name):
            query['DBClusterIPArrayName'] = request.dbcluster_iparray_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.modify_mode):
            query['ModifyMode'] = request.modify_mode
        if not UtilClient.is_unset(request.security_ips):
            query['SecurityIps'] = request.security_ips
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyClusterAccessWhiteList',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyClusterAccessWhiteListResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyClusterAccessWhiteListResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_cluster_access_white_list_with_options_async(
        self,
        request: adb_20211201_models.ModifyClusterAccessWhiteListRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyClusterAccessWhiteListResponse:
        """
        @summary Modifies the IP address whitelist of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: ModifyClusterAccessWhiteListRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyClusterAccessWhiteListResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_iparray_attribute):
            query['DBClusterIPArrayAttribute'] = request.dbcluster_iparray_attribute
        if not UtilClient.is_unset(request.dbcluster_iparray_name):
            query['DBClusterIPArrayName'] = request.dbcluster_iparray_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.modify_mode):
            query['ModifyMode'] = request.modify_mode
        if not UtilClient.is_unset(request.security_ips):
            query['SecurityIps'] = request.security_ips
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyClusterAccessWhiteList',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyClusterAccessWhiteListResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyClusterAccessWhiteListResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_cluster_access_white_list(
        self,
        request: adb_20211201_models.ModifyClusterAccessWhiteListRequest,
    ) -> adb_20211201_models.ModifyClusterAccessWhiteListResponse:
        """
        @summary Modifies the IP address whitelist of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: ModifyClusterAccessWhiteListRequest
        @return: ModifyClusterAccessWhiteListResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_cluster_access_white_list_with_options(request, runtime)

    async def modify_cluster_access_white_list_async(
        self,
        request: adb_20211201_models.ModifyClusterAccessWhiteListRequest,
    ) -> adb_20211201_models.ModifyClusterAccessWhiteListResponse:
        """
        @summary Modifies the IP address whitelist of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: ModifyClusterAccessWhiteListRequest
        @return: ModifyClusterAccessWhiteListResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_cluster_access_white_list_with_options_async(request, runtime)

    def modify_cluster_connection_string_with_options(
        self,
        request: adb_20211201_models.ModifyClusterConnectionStringRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyClusterConnectionStringResponse:
        """
        @summary Modifies the public endpoint of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyClusterConnectionStringRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyClusterConnectionStringResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.connection_string_prefix):
            query['ConnectionStringPrefix'] = request.connection_string_prefix
        if not UtilClient.is_unset(request.current_connection_string):
            query['CurrentConnectionString'] = request.current_connection_string
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.port):
            query['Port'] = request.port
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyClusterConnectionString',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyClusterConnectionStringResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyClusterConnectionStringResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_cluster_connection_string_with_options_async(
        self,
        request: adb_20211201_models.ModifyClusterConnectionStringRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyClusterConnectionStringResponse:
        """
        @summary Modifies the public endpoint of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyClusterConnectionStringRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyClusterConnectionStringResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.connection_string_prefix):
            query['ConnectionStringPrefix'] = request.connection_string_prefix
        if not UtilClient.is_unset(request.current_connection_string):
            query['CurrentConnectionString'] = request.current_connection_string
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.port):
            query['Port'] = request.port
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyClusterConnectionString',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyClusterConnectionStringResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyClusterConnectionStringResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_cluster_connection_string(
        self,
        request: adb_20211201_models.ModifyClusterConnectionStringRequest,
    ) -> adb_20211201_models.ModifyClusterConnectionStringResponse:
        """
        @summary Modifies the public endpoint of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyClusterConnectionStringRequest
        @return: ModifyClusterConnectionStringResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_cluster_connection_string_with_options(request, runtime)

    async def modify_cluster_connection_string_async(
        self,
        request: adb_20211201_models.ModifyClusterConnectionStringRequest,
    ) -> adb_20211201_models.ModifyClusterConnectionStringResponse:
        """
        @summary Modifies the public endpoint of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyClusterConnectionStringRequest
        @return: ModifyClusterConnectionStringResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_cluster_connection_string_with_options_async(request, runtime)

    def modify_compaction_service_switch_with_options(
        self,
        request: adb_20211201_models.ModifyCompactionServiceSwitchRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyCompactionServiceSwitchResponse:
        """
        @summary Modifies the status of the remote build feature in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyCompactionServiceSwitchRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyCompactionServiceSwitchResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_compaction_service):
            query['EnableCompactionService'] = request.enable_compaction_service
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyCompactionServiceSwitch',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyCompactionServiceSwitchResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyCompactionServiceSwitchResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_compaction_service_switch_with_options_async(
        self,
        request: adb_20211201_models.ModifyCompactionServiceSwitchRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyCompactionServiceSwitchResponse:
        """
        @summary Modifies the status of the remote build feature in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyCompactionServiceSwitchRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyCompactionServiceSwitchResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_compaction_service):
            query['EnableCompactionService'] = request.enable_compaction_service
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyCompactionServiceSwitch',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyCompactionServiceSwitchResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyCompactionServiceSwitchResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_compaction_service_switch(
        self,
        request: adb_20211201_models.ModifyCompactionServiceSwitchRequest,
    ) -> adb_20211201_models.ModifyCompactionServiceSwitchResponse:
        """
        @summary Modifies the status of the remote build feature in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyCompactionServiceSwitchRequest
        @return: ModifyCompactionServiceSwitchResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_compaction_service_switch_with_options(request, runtime)

    async def modify_compaction_service_switch_async(
        self,
        request: adb_20211201_models.ModifyCompactionServiceSwitchRequest,
    ) -> adb_20211201_models.ModifyCompactionServiceSwitchResponse:
        """
        @summary Modifies the status of the remote build feature in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyCompactionServiceSwitchRequest
        @return: ModifyCompactionServiceSwitchResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_compaction_service_switch_with_options_async(request, runtime)

    def modify_dbcluster_with_options(
        self,
        request: adb_20211201_models.ModifyDBClusterRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBClusterResponse:
        """
        @summary Changes the configurations of an AnalyticDB for MySQL Data Lakehouse Edition cluster.
        
        @description ### [](#)
        During a scaling event, you are not allowed to execute the `SUBMIT JOB` statement to submit asynchronous jobs. If your business requires asynchronous jobs, perform scaling during appropriate periods.
        When you scale a cluster, data in the cluster is migrated for redistribution. The amount of time that is required to migrate data is proportional to the data volume. During a scaling event, the services provided by the cluster are not interrupted. When you downgrade cluster specifications, data migration may require up to dozens of hours to complete. Proceed with caution especially if your cluster contains a large amount of data.
        If the cluster has a built-in dataset loaded, make sure that the cluster has reserved storage resources of at least 24 AnalyticDB compute units (ACUs). Otherwise, the built-in dataset cannot be used.
        When the scaling process is about to end, transient connections may occur. We recommend that you scale your cluster during off-peak hours or make sure that your application is configured to automatically reconnect to your cluster.
        You can change an AnalyticDB for MySQL cluster from Data Warehouse Edition to Data Lakehouse Edition, but not the other way around. For more information, see Change a cluster from Data Warehouse Edition to Data Lakehouse Edition.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBClusterResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.compute_resource):
            query['ComputeResource'] = request.compute_resource
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_default_resource_pool):
            query['EnableDefaultResourcePool'] = request.enable_default_resource_pool
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.product_form):
            query['ProductForm'] = request.product_form
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.reserved_node_count):
            query['ReservedNodeCount'] = request.reserved_node_count
        if not UtilClient.is_unset(request.reserved_node_size):
            query['ReservedNodeSize'] = request.reserved_node_size
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.storage_resource):
            query['StorageResource'] = request.storage_resource
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBCluster',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_dbcluster_with_options_async(
        self,
        request: adb_20211201_models.ModifyDBClusterRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBClusterResponse:
        """
        @summary Changes the configurations of an AnalyticDB for MySQL Data Lakehouse Edition cluster.
        
        @description ### [](#)
        During a scaling event, you are not allowed to execute the `SUBMIT JOB` statement to submit asynchronous jobs. If your business requires asynchronous jobs, perform scaling during appropriate periods.
        When you scale a cluster, data in the cluster is migrated for redistribution. The amount of time that is required to migrate data is proportional to the data volume. During a scaling event, the services provided by the cluster are not interrupted. When you downgrade cluster specifications, data migration may require up to dozens of hours to complete. Proceed with caution especially if your cluster contains a large amount of data.
        If the cluster has a built-in dataset loaded, make sure that the cluster has reserved storage resources of at least 24 AnalyticDB compute units (ACUs). Otherwise, the built-in dataset cannot be used.
        When the scaling process is about to end, transient connections may occur. We recommend that you scale your cluster during off-peak hours or make sure that your application is configured to automatically reconnect to your cluster.
        You can change an AnalyticDB for MySQL cluster from Data Warehouse Edition to Data Lakehouse Edition, but not the other way around. For more information, see Change a cluster from Data Warehouse Edition to Data Lakehouse Edition.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBClusterResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.compute_resource):
            query['ComputeResource'] = request.compute_resource
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_default_resource_pool):
            query['EnableDefaultResourcePool'] = request.enable_default_resource_pool
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.product_form):
            query['ProductForm'] = request.product_form
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.reserved_node_count):
            query['ReservedNodeCount'] = request.reserved_node_count
        if not UtilClient.is_unset(request.reserved_node_size):
            query['ReservedNodeSize'] = request.reserved_node_size
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.storage_resource):
            query['StorageResource'] = request.storage_resource
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBCluster',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_dbcluster(
        self,
        request: adb_20211201_models.ModifyDBClusterRequest,
    ) -> adb_20211201_models.ModifyDBClusterResponse:
        """
        @summary Changes the configurations of an AnalyticDB for MySQL Data Lakehouse Edition cluster.
        
        @description ### [](#)
        During a scaling event, you are not allowed to execute the `SUBMIT JOB` statement to submit asynchronous jobs. If your business requires asynchronous jobs, perform scaling during appropriate periods.
        When you scale a cluster, data in the cluster is migrated for redistribution. The amount of time that is required to migrate data is proportional to the data volume. During a scaling event, the services provided by the cluster are not interrupted. When you downgrade cluster specifications, data migration may require up to dozens of hours to complete. Proceed with caution especially if your cluster contains a large amount of data.
        If the cluster has a built-in dataset loaded, make sure that the cluster has reserved storage resources of at least 24 AnalyticDB compute units (ACUs). Otherwise, the built-in dataset cannot be used.
        When the scaling process is about to end, transient connections may occur. We recommend that you scale your cluster during off-peak hours or make sure that your application is configured to automatically reconnect to your cluster.
        You can change an AnalyticDB for MySQL cluster from Data Warehouse Edition to Data Lakehouse Edition, but not the other way around. For more information, see Change a cluster from Data Warehouse Edition to Data Lakehouse Edition.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterRequest
        @return: ModifyDBClusterResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_dbcluster_with_options(request, runtime)

    async def modify_dbcluster_async(
        self,
        request: adb_20211201_models.ModifyDBClusterRequest,
    ) -> adb_20211201_models.ModifyDBClusterResponse:
        """
        @summary Changes the configurations of an AnalyticDB for MySQL Data Lakehouse Edition cluster.
        
        @description ### [](#)
        During a scaling event, you are not allowed to execute the `SUBMIT JOB` statement to submit asynchronous jobs. If your business requires asynchronous jobs, perform scaling during appropriate periods.
        When you scale a cluster, data in the cluster is migrated for redistribution. The amount of time that is required to migrate data is proportional to the data volume. During a scaling event, the services provided by the cluster are not interrupted. When you downgrade cluster specifications, data migration may require up to dozens of hours to complete. Proceed with caution especially if your cluster contains a large amount of data.
        If the cluster has a built-in dataset loaded, make sure that the cluster has reserved storage resources of at least 24 AnalyticDB compute units (ACUs). Otherwise, the built-in dataset cannot be used.
        When the scaling process is about to end, transient connections may occur. We recommend that you scale your cluster during off-peak hours or make sure that your application is configured to automatically reconnect to your cluster.
        You can change an AnalyticDB for MySQL cluster from Data Warehouse Edition to Data Lakehouse Edition, but not the other way around. For more information, see Change a cluster from Data Warehouse Edition to Data Lakehouse Edition.
        For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterRequest
        @return: ModifyDBClusterResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_dbcluster_with_options_async(request, runtime)

    def modify_dbcluster_description_with_options(
        self,
        request: adb_20211201_models.ModifyDBClusterDescriptionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBClusterDescriptionResponse:
        """
        @summary Modifies the description of an AnalyticDB for MySQL cluster to facilitate the maintenance and management of the cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterDescriptionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBClusterDescriptionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_description):
            query['DBClusterDescription'] = request.dbcluster_description
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBClusterDescription',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterDescriptionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterDescriptionResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_dbcluster_description_with_options_async(
        self,
        request: adb_20211201_models.ModifyDBClusterDescriptionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBClusterDescriptionResponse:
        """
        @summary Modifies the description of an AnalyticDB for MySQL cluster to facilitate the maintenance and management of the cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterDescriptionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBClusterDescriptionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_description):
            query['DBClusterDescription'] = request.dbcluster_description
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBClusterDescription',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterDescriptionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterDescriptionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_dbcluster_description(
        self,
        request: adb_20211201_models.ModifyDBClusterDescriptionRequest,
    ) -> adb_20211201_models.ModifyDBClusterDescriptionResponse:
        """
        @summary Modifies the description of an AnalyticDB for MySQL cluster to facilitate the maintenance and management of the cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterDescriptionRequest
        @return: ModifyDBClusterDescriptionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_dbcluster_description_with_options(request, runtime)

    async def modify_dbcluster_description_async(
        self,
        request: adb_20211201_models.ModifyDBClusterDescriptionRequest,
    ) -> adb_20211201_models.ModifyDBClusterDescriptionResponse:
        """
        @summary Modifies the description of an AnalyticDB for MySQL cluster to facilitate the maintenance and management of the cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterDescriptionRequest
        @return: ModifyDBClusterDescriptionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_dbcluster_description_with_options_async(request, runtime)

    def modify_dbcluster_maintain_time_with_options(
        self,
        request: adb_20211201_models.ModifyDBClusterMaintainTimeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBClusterMaintainTimeResponse:
        """
        @summary Modifies the maintenance window of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterMaintainTimeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBClusterMaintainTimeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.maintain_time):
            query['MaintainTime'] = request.maintain_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBClusterMaintainTime',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterMaintainTimeResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterMaintainTimeResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_dbcluster_maintain_time_with_options_async(
        self,
        request: adb_20211201_models.ModifyDBClusterMaintainTimeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBClusterMaintainTimeResponse:
        """
        @summary Modifies the maintenance window of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterMaintainTimeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBClusterMaintainTimeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.maintain_time):
            query['MaintainTime'] = request.maintain_time
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBClusterMaintainTime',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterMaintainTimeResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterMaintainTimeResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_dbcluster_maintain_time(
        self,
        request: adb_20211201_models.ModifyDBClusterMaintainTimeRequest,
    ) -> adb_20211201_models.ModifyDBClusterMaintainTimeResponse:
        """
        @summary Modifies the maintenance window of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterMaintainTimeRequest
        @return: ModifyDBClusterMaintainTimeResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_dbcluster_maintain_time_with_options(request, runtime)

    async def modify_dbcluster_maintain_time_async(
        self,
        request: adb_20211201_models.ModifyDBClusterMaintainTimeRequest,
    ) -> adb_20211201_models.ModifyDBClusterMaintainTimeResponse:
        """
        @summary Modifies the maintenance window of an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBClusterMaintainTimeRequest
        @return: ModifyDBClusterMaintainTimeResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_dbcluster_maintain_time_with_options_async(request, runtime)

    def modify_dbcluster_resource_group_with_options(
        self,
        request: adb_20211201_models.ModifyDBClusterResourceGroupRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBClusterResourceGroupResponse:
        """
        @summary Changes the resource group to which an AnalyticDB for MySQL cluster belongs.
        
        @param request: ModifyDBClusterResourceGroupRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBClusterResourceGroupResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.new_resource_group_id):
            query['NewResourceGroupId'] = request.new_resource_group_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBClusterResourceGroup',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterResourceGroupResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterResourceGroupResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_dbcluster_resource_group_with_options_async(
        self,
        request: adb_20211201_models.ModifyDBClusterResourceGroupRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBClusterResourceGroupResponse:
        """
        @summary Changes the resource group to which an AnalyticDB for MySQL cluster belongs.
        
        @param request: ModifyDBClusterResourceGroupRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBClusterResourceGroupResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.new_resource_group_id):
            query['NewResourceGroupId'] = request.new_resource_group_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBClusterResourceGroup',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterResourceGroupResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterResourceGroupResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_dbcluster_resource_group(
        self,
        request: adb_20211201_models.ModifyDBClusterResourceGroupRequest,
    ) -> adb_20211201_models.ModifyDBClusterResourceGroupResponse:
        """
        @summary Changes the resource group to which an AnalyticDB for MySQL cluster belongs.
        
        @param request: ModifyDBClusterResourceGroupRequest
        @return: ModifyDBClusterResourceGroupResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_dbcluster_resource_group_with_options(request, runtime)

    async def modify_dbcluster_resource_group_async(
        self,
        request: adb_20211201_models.ModifyDBClusterResourceGroupRequest,
    ) -> adb_20211201_models.ModifyDBClusterResourceGroupResponse:
        """
        @summary Changes the resource group to which an AnalyticDB for MySQL cluster belongs.
        
        @param request: ModifyDBClusterResourceGroupRequest
        @return: ModifyDBClusterResourceGroupResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_dbcluster_resource_group_with_options_async(request, runtime)

    def modify_dbcluster_vip_with_options(
        self,
        request: adb_20211201_models.ModifyDBClusterVipRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBClusterVipResponse:
        """
        @summary Changes the virtual IP address (VIP) that is used to connect to an AnalyticDB for MySQL cluster.
        
        @param request: ModifyDBClusterVipRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBClusterVipResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.connect_string):
            query['ConnectString'] = request.connect_string
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.vpcid):
            query['VPCId'] = request.vpcid
        if not UtilClient.is_unset(request.v_switch_id):
            query['VSwitchId'] = request.v_switch_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBClusterVip',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterVipResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterVipResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_dbcluster_vip_with_options_async(
        self,
        request: adb_20211201_models.ModifyDBClusterVipRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBClusterVipResponse:
        """
        @summary Changes the virtual IP address (VIP) that is used to connect to an AnalyticDB for MySQL cluster.
        
        @param request: ModifyDBClusterVipRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBClusterVipResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.connect_string):
            query['ConnectString'] = request.connect_string
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.vpcid):
            query['VPCId'] = request.vpcid
        if not UtilClient.is_unset(request.v_switch_id):
            query['VSwitchId'] = request.v_switch_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBClusterVip',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterVipResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBClusterVipResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_dbcluster_vip(
        self,
        request: adb_20211201_models.ModifyDBClusterVipRequest,
    ) -> adb_20211201_models.ModifyDBClusterVipResponse:
        """
        @summary Changes the virtual IP address (VIP) that is used to connect to an AnalyticDB for MySQL cluster.
        
        @param request: ModifyDBClusterVipRequest
        @return: ModifyDBClusterVipResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_dbcluster_vip_with_options(request, runtime)

    async def modify_dbcluster_vip_async(
        self,
        request: adb_20211201_models.ModifyDBClusterVipRequest,
    ) -> adb_20211201_models.ModifyDBClusterVipResponse:
        """
        @summary Changes the virtual IP address (VIP) that is used to connect to an AnalyticDB for MySQL cluster.
        
        @param request: ModifyDBClusterVipRequest
        @return: ModifyDBClusterVipResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_dbcluster_vip_with_options_async(request, runtime)

    def modify_dbresource_group_with_options(
        self,
        tmp_req: adb_20211201_models.ModifyDBResourceGroupRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBResourceGroupResponse:
        """
        @summary Modifies the amount of reserved computing resources for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param tmp_req: ModifyDBResourceGroupRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBResourceGroupResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ModifyDBResourceGroupShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.engine_params):
            request.engine_params_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.engine_params, 'EngineParams', 'json')
        if not UtilClient.is_unset(tmp_req.ray_config):
            request.ray_config_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.ray_config, 'RayConfig', 'json')
        if not UtilClient.is_unset(tmp_req.rules):
            request.rules_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.rules, 'Rules', 'json')
        query = {}
        if not UtilClient.is_unset(request.auto_stop_interval):
            query['AutoStopInterval'] = request.auto_stop_interval
        if not UtilClient.is_unset(request.cluster_mode):
            query['ClusterMode'] = request.cluster_mode
        if not UtilClient.is_unset(request.cluster_size_resource):
            query['ClusterSizeResource'] = request.cluster_size_resource
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_spot):
            query['EnableSpot'] = request.enable_spot
        if not UtilClient.is_unset(request.engine_params_shrink):
            query['EngineParams'] = request.engine_params_shrink
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        if not UtilClient.is_unset(request.group_type):
            query['GroupType'] = request.group_type
        if not UtilClient.is_unset(request.max_cluster_count):
            query['MaxClusterCount'] = request.max_cluster_count
        if not UtilClient.is_unset(request.max_compute_resource):
            query['MaxComputeResource'] = request.max_compute_resource
        if not UtilClient.is_unset(request.max_gpu_quantity):
            query['MaxGpuQuantity'] = request.max_gpu_quantity
        if not UtilClient.is_unset(request.min_cluster_count):
            query['MinClusterCount'] = request.min_cluster_count
        if not UtilClient.is_unset(request.min_compute_resource):
            query['MinComputeResource'] = request.min_compute_resource
        if not UtilClient.is_unset(request.min_gpu_quantity):
            query['MinGpuQuantity'] = request.min_gpu_quantity
        if not UtilClient.is_unset(request.ray_config_shrink):
            query['RayConfig'] = request.ray_config_shrink
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.rules_shrink):
            query['Rules'] = request.rules_shrink
        if not UtilClient.is_unset(request.spec_name):
            query['SpecName'] = request.spec_name
        if not UtilClient.is_unset(request.status):
            query['Status'] = request.status
        if not UtilClient.is_unset(request.target_resource_group_name):
            query['TargetResourceGroupName'] = request.target_resource_group_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBResourceGroup',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBResourceGroupResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBResourceGroupResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_dbresource_group_with_options_async(
        self,
        tmp_req: adb_20211201_models.ModifyDBResourceGroupRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyDBResourceGroupResponse:
        """
        @summary Modifies the amount of reserved computing resources for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param tmp_req: ModifyDBResourceGroupRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyDBResourceGroupResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ModifyDBResourceGroupShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.engine_params):
            request.engine_params_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.engine_params, 'EngineParams', 'json')
        if not UtilClient.is_unset(tmp_req.ray_config):
            request.ray_config_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.ray_config, 'RayConfig', 'json')
        if not UtilClient.is_unset(tmp_req.rules):
            request.rules_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.rules, 'Rules', 'json')
        query = {}
        if not UtilClient.is_unset(request.auto_stop_interval):
            query['AutoStopInterval'] = request.auto_stop_interval
        if not UtilClient.is_unset(request.cluster_mode):
            query['ClusterMode'] = request.cluster_mode
        if not UtilClient.is_unset(request.cluster_size_resource):
            query['ClusterSizeResource'] = request.cluster_size_resource
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_spot):
            query['EnableSpot'] = request.enable_spot
        if not UtilClient.is_unset(request.engine_params_shrink):
            query['EngineParams'] = request.engine_params_shrink
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        if not UtilClient.is_unset(request.group_type):
            query['GroupType'] = request.group_type
        if not UtilClient.is_unset(request.max_cluster_count):
            query['MaxClusterCount'] = request.max_cluster_count
        if not UtilClient.is_unset(request.max_compute_resource):
            query['MaxComputeResource'] = request.max_compute_resource
        if not UtilClient.is_unset(request.max_gpu_quantity):
            query['MaxGpuQuantity'] = request.max_gpu_quantity
        if not UtilClient.is_unset(request.min_cluster_count):
            query['MinClusterCount'] = request.min_cluster_count
        if not UtilClient.is_unset(request.min_compute_resource):
            query['MinComputeResource'] = request.min_compute_resource
        if not UtilClient.is_unset(request.min_gpu_quantity):
            query['MinGpuQuantity'] = request.min_gpu_quantity
        if not UtilClient.is_unset(request.ray_config_shrink):
            query['RayConfig'] = request.ray_config_shrink
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.rules_shrink):
            query['Rules'] = request.rules_shrink
        if not UtilClient.is_unset(request.spec_name):
            query['SpecName'] = request.spec_name
        if not UtilClient.is_unset(request.status):
            query['Status'] = request.status
        if not UtilClient.is_unset(request.target_resource_group_name):
            query['TargetResourceGroupName'] = request.target_resource_group_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyDBResourceGroup',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBResourceGroupResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyDBResourceGroupResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_dbresource_group(
        self,
        request: adb_20211201_models.ModifyDBResourceGroupRequest,
    ) -> adb_20211201_models.ModifyDBResourceGroupResponse:
        """
        @summary Modifies the amount of reserved computing resources for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBResourceGroupRequest
        @return: ModifyDBResourceGroupResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_dbresource_group_with_options(request, runtime)

    async def modify_dbresource_group_async(
        self,
        request: adb_20211201_models.ModifyDBResourceGroupRequest,
    ) -> adb_20211201_models.ModifyDBResourceGroupResponse:
        """
        @summary Modifies the amount of reserved computing resources for an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ModifyDBResourceGroupRequest
        @return: ModifyDBResourceGroupResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_dbresource_group_with_options_async(request, runtime)

    def modify_elastic_plan_with_options(
        self,
        request: adb_20211201_models.ModifyElasticPlanRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyElasticPlanResponse:
        """
        @summary Modifies a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: ModifyElasticPlanRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyElasticPlanResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.cron_expression):
            query['CronExpression'] = request.cron_expression
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.target_size):
            query['TargetSize'] = request.target_size
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyElasticPlan',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyElasticPlanResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyElasticPlanResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_elastic_plan_with_options_async(
        self,
        request: adb_20211201_models.ModifyElasticPlanRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyElasticPlanResponse:
        """
        @summary Modifies a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: ModifyElasticPlanRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyElasticPlanResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.cron_expression):
            query['CronExpression'] = request.cron_expression
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.elastic_plan_name):
            query['ElasticPlanName'] = request.elastic_plan_name
        if not UtilClient.is_unset(request.end_time):
            query['EndTime'] = request.end_time
        if not UtilClient.is_unset(request.start_time):
            query['StartTime'] = request.start_time
        if not UtilClient.is_unset(request.target_size):
            query['TargetSize'] = request.target_size
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyElasticPlan',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyElasticPlanResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyElasticPlanResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_elastic_plan(
        self,
        request: adb_20211201_models.ModifyElasticPlanRequest,
    ) -> adb_20211201_models.ModifyElasticPlanResponse:
        """
        @summary Modifies a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: ModifyElasticPlanRequest
        @return: ModifyElasticPlanResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_elastic_plan_with_options(request, runtime)

    async def modify_elastic_plan_async(
        self,
        request: adb_20211201_models.ModifyElasticPlanRequest,
    ) -> adb_20211201_models.ModifyElasticPlanResponse:
        """
        @summary Modifies a scaling plan for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see Endpoints.
        
        @param request: ModifyElasticPlanRequest
        @return: ModifyElasticPlanResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_elastic_plan_with_options_async(request, runtime)

    def modify_essd_cache_config_with_options(
        self,
        request: adb_20211201_models.ModifyEssdCacheConfigRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyEssdCacheConfigResponse:
        """
        @summary Modifies the disk cache size in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyEssdCacheConfigRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyEssdCacheConfigResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_essd_cache):
            query['EnableEssdCache'] = request.enable_essd_cache
        if not UtilClient.is_unset(request.essd_cache_size):
            query['EssdCacheSize'] = request.essd_cache_size
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyEssdCacheConfig',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyEssdCacheConfigResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyEssdCacheConfigResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_essd_cache_config_with_options_async(
        self,
        request: adb_20211201_models.ModifyEssdCacheConfigRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyEssdCacheConfigResponse:
        """
        @summary Modifies the disk cache size in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyEssdCacheConfigRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyEssdCacheConfigResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_essd_cache):
            query['EnableEssdCache'] = request.enable_essd_cache
        if not UtilClient.is_unset(request.essd_cache_size):
            query['EssdCacheSize'] = request.essd_cache_size
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyEssdCacheConfig',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyEssdCacheConfigResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyEssdCacheConfigResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_essd_cache_config(
        self,
        request: adb_20211201_models.ModifyEssdCacheConfigRequest,
    ) -> adb_20211201_models.ModifyEssdCacheConfigResponse:
        """
        @summary Modifies the disk cache size in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyEssdCacheConfigRequest
        @return: ModifyEssdCacheConfigResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_essd_cache_config_with_options(request, runtime)

    async def modify_essd_cache_config_async(
        self,
        request: adb_20211201_models.ModifyEssdCacheConfigRequest,
    ) -> adb_20211201_models.ModifyEssdCacheConfigResponse:
        """
        @summary Modifies the disk cache size in the query acceleration configuration of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyEssdCacheConfigRequest
        @return: ModifyEssdCacheConfigResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_essd_cache_config_with_options_async(request, runtime)

    def modify_lake_cache_size_with_options(
        self,
        request: adb_20211201_models.ModifyLakeCacheSizeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyLakeCacheSizeResponse:
        """
        @summary Modifies the lake cache size of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyLakeCacheSizeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyLakeCacheSizeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.capacity):
            query['Capacity'] = request.capacity
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_lake_cache):
            query['EnableLakeCache'] = request.enable_lake_cache
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyLakeCacheSize',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyLakeCacheSizeResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyLakeCacheSizeResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_lake_cache_size_with_options_async(
        self,
        request: adb_20211201_models.ModifyLakeCacheSizeRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyLakeCacheSizeResponse:
        """
        @summary Modifies the lake cache size of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyLakeCacheSizeRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyLakeCacheSizeResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.capacity):
            query['Capacity'] = request.capacity
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.enable_lake_cache):
            query['EnableLakeCache'] = request.enable_lake_cache
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyLakeCacheSize',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyLakeCacheSizeResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyLakeCacheSizeResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_lake_cache_size(
        self,
        request: adb_20211201_models.ModifyLakeCacheSizeRequest,
    ) -> adb_20211201_models.ModifyLakeCacheSizeResponse:
        """
        @summary Modifies the lake cache size of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyLakeCacheSizeRequest
        @return: ModifyLakeCacheSizeResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_lake_cache_size_with_options(request, runtime)

    async def modify_lake_cache_size_async(
        self,
        request: adb_20211201_models.ModifyLakeCacheSizeRequest,
    ) -> adb_20211201_models.ModifyLakeCacheSizeResponse:
        """
        @summary Modifies the lake cache size of an AnalyticDB for MySQL cluster.
        
        @param request: ModifyLakeCacheSizeRequest
        @return: ModifyLakeCacheSizeResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_lake_cache_size_with_options_async(request, runtime)

    def modify_performance_view_with_options(
        self,
        tmp_req: adb_20211201_models.ModifyPerformanceViewRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyPerformanceViewResponse:
        """
        @summary Modifies the information about a custom monitoring view.
        
        @param tmp_req: ModifyPerformanceViewRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyPerformanceViewResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ModifyPerformanceViewShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.view_detail):
            request.view_detail_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.view_detail, 'ViewDetail', 'json')
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.view_detail_shrink):
            query['ViewDetail'] = request.view_detail_shrink
        if not UtilClient.is_unset(request.view_name):
            query['ViewName'] = request.view_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyPerformanceView',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyPerformanceViewResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyPerformanceViewResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_performance_view_with_options_async(
        self,
        tmp_req: adb_20211201_models.ModifyPerformanceViewRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyPerformanceViewResponse:
        """
        @summary Modifies the information about a custom monitoring view.
        
        @param tmp_req: ModifyPerformanceViewRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyPerformanceViewResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.ModifyPerformanceViewShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.view_detail):
            request.view_detail_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.view_detail, 'ViewDetail', 'json')
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.view_detail_shrink):
            query['ViewDetail'] = request.view_detail_shrink
        if not UtilClient.is_unset(request.view_name):
            query['ViewName'] = request.view_name
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ModifyPerformanceView',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyPerformanceViewResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyPerformanceViewResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_performance_view(
        self,
        request: adb_20211201_models.ModifyPerformanceViewRequest,
    ) -> adb_20211201_models.ModifyPerformanceViewResponse:
        """
        @summary Modifies the information about a custom monitoring view.
        
        @param request: ModifyPerformanceViewRequest
        @return: ModifyPerformanceViewResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_performance_view_with_options(request, runtime)

    async def modify_performance_view_async(
        self,
        request: adb_20211201_models.ModifyPerformanceViewRequest,
    ) -> adb_20211201_models.ModifyPerformanceViewResponse:
        """
        @summary Modifies the information about a custom monitoring view.
        
        @param request: ModifyPerformanceViewRequest
        @return: ModifyPerformanceViewResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_performance_view_with_options_async(request, runtime)

    def modify_user_eni_vswitch_options_with_options(
        self,
        request: adb_20211201_models.ModifyUserEniVswitchOptionsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyUserEniVswitchOptionsResponse:
        """
        @summary Modifies the vSwitches that are connected to elastic network interfaces (ENIs).
        
        @param request: ModifyUserEniVswitchOptionsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyUserEniVswitchOptionsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.db_cluster_id):
            query['DbClusterId'] = request.db_cluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        body = {}
        if not UtilClient.is_unset(request.v_switch_options):
            body['VSwitchOptions'] = request.v_switch_options
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ModifyUserEniVswitchOptions',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyUserEniVswitchOptionsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyUserEniVswitchOptionsResponse(),
                self.execute(params, req, runtime)
            )

    async def modify_user_eni_vswitch_options_with_options_async(
        self,
        request: adb_20211201_models.ModifyUserEniVswitchOptionsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ModifyUserEniVswitchOptionsResponse:
        """
        @summary Modifies the vSwitches that are connected to elastic network interfaces (ENIs).
        
        @param request: ModifyUserEniVswitchOptionsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ModifyUserEniVswitchOptionsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.db_cluster_id):
            query['DbClusterId'] = request.db_cluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.region_id):
            query['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        body = {}
        if not UtilClient.is_unset(request.v_switch_options):
            body['VSwitchOptions'] = request.v_switch_options
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='ModifyUserEniVswitchOptions',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ModifyUserEniVswitchOptionsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ModifyUserEniVswitchOptionsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def modify_user_eni_vswitch_options(
        self,
        request: adb_20211201_models.ModifyUserEniVswitchOptionsRequest,
    ) -> adb_20211201_models.ModifyUserEniVswitchOptionsResponse:
        """
        @summary Modifies the vSwitches that are connected to elastic network interfaces (ENIs).
        
        @param request: ModifyUserEniVswitchOptionsRequest
        @return: ModifyUserEniVswitchOptionsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.modify_user_eni_vswitch_options_with_options(request, runtime)

    async def modify_user_eni_vswitch_options_async(
        self,
        request: adb_20211201_models.ModifyUserEniVswitchOptionsRequest,
    ) -> adb_20211201_models.ModifyUserEniVswitchOptionsResponse:
        """
        @summary Modifies the vSwitches that are connected to elastic network interfaces (ENIs).
        
        @param request: ModifyUserEniVswitchOptionsRequest
        @return: ModifyUserEniVswitchOptionsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.modify_user_eni_vswitch_options_with_options_async(request, runtime)

    def preload_spark_app_metrics_with_options(
        self,
        request: adb_20211201_models.PreloadSparkAppMetricsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.PreloadSparkAppMetricsResponse:
        """
        @summary Preloads metrics for a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: PreloadSparkAppMetricsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: PreloadSparkAppMetricsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='PreloadSparkAppMetrics',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.PreloadSparkAppMetricsResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.PreloadSparkAppMetricsResponse(),
                self.execute(params, req, runtime)
            )

    async def preload_spark_app_metrics_with_options_async(
        self,
        request: adb_20211201_models.PreloadSparkAppMetricsRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.PreloadSparkAppMetricsResponse:
        """
        @summary Preloads metrics for a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: PreloadSparkAppMetricsRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: PreloadSparkAppMetricsResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query),
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='PreloadSparkAppMetrics',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.PreloadSparkAppMetricsResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.PreloadSparkAppMetricsResponse(),
                await self.execute_async(params, req, runtime)
            )

    def preload_spark_app_metrics(
        self,
        request: adb_20211201_models.PreloadSparkAppMetricsRequest,
    ) -> adb_20211201_models.PreloadSparkAppMetricsResponse:
        """
        @summary Preloads metrics for a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: PreloadSparkAppMetricsRequest
        @return: PreloadSparkAppMetricsResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.preload_spark_app_metrics_with_options(request, runtime)

    async def preload_spark_app_metrics_async(
        self,
        request: adb_20211201_models.PreloadSparkAppMetricsRequest,
    ) -> adb_20211201_models.PreloadSparkAppMetricsResponse:
        """
        @summary Preloads metrics for a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: PreloadSparkAppMetricsRequest
        @return: PreloadSparkAppMetricsResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.preload_spark_app_metrics_with_options_async(request, runtime)

    def release_cluster_public_connection_with_options(
        self,
        request: adb_20211201_models.ReleaseClusterPublicConnectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ReleaseClusterPublicConnectionResponse:
        """
        @summary Releases the public endpoint of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ReleaseClusterPublicConnectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ReleaseClusterPublicConnectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ReleaseClusterPublicConnection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ReleaseClusterPublicConnectionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ReleaseClusterPublicConnectionResponse(),
                self.execute(params, req, runtime)
            )

    async def release_cluster_public_connection_with_options_async(
        self,
        request: adb_20211201_models.ReleaseClusterPublicConnectionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ReleaseClusterPublicConnectionResponse:
        """
        @summary Releases the public endpoint of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ReleaseClusterPublicConnectionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ReleaseClusterPublicConnectionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ReleaseClusterPublicConnection',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ReleaseClusterPublicConnectionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ReleaseClusterPublicConnectionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def release_cluster_public_connection(
        self,
        request: adb_20211201_models.ReleaseClusterPublicConnectionRequest,
    ) -> adb_20211201_models.ReleaseClusterPublicConnectionResponse:
        """
        @summary Releases the public endpoint of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ReleaseClusterPublicConnectionRequest
        @return: ReleaseClusterPublicConnectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.release_cluster_public_connection_with_options(request, runtime)

    async def release_cluster_public_connection_async(
        self,
        request: adb_20211201_models.ReleaseClusterPublicConnectionRequest,
    ) -> adb_20211201_models.ReleaseClusterPublicConnectionResponse:
        """
        @summary Releases the public endpoint of an AnalyticDB for MySQL Data Lakehouse Edition (V3.0) cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ReleaseClusterPublicConnectionRequest
        @return: ReleaseClusterPublicConnectionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.release_cluster_public_connection_with_options_async(request, runtime)

    def reset_account_password_with_options(
        self,
        request: adb_20211201_models.ResetAccountPasswordRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ResetAccountPasswordResponse:
        """
        @summary Resets the password of a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ResetAccountPasswordRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ResetAccountPasswordResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_description):
            query['AccountDescription'] = request.account_description
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.account_password):
            query['AccountPassword'] = request.account_password
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ResetAccountPassword',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ResetAccountPasswordResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ResetAccountPasswordResponse(),
                self.execute(params, req, runtime)
            )

    async def reset_account_password_with_options_async(
        self,
        request: adb_20211201_models.ResetAccountPasswordRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.ResetAccountPasswordResponse:
        """
        @summary Resets the password of a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ResetAccountPasswordRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: ResetAccountPasswordResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_description):
            query['AccountDescription'] = request.account_description
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.account_password):
            query['AccountPassword'] = request.account_password
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            query['Engine'] = request.engine
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='ResetAccountPassword',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.ResetAccountPasswordResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.ResetAccountPasswordResponse(),
                await self.execute_async(params, req, runtime)
            )

    def reset_account_password(
        self,
        request: adb_20211201_models.ResetAccountPasswordRequest,
    ) -> adb_20211201_models.ResetAccountPasswordResponse:
        """
        @summary Resets the password of a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ResetAccountPasswordRequest
        @return: ResetAccountPasswordResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.reset_account_password_with_options(request, runtime)

    async def reset_account_password_async(
        self,
        request: adb_20211201_models.ResetAccountPasswordRequest,
    ) -> adb_20211201_models.ResetAccountPasswordResponse:
        """
        @summary Resets the password of a database account for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: ResetAccountPasswordRequest
        @return: ResetAccountPasswordResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.reset_account_password_with_options_async(request, runtime)

    def revoke_operator_permission_with_options(
        self,
        request: adb_20211201_models.RevokeOperatorPermissionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.RevokeOperatorPermissionResponse:
        """
        @summary Revokes permissions from the service account of an AnalyticDB for MySQL cluster.
        
        @param request: RevokeOperatorPermissionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: RevokeOperatorPermissionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='RevokeOperatorPermission',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.RevokeOperatorPermissionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.RevokeOperatorPermissionResponse(),
                self.execute(params, req, runtime)
            )

    async def revoke_operator_permission_with_options_async(
        self,
        request: adb_20211201_models.RevokeOperatorPermissionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.RevokeOperatorPermissionResponse:
        """
        @summary Revokes permissions from the service account of an AnalyticDB for MySQL cluster.
        
        @param request: RevokeOperatorPermissionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: RevokeOperatorPermissionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='RevokeOperatorPermission',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.RevokeOperatorPermissionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.RevokeOperatorPermissionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def revoke_operator_permission(
        self,
        request: adb_20211201_models.RevokeOperatorPermissionRequest,
    ) -> adb_20211201_models.RevokeOperatorPermissionResponse:
        """
        @summary Revokes permissions from the service account of an AnalyticDB for MySQL cluster.
        
        @param request: RevokeOperatorPermissionRequest
        @return: RevokeOperatorPermissionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.revoke_operator_permission_with_options(request, runtime)

    async def revoke_operator_permission_async(
        self,
        request: adb_20211201_models.RevokeOperatorPermissionRequest,
    ) -> adb_20211201_models.RevokeOperatorPermissionResponse:
        """
        @summary Revokes permissions from the service account of an AnalyticDB for MySQL cluster.
        
        @param request: RevokeOperatorPermissionRequest
        @return: RevokeOperatorPermissionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.revoke_operator_permission_with_options_async(request, runtime)

    def set_spark_app_log_root_path_with_options(
        self,
        request: adb_20211201_models.SetSparkAppLogRootPathRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.SetSparkAppLogRootPathResponse:
        """
        @summary Modifies the Spark log configuration.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SetSparkAppLogRootPathRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: SetSparkAppLogRootPathResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.oss_log_path):
            body['OssLogPath'] = request.oss_log_path
        if not UtilClient.is_unset(request.use_default_oss):
            body['UseDefaultOss'] = request.use_default_oss
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='SetSparkAppLogRootPath',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.SetSparkAppLogRootPathResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.SetSparkAppLogRootPathResponse(),
                self.execute(params, req, runtime)
            )

    async def set_spark_app_log_root_path_with_options_async(
        self,
        request: adb_20211201_models.SetSparkAppLogRootPathRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.SetSparkAppLogRootPathResponse:
        """
        @summary Modifies the Spark log configuration.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SetSparkAppLogRootPathRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: SetSparkAppLogRootPathResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.oss_log_path):
            body['OssLogPath'] = request.oss_log_path
        if not UtilClient.is_unset(request.use_default_oss):
            body['UseDefaultOss'] = request.use_default_oss
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='SetSparkAppLogRootPath',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.SetSparkAppLogRootPathResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.SetSparkAppLogRootPathResponse(),
                await self.execute_async(params, req, runtime)
            )

    def set_spark_app_log_root_path(
        self,
        request: adb_20211201_models.SetSparkAppLogRootPathRequest,
    ) -> adb_20211201_models.SetSparkAppLogRootPathResponse:
        """
        @summary Modifies the Spark log configuration.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SetSparkAppLogRootPathRequest
        @return: SetSparkAppLogRootPathResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.set_spark_app_log_root_path_with_options(request, runtime)

    async def set_spark_app_log_root_path_async(
        self,
        request: adb_20211201_models.SetSparkAppLogRootPathRequest,
    ) -> adb_20211201_models.SetSparkAppLogRootPathResponse:
        """
        @summary Modifies the Spark log configuration.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SetSparkAppLogRootPathRequest
        @return: SetSparkAppLogRootPathResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.set_spark_app_log_root_path_with_options_async(request, runtime)

    def start_aps_job_with_options(
        self,
        request: adb_20211201_models.StartApsJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.StartApsJobResponse:
        """
        @summary Starts an AnalyticDB Pipeline Service (APS) job.
        
        @param request: StartApsJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: StartApsJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_id):
            body['ApsJobId'] = request.aps_job_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='StartApsJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.StartApsJobResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.StartApsJobResponse(),
                self.execute(params, req, runtime)
            )

    async def start_aps_job_with_options_async(
        self,
        request: adb_20211201_models.StartApsJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.StartApsJobResponse:
        """
        @summary Starts an AnalyticDB Pipeline Service (APS) job.
        
        @param request: StartApsJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: StartApsJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_id):
            body['ApsJobId'] = request.aps_job_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='StartApsJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.StartApsJobResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.StartApsJobResponse(),
                await self.execute_async(params, req, runtime)
            )

    def start_aps_job(
        self,
        request: adb_20211201_models.StartApsJobRequest,
    ) -> adb_20211201_models.StartApsJobResponse:
        """
        @summary Starts an AnalyticDB Pipeline Service (APS) job.
        
        @param request: StartApsJobRequest
        @return: StartApsJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.start_aps_job_with_options(request, runtime)

    async def start_aps_job_async(
        self,
        request: adb_20211201_models.StartApsJobRequest,
    ) -> adb_20211201_models.StartApsJobResponse:
        """
        @summary Starts an AnalyticDB Pipeline Service (APS) job.
        
        @param request: StartApsJobRequest
        @return: StartApsJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.start_aps_job_with_options_async(request, runtime)

    def start_spark_repl_session_with_options(
        self,
        request: adb_20211201_models.StartSparkReplSessionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.StartSparkReplSessionResponse:
        """
        @summary Starts a Spark session.
        
        @param request: StartSparkReplSessionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: StartSparkReplSessionResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.config):
            body['Config'] = request.config
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='StartSparkReplSession',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.StartSparkReplSessionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.StartSparkReplSessionResponse(),
                self.execute(params, req, runtime)
            )

    async def start_spark_repl_session_with_options_async(
        self,
        request: adb_20211201_models.StartSparkReplSessionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.StartSparkReplSessionResponse:
        """
        @summary Starts a Spark session.
        
        @param request: StartSparkReplSessionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: StartSparkReplSessionResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.config):
            body['Config'] = request.config
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='StartSparkReplSession',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.StartSparkReplSessionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.StartSparkReplSessionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def start_spark_repl_session(
        self,
        request: adb_20211201_models.StartSparkReplSessionRequest,
    ) -> adb_20211201_models.StartSparkReplSessionResponse:
        """
        @summary Starts a Spark session.
        
        @param request: StartSparkReplSessionRequest
        @return: StartSparkReplSessionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.start_spark_repl_session_with_options(request, runtime)

    async def start_spark_repl_session_async(
        self,
        request: adb_20211201_models.StartSparkReplSessionRequest,
    ) -> adb_20211201_models.StartSparkReplSessionResponse:
        """
        @summary Starts a Spark session.
        
        @param request: StartSparkReplSessionRequest
        @return: StartSparkReplSessionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.start_spark_repl_session_with_options_async(request, runtime)

    def start_spark_sqlengine_with_options(
        self,
        request: adb_20211201_models.StartSparkSQLEngineRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.StartSparkSQLEngineResponse:
        """
        @summary Starts the Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: StartSparkSQLEngineRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: StartSparkSQLEngineResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.config):
            body['Config'] = request.config
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.jars):
            body['Jars'] = request.jars
        if not UtilClient.is_unset(request.max_executor):
            body['MaxExecutor'] = request.max_executor
        if not UtilClient.is_unset(request.min_executor):
            body['MinExecutor'] = request.min_executor
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.slot_num):
            body['SlotNum'] = request.slot_num
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='StartSparkSQLEngine',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.StartSparkSQLEngineResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.StartSparkSQLEngineResponse(),
                self.execute(params, req, runtime)
            )

    async def start_spark_sqlengine_with_options_async(
        self,
        request: adb_20211201_models.StartSparkSQLEngineRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.StartSparkSQLEngineResponse:
        """
        @summary Starts the Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: StartSparkSQLEngineRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: StartSparkSQLEngineResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.config):
            body['Config'] = request.config
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.jars):
            body['Jars'] = request.jars
        if not UtilClient.is_unset(request.max_executor):
            body['MaxExecutor'] = request.max_executor
        if not UtilClient.is_unset(request.min_executor):
            body['MinExecutor'] = request.min_executor
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.slot_num):
            body['SlotNum'] = request.slot_num
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='StartSparkSQLEngine',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.StartSparkSQLEngineResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.StartSparkSQLEngineResponse(),
                await self.execute_async(params, req, runtime)
            )

    def start_spark_sqlengine(
        self,
        request: adb_20211201_models.StartSparkSQLEngineRequest,
    ) -> adb_20211201_models.StartSparkSQLEngineResponse:
        """
        @summary Starts the Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: StartSparkSQLEngineRequest
        @return: StartSparkSQLEngineResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.start_spark_sqlengine_with_options(request, runtime)

    async def start_spark_sqlengine_async(
        self,
        request: adb_20211201_models.StartSparkSQLEngineRequest,
    ) -> adb_20211201_models.StartSparkSQLEngineResponse:
        """
        @summary Starts the Spark SQL engine.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: StartSparkSQLEngineRequest
        @return: StartSparkSQLEngineResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.start_spark_sqlengine_with_options_async(request, runtime)

    def submit_result_export_job_with_options(
        self,
        request: adb_20211201_models.SubmitResultExportJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.SubmitResultExportJobResponse:
        """
        @summary Submits an SQL query and exports a result set.
        
        @param request: SubmitResultExportJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: SubmitResultExportJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            body['Engine'] = request.engine
        if not UtilClient.is_unset(request.export_type):
            body['ExportType'] = request.export_type
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            body['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.sql):
            body['SQL'] = request.sql
        if not UtilClient.is_unset(request.schema):
            body['Schema'] = request.schema
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='SubmitResultExportJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.SubmitResultExportJobResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.SubmitResultExportJobResponse(),
                self.execute(params, req, runtime)
            )

    async def submit_result_export_job_with_options_async(
        self,
        request: adb_20211201_models.SubmitResultExportJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.SubmitResultExportJobResponse:
        """
        @summary Submits an SQL query and exports a result set.
        
        @param request: SubmitResultExportJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: SubmitResultExportJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.engine):
            body['Engine'] = request.engine
        if not UtilClient.is_unset(request.export_type):
            body['ExportType'] = request.export_type
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        if not UtilClient.is_unset(request.resource_group):
            body['ResourceGroup'] = request.resource_group
        if not UtilClient.is_unset(request.sql):
            body['SQL'] = request.sql
        if not UtilClient.is_unset(request.schema):
            body['Schema'] = request.schema
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='SubmitResultExportJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.SubmitResultExportJobResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.SubmitResultExportJobResponse(),
                await self.execute_async(params, req, runtime)
            )

    def submit_result_export_job(
        self,
        request: adb_20211201_models.SubmitResultExportJobRequest,
    ) -> adb_20211201_models.SubmitResultExportJobResponse:
        """
        @summary Submits an SQL query and exports a result set.
        
        @param request: SubmitResultExportJobRequest
        @return: SubmitResultExportJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.submit_result_export_job_with_options(request, runtime)

    async def submit_result_export_job_async(
        self,
        request: adb_20211201_models.SubmitResultExportJobRequest,
    ) -> adb_20211201_models.SubmitResultExportJobResponse:
        """
        @summary Submits an SQL query and exports a result set.
        
        @param request: SubmitResultExportJobRequest
        @return: SubmitResultExportJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.submit_result_export_job_with_options_async(request, runtime)

    def submit_spark_app_with_options(
        self,
        request: adb_20211201_models.SubmitSparkAppRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.SubmitSparkAppResponse:
        """
        @summary Submits a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SubmitSparkAppRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: SubmitSparkAppResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.agent_source):
            body['AgentSource'] = request.agent_source
        if not UtilClient.is_unset(request.agent_version):
            body['AgentVersion'] = request.agent_version
        if not UtilClient.is_unset(request.app_name):
            body['AppName'] = request.app_name
        if not UtilClient.is_unset(request.app_type):
            body['AppType'] = request.app_type
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.data):
            body['Data'] = request.data
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.template_file_id):
            body['TemplateFileId'] = request.template_file_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='SubmitSparkApp',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.SubmitSparkAppResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.SubmitSparkAppResponse(),
                self.execute(params, req, runtime)
            )

    async def submit_spark_app_with_options_async(
        self,
        request: adb_20211201_models.SubmitSparkAppRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.SubmitSparkAppResponse:
        """
        @summary Submits a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SubmitSparkAppRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: SubmitSparkAppResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.agent_source):
            body['AgentSource'] = request.agent_source
        if not UtilClient.is_unset(request.agent_version):
            body['AgentVersion'] = request.agent_version
        if not UtilClient.is_unset(request.app_name):
            body['AppName'] = request.app_name
        if not UtilClient.is_unset(request.app_type):
            body['AppType'] = request.app_type
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.data):
            body['Data'] = request.data
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        if not UtilClient.is_unset(request.template_file_id):
            body['TemplateFileId'] = request.template_file_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='SubmitSparkApp',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.SubmitSparkAppResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.SubmitSparkAppResponse(),
                await self.execute_async(params, req, runtime)
            )

    def submit_spark_app(
        self,
        request: adb_20211201_models.SubmitSparkAppRequest,
    ) -> adb_20211201_models.SubmitSparkAppResponse:
        """
        @summary Submits a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SubmitSparkAppRequest
        @return: SubmitSparkAppResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.submit_spark_app_with_options(request, runtime)

    async def submit_spark_app_async(
        self,
        request: adb_20211201_models.SubmitSparkAppRequest,
    ) -> adb_20211201_models.SubmitSparkAppResponse:
        """
        @summary Submits a Spark application.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SubmitSparkAppRequest
        @return: SubmitSparkAppResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.submit_spark_app_with_options_async(request, runtime)

    def submit_spark_log_analyze_task_with_options(
        self,
        request: adb_20211201_models.SubmitSparkLogAnalyzeTaskRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.SubmitSparkLogAnalyzeTaskResponse:
        """
        @summary Submits a Spark log analysis task and queries the analysis results.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SubmitSparkLogAnalyzeTaskRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: SubmitSparkLogAnalyzeTaskResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='SubmitSparkLogAnalyzeTask',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.SubmitSparkLogAnalyzeTaskResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.SubmitSparkLogAnalyzeTaskResponse(),
                self.execute(params, req, runtime)
            )

    async def submit_spark_log_analyze_task_with_options_async(
        self,
        request: adb_20211201_models.SubmitSparkLogAnalyzeTaskRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.SubmitSparkLogAnalyzeTaskResponse:
        """
        @summary Submits a Spark log analysis task and queries the analysis results.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SubmitSparkLogAnalyzeTaskRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: SubmitSparkLogAnalyzeTaskResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.app_id):
            body['AppId'] = request.app_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='SubmitSparkLogAnalyzeTask',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.SubmitSparkLogAnalyzeTaskResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.SubmitSparkLogAnalyzeTaskResponse(),
                await self.execute_async(params, req, runtime)
            )

    def submit_spark_log_analyze_task(
        self,
        request: adb_20211201_models.SubmitSparkLogAnalyzeTaskRequest,
    ) -> adb_20211201_models.SubmitSparkLogAnalyzeTaskResponse:
        """
        @summary Submits a Spark log analysis task and queries the analysis results.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SubmitSparkLogAnalyzeTaskRequest
        @return: SubmitSparkLogAnalyzeTaskResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.submit_spark_log_analyze_task_with_options(request, runtime)

    async def submit_spark_log_analyze_task_async(
        self,
        request: adb_20211201_models.SubmitSparkLogAnalyzeTaskRequest,
    ) -> adb_20211201_models.SubmitSparkLogAnalyzeTaskResponse:
        """
        @summary Submits a Spark log analysis task and queries the analysis results.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: SubmitSparkLogAnalyzeTaskRequest
        @return: SubmitSparkLogAnalyzeTaskResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.submit_spark_log_analyze_task_with_options_async(request, runtime)

    def suspend_aps_job_with_options(
        self,
        request: adb_20211201_models.SuspendApsJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.SuspendApsJobResponse:
        """
        @summary Suspends an AnalyticDB Pipeline Service (APS) job.
        
        @param request: SuspendApsJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: SuspendApsJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_id):
            body['ApsJobId'] = request.aps_job_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='SuspendApsJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.SuspendApsJobResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.SuspendApsJobResponse(),
                self.execute(params, req, runtime)
            )

    async def suspend_aps_job_with_options_async(
        self,
        request: adb_20211201_models.SuspendApsJobRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.SuspendApsJobResponse:
        """
        @summary Suspends an AnalyticDB Pipeline Service (APS) job.
        
        @param request: SuspendApsJobRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: SuspendApsJobResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.aps_job_id):
            body['ApsJobId'] = request.aps_job_id
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='SuspendApsJob',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.SuspendApsJobResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.SuspendApsJobResponse(),
                await self.execute_async(params, req, runtime)
            )

    def suspend_aps_job(
        self,
        request: adb_20211201_models.SuspendApsJobRequest,
    ) -> adb_20211201_models.SuspendApsJobResponse:
        """
        @summary Suspends an AnalyticDB Pipeline Service (APS) job.
        
        @param request: SuspendApsJobRequest
        @return: SuspendApsJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.suspend_aps_job_with_options(request, runtime)

    async def suspend_aps_job_async(
        self,
        request: adb_20211201_models.SuspendApsJobRequest,
    ) -> adb_20211201_models.SuspendApsJobResponse:
        """
        @summary Suspends an AnalyticDB Pipeline Service (APS) job.
        
        @param request: SuspendApsJobRequest
        @return: SuspendApsJobResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.suspend_aps_job_with_options_async(request, runtime)

    def unbind_account_with_options(
        self,
        request: adb_20211201_models.UnbindAccountRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.UnbindAccountResponse:
        """
        @summary Disassociates a standard account of an AnalyticDB for MySQL cluster from a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: UnbindAccountRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: UnbindAccountResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='UnbindAccount',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.UnbindAccountResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.UnbindAccountResponse(),
                self.execute(params, req, runtime)
            )

    async def unbind_account_with_options_async(
        self,
        request: adb_20211201_models.UnbindAccountRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.UnbindAccountResponse:
        """
        @summary Disassociates a standard account of an AnalyticDB for MySQL cluster from a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: UnbindAccountRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: UnbindAccountResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.account_name):
            query['AccountName'] = request.account_name
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='UnbindAccount',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.UnbindAccountResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.UnbindAccountResponse(),
                await self.execute_async(params, req, runtime)
            )

    def unbind_account(
        self,
        request: adb_20211201_models.UnbindAccountRequest,
    ) -> adb_20211201_models.UnbindAccountResponse:
        """
        @summary Disassociates a standard account of an AnalyticDB for MySQL cluster from a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: UnbindAccountRequest
        @return: UnbindAccountResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.unbind_account_with_options(request, runtime)

    async def unbind_account_async(
        self,
        request: adb_20211201_models.UnbindAccountRequest,
    ) -> adb_20211201_models.UnbindAccountResponse:
        """
        @summary Disassociates a standard account of an AnalyticDB for MySQL cluster from a Resource Access Management (RAM) user.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: UnbindAccountRequest
        @return: UnbindAccountResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.unbind_account_with_options_async(request, runtime)

    def unbind_dbresource_group_with_user_with_options(
        self,
        request: adb_20211201_models.UnbindDBResourceGroupWithUserRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.UnbindDBResourceGroupWithUserResponse:
        """
        @summary Disassociates resource groups from database accounts for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: UnbindDBResourceGroupWithUserRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: UnbindDBResourceGroupWithUserResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        if not UtilClient.is_unset(request.group_user):
            query['GroupUser'] = request.group_user
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='UnbindDBResourceGroupWithUser',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.UnbindDBResourceGroupWithUserResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.UnbindDBResourceGroupWithUserResponse(),
                self.execute(params, req, runtime)
            )

    async def unbind_dbresource_group_with_user_with_options_async(
        self,
        request: adb_20211201_models.UnbindDBResourceGroupWithUserRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.UnbindDBResourceGroupWithUserResponse:
        """
        @summary Disassociates resource groups from database accounts for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: UnbindDBResourceGroupWithUserRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: UnbindDBResourceGroupWithUserResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.group_name):
            query['GroupName'] = request.group_name
        if not UtilClient.is_unset(request.group_user):
            query['GroupUser'] = request.group_user
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='UnbindDBResourceGroupWithUser',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.UnbindDBResourceGroupWithUserResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.UnbindDBResourceGroupWithUserResponse(),
                await self.execute_async(params, req, runtime)
            )

    def unbind_dbresource_group_with_user(
        self,
        request: adb_20211201_models.UnbindDBResourceGroupWithUserRequest,
    ) -> adb_20211201_models.UnbindDBResourceGroupWithUserResponse:
        """
        @summary Disassociates resource groups from database accounts for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: UnbindDBResourceGroupWithUserRequest
        @return: UnbindDBResourceGroupWithUserResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.unbind_dbresource_group_with_user_with_options(request, runtime)

    async def unbind_dbresource_group_with_user_async(
        self,
        request: adb_20211201_models.UnbindDBResourceGroupWithUserRequest,
    ) -> adb_20211201_models.UnbindDBResourceGroupWithUserResponse:
        """
        @summary Disassociates resource groups from database accounts for an AnalyticDB for MySQL cluster.
        
        @description For information about the endpoints of AnalyticDB for MySQL, see [Endpoints](https://help.aliyun.com/document_detail/612373.html).
        
        @param request: UnbindDBResourceGroupWithUserRequest
        @return: UnbindDBResourceGroupWithUserResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.unbind_dbresource_group_with_user_with_options_async(request, runtime)

    def update_lake_storage_with_options(
        self,
        tmp_req: adb_20211201_models.UpdateLakeStorageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.UpdateLakeStorageResponse:
        """
        @summary Updates a lake storage.
        
        @param tmp_req: UpdateLakeStorageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: UpdateLakeStorageResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.UpdateLakeStorageShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.permissions):
            request.permissions_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.permissions, 'Permissions', 'json')
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.description):
            body['Description'] = request.description
        if not UtilClient.is_unset(request.lake_storage_id):
            body['LakeStorageId'] = request.lake_storage_id
        if not UtilClient.is_unset(request.permissions_shrink):
            body['Permissions'] = request.permissions_shrink
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='UpdateLakeStorage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.UpdateLakeStorageResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.UpdateLakeStorageResponse(),
                self.execute(params, req, runtime)
            )

    async def update_lake_storage_with_options_async(
        self,
        tmp_req: adb_20211201_models.UpdateLakeStorageRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.UpdateLakeStorageResponse:
        """
        @summary Updates a lake storage.
        
        @param tmp_req: UpdateLakeStorageRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: UpdateLakeStorageResponse
        """
        UtilClient.validate_model(tmp_req)
        request = adb_20211201_models.UpdateLakeStorageShrinkRequest()
        OpenApiUtilClient.convert(tmp_req, request)
        if not UtilClient.is_unset(tmp_req.permissions):
            request.permissions_shrink = OpenApiUtilClient.array_to_string_with_specified_style(tmp_req.permissions, 'Permissions', 'json')
        body = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.description):
            body['Description'] = request.description
        if not UtilClient.is_unset(request.lake_storage_id):
            body['LakeStorageId'] = request.lake_storage_id
        if not UtilClient.is_unset(request.permissions_shrink):
            body['Permissions'] = request.permissions_shrink
        if not UtilClient.is_unset(request.region_id):
            body['RegionId'] = request.region_id
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='UpdateLakeStorage',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.UpdateLakeStorageResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.UpdateLakeStorageResponse(),
                await self.execute_async(params, req, runtime)
            )

    def update_lake_storage(
        self,
        request: adb_20211201_models.UpdateLakeStorageRequest,
    ) -> adb_20211201_models.UpdateLakeStorageResponse:
        """
        @summary Updates a lake storage.
        
        @param request: UpdateLakeStorageRequest
        @return: UpdateLakeStorageResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.update_lake_storage_with_options(request, runtime)

    async def update_lake_storage_async(
        self,
        request: adb_20211201_models.UpdateLakeStorageRequest,
    ) -> adb_20211201_models.UpdateLakeStorageResponse:
        """
        @summary Updates a lake storage.
        
        @param request: UpdateLakeStorageRequest
        @return: UpdateLakeStorageResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.update_lake_storage_with_options_async(request, runtime)

    def update_spark_template_file_with_options(
        self,
        request: adb_20211201_models.UpdateSparkTemplateFileRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.UpdateSparkTemplateFileResponse:
        """
        @summary Updates a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: UpdateSparkTemplateFileRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: UpdateSparkTemplateFileResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.content):
            body['Content'] = request.content
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.id):
            body['Id'] = request.id
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='UpdateSparkTemplateFile',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.UpdateSparkTemplateFileResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.UpdateSparkTemplateFileResponse(),
                self.execute(params, req, runtime)
            )

    async def update_spark_template_file_with_options_async(
        self,
        request: adb_20211201_models.UpdateSparkTemplateFileRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.UpdateSparkTemplateFileResponse:
        """
        @summary Updates a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: UpdateSparkTemplateFileRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: UpdateSparkTemplateFileResponse
        """
        UtilClient.validate_model(request)
        body = {}
        if not UtilClient.is_unset(request.content):
            body['Content'] = request.content
        if not UtilClient.is_unset(request.dbcluster_id):
            body['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.id):
            body['Id'] = request.id
        if not UtilClient.is_unset(request.resource_group_name):
            body['ResourceGroupName'] = request.resource_group_name
        req = open_api_models.OpenApiRequest(
            body=OpenApiUtilClient.parse_to_map(body)
        )
        params = open_api_models.Params(
            action='UpdateSparkTemplateFile',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.UpdateSparkTemplateFileResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.UpdateSparkTemplateFileResponse(),
                await self.execute_async(params, req, runtime)
            )

    def update_spark_template_file(
        self,
        request: adb_20211201_models.UpdateSparkTemplateFileRequest,
    ) -> adb_20211201_models.UpdateSparkTemplateFileResponse:
        """
        @summary Updates a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: UpdateSparkTemplateFileRequest
        @return: UpdateSparkTemplateFileResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.update_spark_template_file_with_options(request, runtime)

    async def update_spark_template_file_async(
        self,
        request: adb_20211201_models.UpdateSparkTemplateFileRequest,
    ) -> adb_20211201_models.UpdateSparkTemplateFileResponse:
        """
        @summary Updates a Spark application template.
        
        @description    Regional public endpoint: `adb.<region-id>.aliyuncs.com`. Example: `adb.cn-hangzhou.aliyuncs.com`.
        Regional Virtual Private Cloud (VPC) endpoint: `adb-vpc.<region-id>.aliyuncs.com`. Example: `adb-vpc.cn-hangzhou.aliyuncs.com`.
        >  If HTTP status code 409 is returned when you call this operation in the China (Qingdao), China (Shenzhen), China (Guangzhou), or China (Hong Kong) region, contact technical support.
        
        @param request: UpdateSparkTemplateFileRequest
        @return: UpdateSparkTemplateFileResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.update_spark_template_file_with_options_async(request, runtime)

    def upgrade_kernel_version_with_options(
        self,
        request: adb_20211201_models.UpgradeKernelVersionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.UpgradeKernelVersionResponse:
        """
        @summary Updates the minor version of an AnalyticDB for MySQL cluster.
        
        @param request: UpgradeKernelVersionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: UpgradeKernelVersionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.dbversion):
            query['DBVersion'] = request.dbversion
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.switch_mode):
            query['SwitchMode'] = request.switch_mode
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='UpgradeKernelVersion',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.UpgradeKernelVersionResponse(),
                self.call_api(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.UpgradeKernelVersionResponse(),
                self.execute(params, req, runtime)
            )

    async def upgrade_kernel_version_with_options_async(
        self,
        request: adb_20211201_models.UpgradeKernelVersionRequest,
        runtime: util_models.RuntimeOptions,
    ) -> adb_20211201_models.UpgradeKernelVersionResponse:
        """
        @summary Updates the minor version of an AnalyticDB for MySQL cluster.
        
        @param request: UpgradeKernelVersionRequest
        @param runtime: runtime options for this request RuntimeOptions
        @return: UpgradeKernelVersionResponse
        """
        UtilClient.validate_model(request)
        query = {}
        if not UtilClient.is_unset(request.dbcluster_id):
            query['DBClusterId'] = request.dbcluster_id
        if not UtilClient.is_unset(request.dbversion):
            query['DBVersion'] = request.dbversion
        if not UtilClient.is_unset(request.owner_account):
            query['OwnerAccount'] = request.owner_account
        if not UtilClient.is_unset(request.owner_id):
            query['OwnerId'] = request.owner_id
        if not UtilClient.is_unset(request.resource_owner_account):
            query['ResourceOwnerAccount'] = request.resource_owner_account
        if not UtilClient.is_unset(request.resource_owner_id):
            query['ResourceOwnerId'] = request.resource_owner_id
        if not UtilClient.is_unset(request.switch_mode):
            query['SwitchMode'] = request.switch_mode
        req = open_api_models.OpenApiRequest(
            query=OpenApiUtilClient.query(query)
        )
        params = open_api_models.Params(
            action='UpgradeKernelVersion',
            version='2021-12-01',
            protocol='HTTPS',
            pathname='/',
            method='POST',
            auth_type='AK',
            style='RPC',
            req_body_type='formData',
            body_type='json'
        )
        if UtilClient.is_unset(self._signature_version) or not UtilClient.equal_string(self._signature_version, 'v4'):
            return TeaCore.from_map(
                adb_20211201_models.UpgradeKernelVersionResponse(),
                await self.call_api_async(params, req, runtime)
            )
        else:
            return TeaCore.from_map(
                adb_20211201_models.UpgradeKernelVersionResponse(),
                await self.execute_async(params, req, runtime)
            )

    def upgrade_kernel_version(
        self,
        request: adb_20211201_models.UpgradeKernelVersionRequest,
    ) -> adb_20211201_models.UpgradeKernelVersionResponse:
        """
        @summary Updates the minor version of an AnalyticDB for MySQL cluster.
        
        @param request: UpgradeKernelVersionRequest
        @return: UpgradeKernelVersionResponse
        """
        runtime = util_models.RuntimeOptions()
        return self.upgrade_kernel_version_with_options(request, runtime)

    async def upgrade_kernel_version_async(
        self,
        request: adb_20211201_models.UpgradeKernelVersionRequest,
    ) -> adb_20211201_models.UpgradeKernelVersionResponse:
        """
        @summary Updates the minor version of an AnalyticDB for MySQL cluster.
        
        @param request: UpgradeKernelVersionRequest
        @return: UpgradeKernelVersionResponse
        """
        runtime = util_models.RuntimeOptions()
        return await self.upgrade_kernel_version_with_options_async(request, runtime)
